C=======================================================================
      MODULE DRIVER
C=======================================================================
C --- MODULE TO HOLD VARIABLES FOR DRIVER
C     FOR LF95 COMPILING, THIS MUST RESIDE AT THE BEGINNING OF THE MAIN
C     PROGRAM
C     FOR LF90 COMPILING, THIS CAN RESIDE AT THE BEGINNING OF THE MAIN
C     PROGRAM, OR CAN BE COMPILED AS A SEPARATE ROUTINE

      IMPLICIT NONE
      INTEGER IOUTP,NLAY,NROW,NCOL,NUMERR,NPER,ITMUNI,LENUNI,ISETCNT
      INTEGER WMROW,WMCOL,WMROWOLD,WMCOLOLD,IWTMAT,IAROW
      INTEGER NOBS,NPRED,NOMIT
      INTEGER LAYCBD(200),LBOTM(200)
      PARAMETER (ISETCNT=20)
      REAL, ALLOCATABLE :: XWTQ(:,:),XWTQS(:,:),HWT(:),WT(:)
      INTEGER, ALLOCATABLE :: IPPTR(:)
      CHARACTER*3 PRE_PREF,OBS_PREF,PAR_PREF
      CHARACTER*300 MF2KCOM,CLINE
      CHARACTER*500 ERRMSG
      CHARACTER*200 BASENAM,OUTPATH
      CHARACTER*4 OBSSUF(6),SENSUF(4),PESSUF(3)
      CHARACTER*5 PRESUF(3),SUMSUF(6)

      DATA OBSSUF/'._os','._ww','._ws','._r ','._w ','._nm'/
      DATA SENSUF/'._sc','._sd','._s1','._su'/
      DATA PESSUF/'._ss','._pa','._b '/
      DATA PRESUF/'._spp','._spr','._sps'/                              !MODPREDICT PREDICTION SET SUMMARY STATISTICS
      DATA SUMSUF/'._obw','._obo','._obr','._prw','._pro ','._prr'/     !MODPREDICT OBS/PRIOR/PRED SET SUMMARY TABLES

      END MODULE DRIVER

C=======================================================================
C=======================================================================
      PROGRAM MODPREDICT
C=======================================================================
C=======================================================================

C==== PROGRAMMING THOUGHTS: SEPT 26, 2003 ==============================
C
C     - ADD A CHECK THAT THE EXECUTABLE FOR MODFLOW EXISTS
c     - CODE IN THE SUBROUTINES FOR CHECKING AND PREPARING THE V-C MATRICES
C        IN THE ADV AND HEAD-DEPENDENT OBSERVATION FILES COULD BE REPLACED
C        BY A CALL TO A GENERAL SUBROUTINE TO ACCOMPLISH THE SAME - THEN
C        'OMIT' FOR   CORRELATED PRIOR COULD BE INCLUDED AND CALL THE ROUTINE
C     - DOES NOT CURRENTLY PERFORM CHECK THAT ALL CORRELATED PRIOR ARE
C        LISTED AS MEMBERS OF THE SAME SET: THIS VERSION DOES *NOT* WORK WITH
C        CORRELATED PRIOR
C
C=======================================================================

C=====DECLARE THE DRIVER MODULE

      USE DRIVER
      IMPLICIT NONE

C -- OBSERVATION VARIABLES

      INTEGER ISCALS,NBLNK,NQT1,IQ1,NT,NC,NTT2,NPTH,KTDIM,IWTQD,NQC,
     +        NQCMAX,NQ,NQMAX,NQT,NQTMAX,NHOBLINES,INAMES,IFAIL,IPRN,
     +        MOBSAR,NHAR,MAXM,MOBS,NH,NHTP,NDMHP,NADVP,IOWTQ
C      NADV,
      INTEGER, ALLOCATABLE :: IPLOTOP(:),IAPLOT(:),IPLOTD(:),ISTATIST(:)
      REAL, ALLOCATABLE :: STATIST(:)
      REAL, ALLOCATABLE :: H(:),HOBS(:),UWH(:)
      REAL, ALLOCATABLE :: UWHOBS(:),RES(:),UWRES(:)
      CHARACTER*12,ALLOCATABLE :: OBSNAME(:),OBSNME(:),OBSNAMED(:)
      CHARACTER*12,ALLOCATABLE :: PREDNME(:),NAMES(:),OBSTYPE(:)
      CHARACTER*1,ALLOCATABLE :: XOPR(:)
      CHARACTER*7 NO_FILE

C -- SEN VARIABLES

      INTEGER ISENSU,ISENPU,IOB_SENOUT,IPR_SENOUT,NPLIST,NPE,ISENALL,
     +        MXSEN,NDMH,NHT,IUHEAD,NPDIM
      INTEGER, ALLOCATABLE :: ISENS(:),LN(:)
      REAL, ALLOCATABLE :: B(:),BL(:),BU(:),BSCAL(:),PAROPT(:)
      DOUBLE PRECISION, ALLOCATABLE :: S_SU(:,:)
      CHARACTER*10, ALLOCATABLE :: PARNAM(:),PARNAMTEMP(:)
      CHARACTER*100 PR_SENOUT,OB_SENOUT,PES_SENOUT,PR_SENLINE,
     +              OB_SENLINE,PES_SENLINE
      CHARACTER*200 SENFILEOPT
      CHARACTER*24 AITYPE
      CHARACTER*3 AIU

C -- PES VARIABLES

      INTEGER NPNG,IPR,MPR,NPRIOR,IPRCOV,IPRINT,LPRINT,MAXITER,
     +        NPESLINES,IPRAR,MPRAR
      REAL MAXCHANGE,TOL,SOSC,RR,SUMSQ,PVAL
      CHARACTER*200 PESNAM
      CHARACTER*200, ALLOCATABLE :: PESTEXT(:)
      CHARACTER*10, ALLOCATABLE :: EQNAM(:),NIPRNAM(:)
      REAL, ALLOCATABLE :: PRM(:,:),WP(:)

C -- SET FILE VARIABLES

      INTEGER IUS,NSETS,IOSTAR,NSETDIM
      INTEGER, ALLOCATABLE :: ISETTYP(:),ISETPRN(:),ISENSCAL(:)
      INTEGER, ALLOCATABLE :: ISETNUM(:),ISYMBOL(:),ISETPLT(:,:)
      REAL, ALLOCATABLE :: VMULT(:), SUMSTAT(:,:)
      CHARACTER*12, ALLOCATABLE :: SETNAM(:)

C -- MF2K VARIABLES

      INTEGER INUNIT,NIUNIT,INBAS,IOUTG,IOUTL,IOUT,IGLOBUN,ILISTUN,
     +        IMOUTS,IFLEN
      PARAMETER (NIUNIT=100)
      INTEGER IUNIT(NIUNIT),MUNIT(NIUNIT)
      CHARACTER*40 VERSION
      PARAMETER (VERSION='MODPREDICT VERSION 1')
      CHARACTER*4   CUNIT(NIUNIT)
      CHARACTER*100 AGLOBNAM,ALISTNAM,BASNAM,AFNAM(NIUNIT),
     +              MFNAM(NIUNIT),FFNAM(3,NIUNIT)
      CHARACTER*200 MFOUTFILE(NIUNIT),OBSNAM,PREDNAM,FNAME,FN

C==== MOD-PREDICT VARIABLES

      INTEGER NOBPAC,IPRED,IOBS,IOMIT,IGLOLST,IERR,
     +        NONB_LEN,N,ISTOP,ISTART,IUOBS, RUNTYPE,IPRD,LENVER,INDENT,
     +        ISEN,ISENFM,IPRINTS,I,LLOC,ITYP2,ITYP1,IU,INAM2,INAM1,ISS,
     +        IOP,ND,IMPN,IGETUNIT,J,IWTDIM,IHWT,IDRY,NP,IP
C      NDMHAR,
      PARAMETER (NOBPAC=10)
      INTEGER OBPAC(NOBPAC),IREWND(NIUNIT)
      REAL PSCAL
      REAL, ALLOCATABLE :: SPS(:,:),SPR(:,:),SPP(:,:)
      DOUBLE PRECISION, ALLOCATABLE :: PCSS(:,:)
      CHARACTER*100 MHOBFILE,MOBFILE,SPACES,PLSTFILE,MODPREDNAMFILE,
     +              MODNAMFILE
      CHARACTER*200 OUTNAM,OBSBASE,PREDBASE,PESBASE,COMLIN,
     +              RUNSTRING,APRED,ASETS
      CHARACTER*1 EMPTYCHAR

      DATA CUNIT/'BCF6', 'WEL ', 'DRN ', 'RIV ', 'EVT ', '    ', 'GHB ',
     +           'RCH ', 'SIP ', 'DE4 ', 'SOR ', 'OC  ', 'PCG ', 'LMG ',
     +           '    ', 'FHB ', 'RES ', 'STR ', 'IBS ', 'CHD ', 'HFB6',
     +           'LAK ', 'LPF ', 'DIS ', 'SEN ', 'PES ', 'OBS ', 'HOB ',
     +           'ADV2', 'COB ', 'ZONE', 'MULT', 'DROB', 'RVOB', 'GBOB',
     +           'STOB', 'HUF ', 'CHOB', 'ETS ', 'DRT ', 'DTOB', '    ',
     +           'HYD ', '    ', 'SFOB', 'GAGE', '    ', '    ', 'LMT6',
     +           '    ', 'SETS', 'PRD ', 48*'    '/

C=== INITIALIZING ======================================================

C == INTEGERS
C    GENERAL
      NUMERR  = 0
      INBAS   = 0
      IOUTP   = 98
      INUNIT  = 99
      IOUT    = 0
      IOUTG   = 0
      IERR    = 0
      IFAIL   = 0
      IUNIT   = 0
      OBPAC   = 0
      INAMES  = 0
      LAYCBD  = 1
      MUNIT   = 0
C    OBSPRED
C     IOBS  = COUNTER OF NO. OBS IN A PACKAGE:  NOBS = TOTALIZER
C     IPRED = COUNTER OF NO. PRED IN A PACKAGE: NPRED = TOTALIZER
C     IOMIT = COUNTER OF NO. OMIT IN A PACKAGE: NOMIT = TOTALIZER
      NOBS    = 0
      IOBS    = 0
      NPRED   = 0
      IPRED   = 0
      IOMIT   = 0
      NOMIT   = 0
      NC      = 0
      NT      = 0
      ND      = 0
      NH      = 0
      NHT     = 0
      IQ1     = 1
      NQT1    = 1
      NTT2    = 0
      NPTH    = 0
      NDMH    = 0
      NQ      = 0
      NQMAX   = 0
      NQC     = 0
      NQCMAX  = 0
      NQT     = 0
      NQTMAX  = 0
      NHTP    = 0
      NDMHP   = 0
      NADVP   = 0
C      NADV    = 0
      IWTQD   = 0
      KTDIM   = 1
      IDRY    = 0
C    PRIOR INFO
      IPR     = 0
      MPR     = 0
      NPRIOR  = 0
      NPESLINES = 1
C    PARAMETERS
      ISEN    = 0
      NPE     = 0
      NPDIM   = 1
      NPLIST  = 0
C    WEIGHT MATRICES
      WMROW   = 0
      WMCOL   = 0
      IWTMAT  = 0
      IAROW   = 0
      IOWTQ   = 0
      IHWT    = 0

C == CHARACTERS
      SPACES      = ' '
      EMPTYCHAR   = ' '
      COMLIN      = ' '
      OUTNAM      = EMPTYCHAR
      FFNAM       = EMPTYCHAR
      AFNAM       = EMPTYCHAR
      MFNAM       = EMPTYCHAR
      AGLOBNAM    = EMPTYCHAR
      ALISTNAM    = EMPTYCHAR
      OB_SENOUT   = EMPTYCHAR
      PR_SENOUT   = EMPTYCHAR
      OB_SENLINE  = EMPTYCHAR
      PR_SENLINE  = EMPTYCHAR
      PES_SENLINE = EMPTYCHAR
      MFOUTFILE   = EMPTYCHAR
      MODNAMFILE  = EMPTYCHAR
      NO_FILE     = 'NO_FILE'

C == OBS-PROCESS PACKAGES
      OBPAC(1) = 28      !HOB
      OBPAC(2) = 29      !ADV2
      OBPAC(3) = 30      !COB
      OBPAC(4) = 33      !DROB
      OBPAC(5) = 34      !RVOB
      OBPAC(6) = 35      !GBOB
      OBPAC(7) = 36      !STOB
      OBPAC(8) = 38      !CHOB
      OBPAC(9) = 41      !DTOB
      OBPAC(10)= 45      !SFOB

C=======================================================================
C===                   START OF MAIN PROGRAM                    ========
C=======================================================================

C == PREPARE HEADER FOR OUTPUT FILE AND WRITE TO SCREEN
      LENVER=NONB_LEN(VERSION,40)
      INDENT=40-(LENVER)/2
      WRITE(*,10)
10    FORMAT(//,1X,'== MF2K MOD-PREDICT PROGRAM, V1 ==',
     +        /,1X,'========================================',/)

C=== 100 BLOCK =========================================================
C=== READ THE MODPREDICT NAME FILE - THEN PRD, MF2K NAME FILE, SETS FILE

      PLSTFILE = 'MODPREDICT.OUT'
      OPEN(IOUTP,FILE=PLSTFILE,STATUS='REPLACE',IOSTAT=IERR)
      IF (IERR.NE.0) THEN
        WRITE(*,100) PLSTFILE
100     FORMAT(/,1X,'ERROR OPENING MOD-PREDICT OUTPUT FILE ',A)
        STOP
      END IF
      WRITE(IOUTP,101) SPACES(1:INDENT),VERSION(1:LENVER)
101   FORMAT(34X,'MODFLOW-2000',/,A,A)

C   OBTAIN NAME OF MOD-PREDICT NAME FILE
C   NOTE - GETARG CAN BE UNCOMMENTED FOR LF95 COMPILATION, BUT MUST
C   BE COMMENTED FOR LF90 COMPILATION. AN ALTERNATIVE IS GETCL

C      CALL GETARG(1,COMLIN)                                            !lf95
      CALL GETCL(COMLIN)                                                !lf90
      IF(COMLIN.NE.' ') THEN
        MODPREDNAMFILE = COMLIN
      ELSE
        WRITE (*,*) ' ENTER THE NAME OF THE MOD-PREDICT NAME FILE: '
        READ (*,'(A)') MODPREDNAMFILE
        LLOC=1
        CALL URWORD(MODPREDNAMFILE,LLOC,ISTART,ISTOP,0,N,RR,0,0)
        MODPREDNAMFILE = MODPREDNAMFILE(ISTART:ISTOP)
      ENDIF
      IF (MODPREDNAMFILE.EQ.EMPTYCHAR) THEN
        WRITE(*,102) MODPREDNAMFILE(1:NBLNK(MODPREDNAMFILE))
102     FORMAT('NO MOD-PREDICT FILE - STOPPING')
        CLOSE(IOUTP)
        STOP
      END IF

C   READ THE MOD-PREDICT NAME FILE, LISTING PRD AND SETS FILES AND ANY
C   SEQUENCE OF OBS-SEN-PES PROCESSES/PACKAGES. OBS-SEN-PES ARE LOADED
C   INTO AFNAM BY DEFAULT. ANY GWF PROCESSES ARE STORED IN MFNAM.

      MODPREDNAMFILE=ADJUSTL(MODPREDNAMFILE)
      IMPN = IGETUNIT(1,95)
      OPEN(IMPN,FILE=MODPREDNAMFILE(1:NBLNK(MODPREDNAMFILE)),
     +                                         STATUS='OLD',IOSTAT=IERR)
      IF (IERR.NE.0) THEN
        WRITE(*,103) MODPREDNAMFILE(1:NBLNK(MODPREDNAMFILE))
103     FORMAT(/,1X,'ERROR OPENING MODPREDICT NAME FILE ',A,' STOPPING')
        CLOSE(IOUTP)
        STOP
      END IF
      WRITE(IOUTP,104) MODPREDNAMFILE(1:NBLNK(MODPREDNAMFILE))
104   FORMAT(/,1X,'OPENING ',A)
      CALL SPRD1NAM2OPEN(IFAIL,IMPN,IUNIT,CUNIT,IREWND,NIUNIT,MFNAM,
     +                   AFNAM,APRED,ASETS,OBPAC,NOBPAC,MUNIT,IPRD)
      IF (IFAIL.NE.0) THEN
        WRITE(IOUTP,199)
        GOTO 9891
      ENDIF
      WRITE(IOUTP,105) MODPREDNAMFILE(1:NBLNK(MODPREDNAMFILE))
105   FORMAT(3X,'READ ',A,' - OK')

C   READ THE MOD-PREDICT "PRD" FILE

      CALL  SPRD1PRD1RD(IFAIL,APRED,IPRD,MODNAMFILE)
      IF (IFAIL.NE.0) THEN
        CLOSE(IOUTP)
        STOP
      ENDIF

C   READ MF2K NAME FILE - ALL ACTIVE PACKAGES ARE ARE LOADED INTO AFNAM
C   NOTE: ANY OBS-SEN-PES PROCESSES OR OBSERVATION PACKAGES THAT MIGHT
C          BE LISTED IN THE MODFLOW NAME FILE WILL BE IGNORED

      MODNAMFILE = ADJUSTL(MODNAMFILE)
      OPEN(INUNIT,FILE=MODNAMFILE(1:NBLNK(MODNAMFILE)),STATUS='OLD',
     +                                                      IOSTAT=IERR)
      IF (IERR.NE.0) THEN
        WRITE(*,106) MODNAMFILE(1:NBLNK(MODNAMFILE))
106     FORMAT(/,1X,'ERROR OPENING MODFLOW NAME FILE ',A,' - STOPPING')
        CLOSE(IOUTP)
        STOP
      END IF
      WRITE(IOUTP,107) MODNAMFILE(1:NBLNK(MODNAMFILE))
107   FORMAT(/,1X,'OPENING ',A)
      CALL SPRD1NAM1OPEN(IFAIL,INUNIT,IOUTG,IOUTL,IOUT,IUNIT,CUNIT,
     +                   IREWND,NIUNIT,INBAS,AFNAM,AGLOBNAM,
     +                   ALISTNAM,IGLOBUN,ILISTUN,IGLOLST,BASNAM,
     +                   MFOUTFILE,IMOUTS)
      IF (IFAIL.NE.0) THEN
        WRITE(IOUTP,199)
        GOTO 9891
      ENDIF
      WRITE(IOUTP,108) MODNAMFILE(1:NBLNK(MODNAMFILE))
108   FORMAT(3X,'READ ',A,' - OK')

C   AT THIS STAGE:
C     MFNAM AND MUNIT CONTAIN FILES FROM THE MODPREDICT NAME FILE THAT
C     WILL BE USED **ONLY** FOR PREDICTION-ONLY RUNS
C
C     AFNAM AND IUNIT NOW CONTAIN FILES FROM THE MODFLOW2000 NAME FILE
C     PLUS THE OBS-SEN-PES PROCESS AND OBSERVATION (OBSPRED) PACKAGE
C     FILES READ FROM THE MODPREDICT NAME FILE. THERE IS A CHANCE THAT A
C     UNIT NUMBER CONFLICT OCCURED - SO CHECK THE SAME UNIT NUMBER DOES
C     NOT OCCUR TWICE IN IUNIT: IF CONFLICT, STOP WITH ERROR MESSAGE.

      DO I=1,NIUNIT
        DO J=1,NIUNIT
          IF (I.NE.J) THEN
            IF ((IUNIT(I).EQ.IUNIT(J)).AND.(IUNIT(I).NE.0)) THEN
              WRITE(IOUTP,109) IUNIT(I)
109           FORMAT(//,1X,
     +                   'A UNIT-NUMBER CONFLICT HAS OCCURRED BETWEEN ',
     +                   'FILES SPECIFIED IN THE MODPREDICT NAME FILE ',
     +              /,1X,'AND FILES SPECIFIED IN THE MODFLOW2000 NAME ',
     +                   'FILE : UNIT# ',I5,' - STOPPING')
              CLOSE(IOUTP)
              STOP
            ENDIF
          ENDIF
        END DO
      END DO

C   DETERMINE TYPE OF RUN WE HAVE BASED ON CONTENTS OF IUNIT ARRAY

      RUNTYPE = 0
      IF (IUNIT(51).NE.0) THEN
        IF (IUNIT(27).NE.0) THEN
C         OBS NOT SEN NOT PES
          IUOBS = IUNIT(27)
          RUNTYPE = 1
          IF ((IUNIT(25).NE.0).AND.(IUNIT(26).EQ.0)) THEN
C           OBS AND SEN NOT PES
            RUNTYPE = 2
            ISEN = 1
          ELSE IF ((IUNIT(25).NE.0).AND.(IUNIT(26).NE.0)) THEN
C           OBS AND SEN AND PES
            RUNTYPE = 3
            ISEN = 1
          ELSE IF ((IUNIT(25).EQ.0).AND.(IUNIT(26).NE.0)) THEN
C           OBS NOT SEN AND PES
            WRITE(*,110) MODPREDNAMFILE(1:NBLNK(MODPREDNAMFILE))
            WRITE(IOUTP,110) MODPREDNAMFILE(1:NBLNK(MODPREDNAMFILE))
110         FORMAT(1X,'PES FILE CITED IN MOD-PREDICT NAME FILE ',A,
     +             1X,'BUT SEN FILE NOT CITED - STOPPING (MODPREDICT)')
            WRITE(IOUTP,199)
            CLOSE(IOUTP)
            GOTO 9891
          END IF
        ELSE
          WRITE(*,111) MODPREDNAMFILE(1:NBLNK(MODPREDNAMFILE))
          WRITE(IOUTP,111) MODPREDNAMFILE(1:NBLNK(MODPREDNAMFILE))
111       FORMAT(1X,'OBS FILE NOT CITED IN MOD-PREDICT NAME FILE ',A,
     +           1X,' - STOPPING (MODPREDICT)')
          WRITE(IOUTP,199)
          CLOSE(IOUTP)
          GOTO 9891
        END IF
      ELSE
        WRITE(*,112) MODPREDNAMFILE(1:NBLNK(MODPREDNAMFILE))
        WRITE(IOUTP,112) MODPREDNAMFILE(1:NBLNK(MODPREDNAMFILE))
112     FORMAT(1X,'SETS FILE NOT CITED IN MOD-PREDICT NAME FILE ',A,
     +           1X,' - STOPPING (MODPREDICT)')
        WRITE(IOUTP,199)
        CLOSE(IOUTP)
        GOTO 9891
      END IF

199   FORMAT(/,1X,'ERROR PROCESSING MOD-PREDICT INPUT FILES',
     +            ' - 100 BLOCK - STOPPING (MODPREDICT)')

C==== 200 BLOCK ========================================================
C==== OBS AND SETS (AT MINIMUM) ARE ACTIVE                      ========
C====   - READ MODFLOW FILES                                    ========
C====   - READ SETS FILE AND ALLOCATE SPACE                     ========

      WRITE(IOUTP,200) '  READ MODFLOW SIMULATION FILES  '
200   FORMAT(//,    '=====================',A,'======================')

      SELECT CASE (RUNTYPE)
        CASE (1)
          WRITE(IOUTP,201) RUNTYPE,' - OBS ONLY ACTIVATED'
          WRITE(IOUTP,202) AFNAM(27)(1:NBLNK(AFNAM(27)))
        CASE (2)
          WRITE(IOUTP,201) RUNTYPE,' - OBS AND SEN ACTIVATED'
          WRITE(IOUTP,202) AFNAM(27)(1:NBLNK(AFNAM(27)))
        CASE (3)
          WRITE(IOUTP,201) RUNTYPE,' - OBS, SEN, AND PES ACTIVATED'
          WRITE(IOUTP,202) AFNAM(27)(1:NBLNK(AFNAM(27)))
        CASE DEFAULT
          WRITE(*,203)
          WRITE(IOUTP,203)
          CLOSE(IOUTP)
          GOTO 9891
      END SELECT
201   FORMAT(/,1X,'SELECTED RUN TYPE ',I1,A)
202   FORMAT(/,1X,'READING OBS FILE ',A,' FOR OUTNAM AND ISCALS')
203   FORMAT(/,1X,'ERROR WITH RUNTYPE - STOPPING (MODPREDICT)')

C -- READ THE "OBS" FILE FOR OUTNAM AND ISCALS

      CALL SPRD1OBS1AL(IFAIL,ISCALS,ISEN,IUOBS,OUTNAM,AFNAM(27))
      IF (IFAIL.NE.0) THEN
          WRITE(IOUTP,299)
          GOTO 9891
      ENDIF
      BASENAM = OUTNAM

C -- SCAN THE "SETS" FILE: ALLOCATE SETS ARRAYS, THEN READ "SETS" FULLY

      WRITE(IOUTP,204) AFNAM(51)(1:NBLNK(AFNAM(51)))
204   FORMAT(/,1X,'READING SETS FILE ',A,' FOR NSETS')
      IUS = IUNIT(51)
      CALL SPRD1SETS1AL(IFAIL,IUS,NSETS)
      IF (IFAIL.NE.0) THEN
          WRITE(IOUTP,299)
          GOTO 9891
      ENDIF
      NSETDIM = NSETS

      ALLOCATE (ISETTYP(NSETS),ISETPRN(NSETS),ISENSCAL(NSETS),
     +     ISETPLT(NSETS,ISETCNT),VMULT(NSETS),SETNAM(NSETS),
     +     SUMSTAT(NSETS,20),ISYMBOL(NSETS),STAT=IERR)
      IF (IERR.NE.0) THEN
          GOTO 9870
      ENDIF

      CALL SPRD1SETS1RP(IFAIL,NSETS,ISETTYP,ISETPRN,ISENSCAL,
     +                      ISETPLT,VMULT,IUS,SETNAM,ISYMBOL)
      IF (IFAIL.NE.0) THEN
        WRITE(IOUTP,210)
        GOTO 9891
      ENDIF
210   FORMAT(/,1X,'ERROR PROCESSING SETS FILE',
     +            ' - 200 BLOCK - STOPPING (MODPREDICT)')

C -- IF SEN ACTIVE: READ TO ALLOCATE SEN ARRAYS THEN READ FILE FULLY

      IF ((RUNTYPE.EQ.2).OR.(RUNTYPE.EQ.3)) THEN
        WRITE(IOUTP,216) AFNAM(25)(1:NBLNK(AFNAM(25)))
216     FORMAT(/,1X,'READING SEN FILE ',A,' FOR ISENSU, ISENPU')
        CALL SPRD1SEN1AL(IFAIL,IUNIT,NIUNIT,NPLIST,ISENALL,IUHEAD,
     +                      MXSEN,IPRINTS,ISENSU,ISENPU,ISENFM)
        IF (IFAIL.NE.0) THEN
          WRITE(IOUTP,299)
          GOTO 9891
        ENDIF
      END IF
      NPDIM = 1
      IF (NPLIST.GT.0) THEN
          NPDIM = NPLIST
      ENDIF
      ALLOCATE(PARNAM(NPDIM),ISENS(NPDIM),LN(NPDIM),B(NPDIM),
     +         BL(NPDIM),BU(NPDIM),BSCAL(NPDIM),PAROPT(NPDIM),
     +         PARNAMTEMP(NPDIM),IPPTR(NPLIST),PCSS(NPDIM,NSETS),
     +         STAT=IERR)
      IF (IERR.NE.0) THEN
        GOTO 9870
      ENDIF
      B = 0.
      PAROPT = 0.

C -- READ SEN FILE AND DETERMINE NPE BASED ON ISENALL, ISENS

      IF ((RUNTYPE.EQ.2).OR.(RUNTYPE.EQ.3)) THEN
        CALL SPRD1SEN1RP(IFAIL,IUNIT,NIUNIT,NPLIST,ISENALL,
     +                      IUHEAD,MXSEN,IPRINTS,ISENSU,ISENPU,ISENFM,
     +                      PARNAM,ISENS,LN,B,BL,BU,BSCAL,NPE,NPDIM)
        IF (IFAIL.NE.0) THEN
          WRITE(IOUTP,299)
          GOTO 9891
        ENDIF

        WRITE(IOUTP,217) AFNAM(25)(1:NBLNK(AFNAM(25)))
217     FORMAT(3X,'SEN FILE ',A,' READ - OK')

        IF (ISENALL.EQ.0) THEN
          WRITE(IOUTP,222) AFNAM(25)(1:NBLNK(AFNAM(25))),NPE
222       FORMAT(3X,'SEN FILE ',A,' ISENALL = 0: ',/,3X,
     +          'ISENS INDICATES ',I3,' PARAMETERS')
        ELSE IF (ISENALL.GT.0) THEN
C         ISENS = 1 FOR ALL PARAMETERS
          WRITE(IOUTP,223) AFNAM(25)(1:NBLNK(AFNAM(25)))
223       FORMAT(/,3X,'SEN FILE ',A,' ISENALL > 0: ',/,3X,
     +          ' - SENSITIVITY FOR ALL LISTED PARAMETERS')
        ELSE IF (ISENALL.LT.0) THEN
C         DEACTIVATE PES - ISENS = 0 FOR ALL PARAMETERS
          WRITE(IOUTP,224) AFNAM(25)(1:NBLNK(AFNAM(25)))
224       FORMAT(/,3X,'SEN FILE ',A,' ISENALL < 0: ',/,3X,
     +          'RUNTYPE = 1 - OBSERVATIONS FOR CURRENT PARAMETER SET')
          FFNAM(1,26) = NO_FILE
          FFNAM(2,26) = NO_FILE
          RUNTYPE = 1
          NPE = 0
        END IF
        IF ((ISENSU.LT.0).OR.(ISENSU.EQ.0)) THEN
          WRITE (IOUTP,221)
        ELSE
C       CHECK THE DATA FILES FROM NAME FILE FOR THE OUTPUT NAME
          IOB_SENOUT = 0
          IPR_SENOUT = 0
          DO I = 1,IMOUTS
            LLOC=1
            CALL URWORD(MFOUTFILE(I),LLOC,ITYP1,ITYP2,1,N,RR,IOUTP,1)
            AITYPE = MFOUTFILE(I)(ITYP1:ITYP2)
            CALL URWORD(MFOUTFILE(I),LLOC,ISTART,ISTOP,2,IU,RR,IOUTP,1)
            WRITE(AIU,'(I3)') IU
            CALL URWORD(MFOUTFILE(I),LLOC,INAM1,INAM2,0,N,RR,IOUTP,1)
            IFLEN=INAM2-INAM1+1
            FNAME(1:IFLEN)=MFOUTFILE(I)(INAM1:INAM2)
            IF (IU.EQ.ISENSU) THEN
              IOB_SENOUT   = 1
              OB_SENOUT     = OBS_PREF//FNAME(1:IFLEN)
              PR_SENOUT     = PRE_PREF//FNAME(1:IFLEN)
              PES_SENOUT    = PAR_PREF//FNAME(1:IFLEN)
              WRITE(IOUTP,218) OB_SENOUT
              WRITE(IOUTP,219) PR_SENOUT
              OB_SENLINE   = TRIM(AITYPE)//' '//AIU//' '//OB_SENOUT
              PR_SENLINE   = TRIM(AITYPE)//' '//AIU//' '//PR_SENOUT
              PES_SENLINE   = TRIM(AITYPE)//' '//AIU//' '//PES_SENOUT
              MFOUTFILE(I) = ' '
            END IF
          END DO
          IF ((IOB_SENOUT.EQ.0).OR.(IPR_SENOUT.EQ.0)) THEN
            WRITE(IOUTP,220) ISENSU
            STOP
          ENDIF
218       FORMAT(3X,'OBSERVATION-ONLY GRID SENSITIVITIES OUTPUT TO ',A)
219       FORMAT(3X,'PREDICTION-ONLY GRID SENSITIVITIES OUTPUT TO ',A)
220       FORMAT(/,1X,'GRID SENSITIVITIES SPECIFIED TO BE SAVED ',/,
     +                'BUT NO OUTPUT FILE SPECIFIED - UNIT ',I4)
221       FORMAT(3X,'GRID SENSITIVITIES WILL NOT BE PRINTED')
        END IF
      END IF
      IF (IFAIL.NE.0) THEN
          WRITE(IOUTP,299)
          GOTO 9891
      ENDIF

C -- IF "PES" ACTIVE: READ FOR DIMENSIONS. READ LATER FOR PRIOR INFO.

      IF (RUNTYPE.EQ.3) THEN
          WRITE(IOUTP,250) AFNAM(26)(1:NBLNK(AFNAM(26)))
250       FORMAT(/,1X,'READING PES FILE ',A,' FOR MAX-ITER')
          CALL SPRD1PES1AL(IFAIL,AFNAM,IUNIT,NIUNIT,MAXITER,NPESLINES,
     +                      IPR,MPR,IPRAR,MPRAR)
          IF (IFAIL.NE.0) THEN
            WRITE(IOUTP,299)
            GOTO 9891
          ENDIF
          ALLOCATE(PESTEXT(NPESLINES),EQNAM(NPESLINES),
     +             NIPRNAM(NPESLINES),PRM(NPLIST+1,MPRAR),WP(MPRAR),
     +             STAT=IERR)
          PRM = 0.0
          IF (IERR.NE.0) THEN
            GOTO 9870
          ENDIF
      END IF
299   FORMAT(/,1X,'ERROR PROCESSING MODFLOW FILES - 200 BLOCK',
     +                                       ' - STOPPING (MODPREDICT)')

C==== 300 BLOCK ========================================================
C=== SCAN ALL ACTIVE OBS PACKAGES FOR DIMENSIONING              ========
C=== READ ALL OBS PACKAGES AND IDENTIFY OBS/PRED/PRIOR          ========
C=== PREPARE THE OBSERVATION/PREDICTION-SPECIFIC PACKAGES       ========

C -- START BY READING THE DISCRETIZATION FILE (PERTAINS ONLY TO ADV2)

      CALL SPRD1DIS1AL(IFAIL,IUNIT(24),AFNAM,NIUNIT)
      IF (IFAIL.NE.0) THEN
          WRITE(IOUTP,399)
          GOTO 9891
      ENDIF

C -- NOW READ THE ACTIVE OBSERVATION PACKAGES FOR DIMENSIONING

      WRITE(IOUTP,306)
306   FORMAT(/,1X,'READING ACTIVE OBSERVATION PACKAGES')
      IWTDIM=0

C   HOB PACKAGE FIRST

      IF(IUNIT(28).NE.0) THEN
          MHOBFILE = TRIM(AFNAM(28))
C         READ HOB PACKAGE FOR DIMENSIONING ONLY
          CALL SPRD1HOB1AL(IFAIL,MHOBFILE,IUNIT(28),NH,MOBS,MAXM,NHT,
     +                          MOBSAR,NHAR,ND,NHOBLINES)
          IF (IFAIL.NE.0) THEN
            WRITE(IOUTP,399)
            GOTO 9891
          ENDIF
      END IF

C   REMAINING _OB PACKAGES

      DO I = 2,NOBPAC
        IF(IUNIT(OBPAC(I)).NE.0) THEN
          MOBFILE = TRIM(AFNAM(OBPAC(I)))
C         COB PACKAGE NOT SUPPORTED
          IF (OBPAC(I).EQ.30) THEN
            WRITE(IOUTP,308) CUNIT(OBPAC(I))
308         FORMAT(A,' PACKAGE NOT PRESENTLY SUPPORTED - STOPPING',
     +               ' (MODPREDICT)')
            WRITE(IOUTP,399)
            IFAIL = 1
            GOTO 9891
          END IF
C         READ ADV PACKAGE FOR DIMENSIONING ONLY
          IF (OBPAC(I).EQ.29) THEN
           CALL SPRD1ADV2AL(NIUNIT,IUNIT,AFNAM,IFAIL,ND,NPTH,NTT2,KTDIM)
            IF (NPTH+(NTT2*KTDIM).GT.IWTQD) IWTQD=NPTH+(NTT2*KTDIM)
          ELSE
C         READ REMAINING PACKAGES FOR DIMENSIONING ONLY
            CALL SPRD1OB1AL(IFAIL,IUNIT(OBPAC(I)),MOBFILE,NQ,NQC,NQT,ND)
          END IF
          IF (IFAIL.NE.0) THEN
            WRITE(IOUTP,399)
            GOTO 9891
          ENDIF
          IF (NQ.GT.NQMAX)   NQMAX  = NQ
          IF (NQC.GT.NQCMAX) NQCMAX = NQC
          IF (NQT.GT.NQTMAX) NQTMAX = NQT
          IF (NQCMAX.GT.IWTQD) IWTQD=NQCMAX
          NDMH = NDMH + NQT
309     END IF
      END DO
      IWTDIM=IWTDIM+NHT+NDMH+NPTH+(NTT2*KTDIM)

C -- ALLOCATE ARRAYS PERTAINING TO OBSERVATIONS, WEIGHTS, ETC

      ALLOCATE(OBSNME(ND+IPR+MPR),PREDNME(ND),OBSNAME(ND+IPR+MPR),
     +    OBSNAMED(ND+IPR+MPR),OBSTYPE(ND+IPR+MPR),XOPR(ND+IPR+MPR),
     +    H(ND+IPR+MPR),HOBS(ND+IPR+MPR),UWH(ND+IPR+MPR),
     +    UWHOBS(ND+IPR+MPR),RES(ND+IPR+MPR),UWRES(ND+IPR+MPR),
     +    NAMES(ND+IPR+MPR),IPLOTOP(ND+IPR+MPR),IPLOTD(ND+IPR+MPR),
     +    IAPLOT(ND+IPR+MPR),ISETNUM(ND+IPR+MPR),STATIST(ND+IPR+MPR),
     +    XWTQ(ND,ND),XWTQS(ND,ND),HWT(ND),WT(ND),S_SU(NPDIM,ND),
     +    SPS(NPDIM,ND),SPR(NPDIM,ND),SPP(NPDIM,ND),
     +    ISTATIST(ND+IPR+MPR),STAT=IERR)
      IF (IERR.NE.0) THEN
        GOTO 9870
      ENDIF

C --INITIALIZE
C    MATRICES
      STATIST = 0.
      ISTATIST= 0
      WT      = 0.
      XWTQ    = 0.
      XWTQS   = 0.
      DO I = 1,ND
        WT = 1.
        DO J = 1,ND
          IF (I.EQ.J) THEN
              XWTQ(I,J) = 1.
          END IF
        END DO
      END DO
      OBSTYPE = ' '

C-- READ "OBS" PACKAGES FULLY AND PREPARE RUN FILES DEPENDING ON RUNTYPE

C    HOB PACKAGE FIRST - THIS IS OBPAC(1)

      IF(IUNIT(28).NE.0) THEN
        MHOBFILE = TRIM(AFNAM(28))
        WRITE(IOUTP,*) CUNIT(28)
        CALL SPRD1HOB1RP(IFAIL,IOBS,OBSNME,PREDNME,MHOBFILE,IUNIT(28),
     +      IPRED,NH,MOBS,MAXM,MPR,IPR,ND,NHAR,FFNAM,MOBSAR,
     +      AFNAM,NHT,NIUNIT,NHOBLINES,NAMES,INAMES,IAPLOT,VMULT,NSETS,
     +      ISETPLT,ISETTYP,IOMIT,ISYMBOL,IHWT,OBSTYPE,XOPR,STATIST,
     +      ISTATIST)
        IF (IFAIL.NE.0) THEN
          WRITE(IOUTP,399)
          GOTO 9891
        ENDIF
        WRITE(IOUTP,310) MHOBFILE(1:NBLNK(MHOBFILE))
310     FORMAT(3X,'READ ',A,' - OK')
        NHTP = IPRED
        NOBS = NOBS + IOBS
        NPRED = NPRED + IPRED
        NOMIT = NOMIT + IOMIT
C       NUMBER OF OBSERVATIONS AND PREDICTIONS
        WRITE(IOUTP,322) TRIM(AFNAM(28)),IOBS
        WRITE(IOUTP,323) TRIM(AFNAM(28)),IPRED
        WRITE(IOUTP,324) TRIM(AFNAM(28)),IOMIT
        IF ((IPRED.NE.0).AND.(IOBS.NE.0)) THEN
          WRITE(IOUTP,326) 'OBSERVATIONS',FFNAM(1,28)
          WRITE(IOUTP,326) 'PREDICTIONS ',FFNAM(2,28)
        ENDIF
      END IF

C    NOW THE REMAINING OBSERVATION PACKAGE FILES

      DO I = 2,NOBPAC
        IOBS = 0
        IPRED = 0
        IOMIT = 0
        IF(IUNIT(OBPAC(I)).NE.0) THEN
          WRITE(IOUTP,*) CUNIT(OBPAC(I))
          IF (OBPAC(I).EQ.30) THEN
C         COB PACKAGE NOT SUPPORTED
            WRITE(IOUTP,319) CUNIT(OBPAC(I))
319         FORMAT(A,' PACKAGE NOT PRESENTLY SUPPORTED - STOPPING',
     +               ' (MODPREDICT)')
            WRITE(IOUTP,399)
            IFAIL = 1
            GOTO 9891
          ELSEIF (OBPAC(I).EQ.29) THEN
C         ADV PACKAGE
            CALL SPRD1ADV2RP(NIUNIT,IUNIT,IPR,MPR,NQT,NHT,AFNAM,
     +                     FFNAM,IOBS,IPRED,IFAIL,ND,
     +                     OBSNME,NPTH,NTT2,KTDIM,IWTQD,NAMES,
     +                     INAMES,IAPLOT,VMULT,NSETS,ISETPLT,ISETTYP,
     +                     IOMIT,ISYMBOL,OBSTYPE,XOPR,STATIST,ISTATIST)
            NADVP = IPRED
          ELSE
C         REMAINING PACKAGES
            MOBFILE = TRIM(AFNAM(OBPAC(I)))
C           READ THE APPROPRIATE OBSERVATION PACKAGE FILE
            CALL SPRD1OB1RP(IFAIL,IUNIT(OBPAC(I)),IOBS,OBSNME,
     +         MOBFILE,I,NQCMAX,NQMAX,NQTMAX,NQ,NQC,NQT,IPRED,
     +         IPRN,ND,MPR,IPR,OBPAC,NOBPAC,NIUNIT,AFNAM,FFNAM,NQT1,NHT,
     +         NT,IQ1,NC,IWTQD,NAMES,INAMES,IAPLOT,VMULT,NSETS,ISETPLT,
     +         ISETTYP,IOMIT,ISYMBOL,NDMH,OBSTYPE,XOPR,STATIST,ISTATIST)
            IF (IWTMAT.GT.0) THEN
              IOWTQ = 1
            ENDIF
            IF (IFAIL.NE.0) THEN
              WRITE(IOUTP,399)
              GOTO 9891
            ENDIF
        END IF
        WRITE(IOUTP,320) TRIM(AFNAM(OBPAC(I)))
320     FORMAT(3X,'READ ',A,' - OK')
C       NUMBER OF OBSERVATIONS AND PREDICTIONS
        WRITE(IOUTP,322) TRIM(AFNAM(OBPAC(I))),IOBS
        WRITE(IOUTP,323) TRIM(AFNAM(OBPAC(I))),IPRED
        WRITE(IOUTP,324) TRIM(AFNAM(OBPAC(I))),IOMIT
        IF (((IPRED.NE.0).AND.(IOBS.NE.0)).OR.((IPRED.NE.0).AND.
     +       (IOMIT.NE.0)).OR.((IOBS.NE.0).AND.(IOMIT.NE.0))) THEN
C         OBSERVATION _OB FILE
          IF(IOBS.GT.0)WRITE(IOUTP,326)'OBSERVATIONS',FFNAM(1,OBPAC(I))
C         PREDICTION  _OB FILE
          IF(IPRED.GT.0)WRITE(IOUTP,326)'PREDICTIONS ',FFNAM(2,OBPAC(I))
        ENDIF
        IF (IFAIL.NE.0) THEN
          WRITE(IOUTP,399)
          GOTO 9891
        END IF
        NOBS = NOBS + IOBS
        NPRED = NPRED + IPRED
        NDMHP = NDMHP + IPRED
        NOMIT = NOMIT + IOMIT
321     END IF
      END DO
      WRITE(IOUTP,327)
      WRITE(IOUTP,322) 'TOTAL',NOBS
      WRITE(IOUTP,323) 'TOTAL',NPRED
      WRITE(IOUTP,324) 'TOTAL',NOMIT
322   FORMAT(3X,A,1X,'NUMBER OF OBSERVATIONS: ',I4)
323   FORMAT(3X,A,1X,'NUMBER OF PREDICTIONS:  ',I4)
324   FORMAT(3X,A,1X,'OMITTED QUANTITIES:     ',I4)
326   FORMAT(3X,'FILE FOR ',A,' = ',A)
327   FORMAT(/,1X,'PROCESSED ALL OBSERVATION PACKAGES OKAY')

C == READ THE PES FILE FULLY NOW, AND LOAD PRIOR INFO

      IF (RUNTYPE.EQ.3) THEN
          IF (MAXITER.GT.0) THEN
              WRITE(IOUTP,331) AFNAM(26)(1:NBLNK(AFNAM(26)))
331           FORMAT(/,1X,'MAX-ITER>0 IN ',A,' - CALIBRATION WILL BE',
     +           ' COMPLETED.',/,
     +           3X,'A NEW .PES FILE WILL BE CREATED WITH MAX-ITER=0',/,
     +           3X,'TO CALCULATE STATISTICS OF THE CALIBRATED MODEL.')
C             IF ISS=2 WRITE "MAX-ITER=0" .PES FILE
              ISS = 2
            ELSEIF (MAXITER.EQ.0) THEN
              WRITE(IOUTP,332) AFNAM(26)(1:NBLNK(AFNAM(26)))
332           FORMAT(3X,'MAX-ITER=0 IN ',A,' - CALIBRATION WILL NOT BE',
     +           ' COMPLETED.',/,
     +          3X,'STATISTICS WITH RESPECT TO THE PARAMETERS LISTED',/,
     +          3X,'IN THE .SEN FILE WILL BE CALCULATED.')
C             IF ISS=1 JUST READ FULLY
              ISS = 1
          END IF
          CALL SPRD1PES1RP(ISS,IFAIL,AFNAM,IUNIT,NIUNIT,NPNG,IPR,MPR,
     +                    NPRIOR,IPRCOV,IPRINT,LPRINT,MAXITER,MAXCHANGE,
     +                    TOL,SOSC,NPESLINES,PESTEXT,NPLIST,ND,NIPRNAM,
     +                    EQNAM,NAMES,INAMES,IAPLOT,LN,
     +                    NSETS,ISETPLT,ISETTYP,IOMIT,ISYMBOL,
     +                    PARNAM,VMULT,IPRAR,MPRAR,NPDIM,PRM,WP)
          IF (IFAIL.NE.0) THEN
            WRITE(IOUTP,299)
            GOTO 9891
          ENDIF
      END IF

c     MAKE CHECK FOR UNIQUE NAMES FOR ALL OBS-PRED-PRIOR================

C     MAKE CHECKS THAT THE RUNTYPE AS IDENTIFIED FROM THE NAME FILE
C     IS COMPATIBLE WITH THE OBSERVATIONS/PREDICTIONS/PARAMETERS AS
C     CITED IN THE MODFLOW INPUT FILES

      IF ((NOBS.LT.1).AND.(RUNTYPE.EQ.3)) THEN
          WRITE(IOUTP,333) NOBS,RUNTYPE
333       FORMAT(/,1X,'NOBS: ',T10,I4,'  RUNTYPE: ',T24,I4,/,
     +    1X,'CAN NOT RUN CALIBRATION WITHOUT OBSERVATIONS - STOPPING')
          GOTO 9891
      ENDIF
      IF (((NOBS+NPRIOR).LT.NPE).AND.(RUNTYPE.EQ.3)) THEN
          WRITE(IOUTP,334) NOBS+NPRIOR,NPE,RUNTYPE
334       FORMAT(/,1X,'NOBS+NPRIOR: ',T14,I4,'  NPE: ',T24,I4,
     +    '  RUNTYPE: ',T36,I4,/,
     +      1X,'NOBS+NPRIOR < NPE - PES CANNOT BE RUN FOR CALIBRATION')
          GOTO 9891
      ENDIF
      IF (NPRED.LT.1) THEN
          WRITE(IOUTP,335) NPRED,RUNTYPE
335       FORMAT(/,1X,'NPRED: ',T10,I4,'  RUNTYPE: ',T24,I4,/,
     +    1X,'NO PREDICTIONS CITED IN _OB FILES - STOPPING')
          GOTO 9891
      ENDIF

C -- NAME THEN WRITE THE OBSERVATION/PREDICTION/CALIBRATION OBS FILES

      FFNAM(1,27) = OBS_PREF//TRIM(AFNAM(27))
      FFNAM(2,27) = PRE_PREF//TRIM(AFNAM(27))
      FFNAM(3,27) = PAR_PREF//TRIM(AFNAM(27))                           !CALIBRATION
      OBSBASE  = TRIM(ADJUSTL(OUTPATH))//OBS_PREF//TRIM(ADJUSTL(OUTNAM))
      PREDBASE = TRIM(ADJUSTL(OUTPATH))//PRE_PREF//TRIM(ADJUSTL(OUTNAM))
      PESBASE  = TRIM(ADJUSTL(OUTPATH))//PAR_PREF//TRIM(ADJUSTL(OUTNAM))
      CALL SPRD1OBS1WR(IFAIL,ISCALS,RUNTYPE,IUNIT,NIUNIT,OBSBASE,
     +              PREDBASE,PESBASE,FFNAM)
      IF (IFAIL.NE.0) THEN
        WRITE(IOUTP,399)
        GOTO 9891
      ENDIF

C -- PREPARE THE NAM FILES FOR THE NECESSARY RUNS

      SELECT CASE (RUNTYPE)

        CASE (1)
C       PREPARE NAME FILE FOR OBS ONLY CASE

          WRITE(IOUTP,350) 'OBS-ONLY CASE'
          CALL SPRD1NAM1WR(IFAIL,'OBS ',CUNIT,AFNAM,FFNAM,IUNIT,OUTNAM,
     +      NIUNIT,RUNTYPE,IGLOLST,AGLOBNAM,ALISTNAM,IGLOBUN,
     +      ILISTUN,INBAS,BASNAM,IMOUTS,MFOUTFILE,OBSNAM,PREDNAM,
     +      OB_SENLINE,PR_SENLINE,PESNAM,SENFILEOPT,MAXITER,
     +      PES_SENLINE,MUNIT,MFNAM)
          CALL SPRD1NAM1WR(IFAIL,'PRED',CUNIT,AFNAM,FFNAM,IUNIT,OUTNAM,
     +      NIUNIT,RUNTYPE,IGLOLST,AGLOBNAM,ALISTNAM,IGLOBUN,
     +      ILISTUN,INBAS,BASNAM,IMOUTS,MFOUTFILE,OBSNAM,PREDNAM,
     +      OB_SENLINE,PR_SENLINE,PESNAM,SENFILEOPT,MAXITER,
     +      PES_SENLINE,MUNIT,MFNAM)

        CASE (2)
C       PREPARE NAME FILE FOR OBS_SEN CASE

          WRITE(IOUTP,350) 'OBS-SEN CASE'
          CALL SPRD1NAM1WR(IFAIL,'OBS ',CUNIT,AFNAM,FFNAM,IUNIT,OUTNAM,
     +      NIUNIT,RUNTYPE,IGLOLST,AGLOBNAM,ALISTNAM,IGLOBUN,
     +      ILISTUN,INBAS,BASNAM,IMOUTS,MFOUTFILE,OBSNAM,PREDNAM,
     +      OB_SENLINE,PR_SENLINE,PESNAM,SENFILEOPT,MAXITER,
     +      PES_SENLINE,MUNIT,MFNAM)
          CALL SPRD1NAM1WR(IFAIL,'PRED',CUNIT,AFNAM,FFNAM,IUNIT,OUTNAM,
     +      NIUNIT,RUNTYPE,IGLOLST,AGLOBNAM,ALISTNAM,IGLOBUN,
     +      ILISTUN,INBAS,BASNAM,IMOUTS,MFOUTFILE,OBSNAM,PREDNAM,
     +      OB_SENLINE,PR_SENLINE,PESNAM,SENFILEOPT,MAXITER,
     +      PES_SENLINE,MUNIT,MFNAM)

        CASE (3)
C       PREPARE NAME FILE FOR OBS_SEN_PES CASE

          WRITE(IOUTP,350) 'OBS-SEN-PES CASE'
          IF (MAXITER.GT.0) THEN
            CALL SPRD1NAM1WR(IFAIL,'PES ',CUNIT,AFNAM,FFNAM,IUNIT,
     +        OUTNAM,NIUNIT,RUNTYPE,IGLOLST,AGLOBNAM,ALISTNAM,IGLOBUN,
     +        ILISTUN,INBAS,BASNAM,IMOUTS,MFOUTFILE,OBSNAM,PREDNAM,
     +        OB_SENLINE,PR_SENLINE,PESNAM,SENFILEOPT,MAXITER,
     +        PES_SENLINE,MUNIT,MFNAM)
          ENDIF
          CALL SPRD1NAM1WR(IFAIL,'OBS ',CUNIT,AFNAM,FFNAM,IUNIT,OUTNAM,
     +      NIUNIT,RUNTYPE,IGLOLST,AGLOBNAM,ALISTNAM,IGLOBUN,
     +      ILISTUN,INBAS,BASNAM,IMOUTS,MFOUTFILE,OBSNAM,PREDNAM,
     +      OB_SENLINE,PR_SENLINE,PESNAM,SENFILEOPT,MAXITER,
     +      PES_SENLINE,MUNIT,MFNAM)
          CALL SPRD1NAM1WR(IFAIL,'PRED',CUNIT,AFNAM,FFNAM,IUNIT,OUTNAM,
     +      NIUNIT,RUNTYPE,IGLOLST,AGLOBNAM,ALISTNAM,IGLOBUN,
     +      ILISTUN,INBAS,BASNAM,IMOUTS,MFOUTFILE,OBSNAM,PREDNAM,
     +      OB_SENLINE,PR_SENLINE,PESNAM,SENFILEOPT,MAXITER,
     +      PES_SENLINE,MUNIT,MFNAM)

        CASE DEFAULT

          WRITE(*,399)
          WRITE(IOUTP,399)
          GOTO 9891

      END SELECT

      IF (IFAIL.NE.0) THEN
        WRITE(IOUTP,399)
        GOTO 9891
      ENDIF

      WRITE(IOUTP,340)
340   FORMAT(3X,'MODFLOW .NAM FILES WRITTEN - OK')
350   FORMAT(/,1X,'PREPARING .NAM FILES FOR ',A)
399   FORMAT(/,1X,'ERROR PROCESSING MODFLOW FILES - 300 BLOCK - ',
     +                                         'STOPPING (MODPREDICT)')

C==== 400 BLOCK ========================================================
C==== DELETE ANY HANGING UNDERSCORE FILES                       ========

C   CHECK NOTHING STILL OPEN BY MODPREDICT

      CALL UCLOSEALL(IUNIT,NIUNIT)

      WRITE(IOUTP,401) RUNTYPE
401   FORMAT(/,1X,'DELETING HANGING UNDERSCORE FILES FOR RUNTYPE ',I2)

      SELECT CASE (RUNTYPE)
        CASE (1)
C         OBS. PROCESS UNDERSCORES
          DO I=1,6
            FN = TRIM(ADJUSTL(OBSBASE))//OBSSUF(I)
            CALL UDELOLD(FN)
            FN = TRIM(ADJUSTL(PREDBASE))//OBSSUF(I)
            CALL UDELOLD(FN)
          END DO
        CASE (2)
C         OBS. AND .SEN PROCESS UNDERSCORES
          DO I=1,6
            FN = TRIM(ADJUSTL(OBSBASE))//OBSSUF(I)
            CALL UDELOLD(FN)
            FN = TRIM(ADJUSTL(PREDBASE))//OBSSUF(I)
            CALL UDELOLD(FN)
          END DO
          DO I=1,3
            FN = TRIM(ADJUSTL(OBSBASE))//SENSUF(I)
            CALL UDELOLD(FN)
            FN = TRIM(ADJUSTL(PREDBASE))//SENSUF(I)
            CALL UDELOLD(FN)
          END DO
        CASE (3)
C         OBS. AND .SEN AND .PES PROCESS UNDERSCORES
          DO I=1,6
            FN = TRIM(ADJUSTL(OBSBASE))//OBSSUF(I)
            CALL UDELOLD(FN)
            FN = TRIM(ADJUSTL(PREDBASE))//OBSSUF(I)
            CALL UDELOLD(FN)
            FN = TRIM(ADJUSTL(OUTNAM))//OBSSUF(I)
            CALL UDELOLD(FN)
          END DO
          DO I=1,3
            FN = TRIM(ADJUSTL(OBSBASE))//SENSUF(I)
            CALL UDELOLD(FN)
            FN = TRIM(ADJUSTL(PREDBASE))//SENSUF(I)
            CALL UDELOLD(FN)
            FN = TRIM(ADJUSTL(OUTNAM))//SENSUF(I)
            CALL UDELOLD(FN)
          END DO
          DO I=1,3
            FN = TRIM(ADJUSTL(OBSBASE))//PESSUF(I)
            CALL UDELOLD(FN)
          END DO
        CASE DEFAULT
          WRITE(IOUTP,499)
          GOTO 9891
      END SELECT
      WRITE(IOUTP,402) RUNTYPE
402   FORMAT(1X,'DELETED HANGING UNDERSCORE FILES FOR RUNTYPE ',I2)
499   FORMAT(/,1X,'ERROR DELETING HANGING FILES',
     +            ' - 400 BLOCK - STOPPING (MODPREDICT)')

C==== 500 BLOCK ========================================================
C==== RUN RELEVENT CASE                                         ========

C -- CHECK CLEAR THESE ARRAYS: REFILL THEM FROM UNDERSCORES

      H = 0.
      HOBS = 0.
      UWH   = 0.
      UWHOBS = 0.
      RES = 0.
      UWRES = 0.

      WRITE(IOUTP,500) '    RUN MODFLOW SIMULATIONS    '
500   FORMAT(/,1X,'======================',A,'======================',/)

      MF2KCOM = ADJUSTL(MF2KCOM)
      OBSNAM  = ADJUSTL(OBSNAM)
      PREDNAM = ADJUSTL(PREDNAM)
      PESNAM  = ADJUSTL(PESNAM)

      SELECT CASE (RUNTYPE)

        CASE (1)
C --    RUN THE OBS_ONLY CASE(S) AND POST PROCESS

C         OBSERVATION RUN
          FN = TRIM(OBSNAM)
          RUNSTRING = ' OBSERVATIONS-ONLY CASE'
          CALL URUNMF2K(FN,RUNTYPE,RUNSTRING,IFAIL,OBSBASE)
          IF (IFAIL.NE.0) THEN
            WRITE(IOUTP,599)
            GOTO 9891
          END IF

C         PREDICTION RUN
          FN = TRIM(PREDNAM)
          RUNSTRING = ' PREDICTIONS-ONLY CASE'
          CALL URUNMF2K(FN,RUNTYPE,RUNSTRING,IFAIL,PREDBASE)
          IF (IFAIL.NE.0) THEN
            WRITE(IOUTP,599)
            GOTO 9891
          END IF

        CASE (2)
C --    RUN THE OBS_SEN CASE(S) AND POST PROCESS

C         OBSERVATION RUN
          FN = TRIM(OBSNAM)
          RUNSTRING = ' OBSERVATIONS-ONLY CASE'
          CALL URUNMF2K(FN,RUNTYPE,RUNSTRING,IFAIL,OBSBASE)
          IF (IFAIL.NE.0) THEN
            WRITE(IOUTP,599)
            GOTO 9891
          END IF

C         PREDICTION RUN
          FN = TRIM(PREDNAM)
          RUNSTRING = ' PREDICTIONS-ONLY CASE'
          CALL URUNMF2K(FN,RUNTYPE,RUNSTRING,IFAIL,PREDBASE)
          IF (IFAIL.NE.0) THEN
            WRITE(IOUTP,599)
            GOTO 9891
          END IF

        CASE (3)
C --    RUN THE OBS_SEN_PES CASE(S) AND POST PROCESS

          IF (MAXITER.GT.0) THEN
C         CALIBRATION RUN
            FN = TRIM(PESNAM)
            RUNSTRING = ' CALIBRATION CASE'
            CALL URUNMF2K(FN,RUNTYPE,RUNSTRING,IFAIL,PESBASE)
            IF (IFAIL.NE.0) THEN
              WRITE(IOUTP,599)
              GOTO 9891
            END IF

            WRITE(*,540) 'READING OUTPUT FOR',TRIM(PESNAM)
            WRITE(IOUTP,540) 'READING OUTPUT FOR',TRIM(PESNAM)
C           READ THE OPTIMIZED PARAMETERS AND UPDATE SEN FILE (PASS'4')
            OBSNAME = ' '
            IPLOTOP = -1
            SUMSQ = 0.
            CALL SPRD1OBS1US(IFAIL,4,PREDBASE,NPLIST,
     +                    NPE,NDMH,NHT,H,HOBS,UWH,UWHOBS,OBSNAME,
     +                    OBSNAMED,PARNAMTEMP,PAROPT,NPDIM,
     +                    PESBASE,IPLOTOP,IPLOTD,MPR,IPR,ND,OBSBASE,
     +                    NHTP,NDMHP,NADVP,RES,UWRES,S_SU,SUMSQ)
            IF (IFAIL.NE.0) THEN
              WRITE(IOUTP,599)
              GOTO 9891
            ENDIF
C           WRITE THE NEW SEN FILE
            CALL SPRD1SEN1WR(IFAIL,AFNAM,IUNIT,NIUNIT,NPLIST,
     +                      ISENALL,IUHEAD,MXSEN,IPRINTS,ISENSU,ISENPU,
     +                      ISENFM,PARNAM,ISENS,LN,B,BL,BU,BSCAL,
     +                      PAROPT,PARNAMTEMP,SENFILEOPT,NPDIM)
            IF (IFAIL.NE.0) THEN
              WRITE(IOUTP,599)
              GOTO 9891
            END IF
          ENDIF

C         OBSERVATION RUN WITH OPTIMIZED/CURRENT PARAMETERS
C         NOTE: SEN AND OBS ACTIVE
          FN = TRIM(OBSNAM)
          RUNSTRING = ' OBSERVATIONS-ONLY CASE'
          CALL URUNMF2K(FN,RUNTYPE,RUNSTRING,IFAIL,OBSBASE)
          IF (IFAIL.NE.0) THEN
            WRITE(IOUTP,599)
            GOTO 9891
          END IF

C         PREDICTION RUN WITH OPTIMIZED/CURRENT PARAMETERS
C         NOTE: SEN AND OBS ACTIVE
          FN = TRIM(PREDNAM)
          RUNSTRING = ' PREDICTIONS-ONLY CASE'
          CALL URUNMF2K(FN,RUNTYPE,RUNSTRING,IFAIL,PREDBASE)
          IF (IFAIL.NE.0) THEN
            WRITE(IOUTP,599)
            GOTO 9891
          END IF

        CASE DEFAULT

          WRITE(IOUTP,599)
          GOTO 9891

      END SELECT

C  FORMAT STATEMENTS FOR 500 BLOCK

540   FORMAT(/,1X,A,' CALIBRATION CASE',T50,A)
599   FORMAT(/,1X,'ERROR RUNNING MODFLOW CASE',
     +            ' - 500 BLOCK - STOPPING (MODPREDICT)')

C==== 600 BLOCK ========================================================
C==== READ OUTPUTS FOR THE RELEVENT CASE                        ========
C==== ORGANIZE AND REPORT RESULTS TO OUT FILE                   ========

      IOSTAR  = 0
      SELECT CASE (RUNTYPE)
        CASE (1)
          WRITE(*,601) 'READING OUTPUT FOR',TRIM(ADJUSTL(OBSNAM)),
     +                                      TRIM(ADJUSTL(PREDNAM))
          WRITE(IOUTP,601) 'READING OUTPUT FOR',TRIM(ADJUSTL(OBSNAM)),
     +                                          TRIM(ADJUSTL(PREDNAM))
        CASE (2)
          WRITE(*,603) 'READING OUTPUT FOR',TRIM(ADJUSTL(OBSNAM)),
     +                                      TRIM(ADJUSTL(PREDNAM))
          WRITE(IOUTP,603) 'READING OUTPUT FOR',TRIM(ADJUSTL(OBSNAM)),
     +                                          TRIM(ADJUSTL(PREDNAM))
        CASE (3)
          WRITE(*,603) 'READING OUTPUT FOR',TRIM(ADJUSTL(OBSNAM)),
     +                                      TRIM(ADJUSTL(PREDNAM))
          WRITE(IOUTP,603) 'READING OUTPUT FOR',TRIM(ADJUSTL(OBSNAM)),
     +                                          TRIM(ADJUSTL(PREDNAM))
        CASE DEFAULT
          WRITE(*,699)
          WRITE(IOUTP,699)
          GOTO 9891
      END SELECT

      OBSNAME = ' '
      IPLOTOP = -1
      SUMSQ = 0.
      S_SU  = 0.
      CALL SPRD1OBS1US(IFAIL,RUNTYPE,PREDBASE,
     +                 NPLIST,NPE,NDMH,NHT,H,HOBS,UWH,UWHOBS,
     +                 OBSNAME,OBSNAMED,PARNAMTEMP,PAROPT,NPDIM,
     +                 PESBASE,IPLOTOP,IPLOTD,MPR,IPR,ND,OBSBASE,NHTP,
     +                 NDMHP,NADVP,RES,UWRES,S_SU,SUMSQ)
      IF (IFAIL.NE.0) THEN
        WRITE(IOUTP,699)
        GOTO 9891
      END IF

c**** COULD ADD SHORT ROUTINE TO REMOVE THE 'OMIT' ENTRIES FROM
c**** THE 'NAMES' AND 'IAPLOT' ARRAYS NOW SO THAT AFTER SORTING
c**** THE COUNTERS FOR THE WEIGHT MATRIX CALCS ARE ALL CORRECT

C  IF RUNTYPE = 2 OR 3
C  - CALCULATE PARAMETER CORRELATION MATRIX USING S_SU SENSITIVITIES
C  - SENSITIVITIES READ FROM THE _su FILE ARE 'GROUPED' IN THE S_SU ARRAY
C     AS ALL "OBS" FOLLOWED BY ALL "PRED": IN CASE THERE ARE ANY FULL
C     WEIGHT MATRICES USED SORTING MUST BE DONE TO MATCH THE ORIGINAL
C     SEQUENCE AS READ FROM THE "OBS" FILES FOR THE XtX CALCULATION

      IF ((RUNTYPE.EQ.2).OR.(RUNTYPE.EQ.3)) THEN

C       COMPLETE THE CALCULATIONS FOR THE NEW PREDICTION UNDERSCORE FILES
        SPP = 0.
        SPR = 0.
        SPS = 0.
        PSCAL=0.
        DO N=1,ND
          IF (XOPR(N).EQ.'P') THEN
            IP=0
            DO NP=1,NPLIST
              IF (ISENS(NP).GT.0) THEN
                IP=IP+1
                IF ((RUNTYPE.EQ.3).AND.(MAXITER.EQ.0)) PVAL = B(NP)
                IF ((RUNTYPE.EQ.3).AND.(MAXITER.GT.0)) PVAL = PAROPT(NP)
                IF (LN(IP).LE.0) THEN
                  IF (PVAL.LT.BSCAL(IP)) PVAL = BSCAL(IP)
                END IF
                SPP(IP,N)= S_SU(IP,N)*(PVAL/100.)*(100./UWHOBS(N))      !(MODIFIED AFTER HILL, 1998 - EQ.11)
                SPR(IP,N)= S_SU(IP,N)*(PVAL/100.)*(100./UWH(N))         !(HILL, 1998 - EQ.12)(UWHOBS = REFERENCE VALUE FOR PREDICTIONS)
                IF (ISTATIST(N).EQ.0) PSCAL=STATIST(N)
                IF (ISTATIST(N).EQ.1) PSCAL=STATIST(N)*UWHOBS(N)
                IF (ISTATIST(N).EQ.2) PSCAL=STATIST(N)*UWH(N)
                SPS(IP,N)= S_SU(IP,N)*(PVAL/100.)*(100./PSCAL)             !(HILL, 1998 - EQ.13) - MODIFY FOR SCALE FACTOR!!!!
              ENDIF
            END DO
          END IF
        END DO

C       WRITE NEW PREDICTION UNDERSCORE FILES (_SPP,_SPR,_SPS)
        CALL SPRD1PRED1WR(IFAIL,ND,NPDIM,NPE,SPP,SPR,SPS,XOPR,PREDBASE,
     +                   IPR,MPR,PARNAMTEMP,IAPLOT,OBSNAME,IOUTP,PRESUF)
        IF (IFAIL.NE.0) GOTO 9891

C       CALCULATE WEIGHT MATRICES
        WRITE(IOUTP,620)
        CALL SPRD1SEN1WT(IFAIL,ND,IPR,MPR,IHWT)
        IF (IFAIL.NE.0) GOTO 9891

C       SORT UNDERSCORE-DATA TO MATCH ORIG. "OBS" SEQUENCE FOR XtX CALC
        CALL SPRD1SEN1SORT(IFAIL,S_SU,ND,NPE,NAMES,NOMIT,OBSTYPE,
     +               IPLOTOP,IPR,MPR,IAPLOT,NPDIM,IDRY,
     +               H,HOBS,RES,UWH,UWHOBS,UWRES,KTDIM,IOUTP,OBSNAME)
        IF (IFAIL.GT.0) GOTO 9891

C       CALCULATE+REPORT PARAMETER COVARIANCE AND CORRELATION MATRICS
        CALL SPRD1SEN1COR(IFAIL,ND,IPR,MPR,IHWT,S_SU,NPE,OBSNAMED,
     +                   OBSNAME,IPLOTD,NPDIM,PARNAMTEMP,OBSTYPE,
     +                   NAMES,IAPLOT,IPLOTOP,XOPR,SUMSQ,IOWTQ,H,HOBS,
     +                   PRM,PAROPT,MPRAR,NPLIST,WP,IDRY,LN,BSCAL)
        IF (IFAIL.GT.0) GOTO 9891

C       CALCULATE CSS FOR CALIBRATION SETS INC PRIOR INFO
C       NOTE: CORRELATED PRIOR NOT ACTIVE IN V.1
C       IF RUNTYPE = 2 LOAD PAROPT WITH B
        IF (RUNTYPE.EQ.2) PAROPT = B
        CALL SPRD1SEN1CSS1(IFAIL,IOWTQ,IAPLOT,IPR,MPR,LN,ND,
     +                   NPE,NPDIM,NAMES,S_SU,BSCAL,OBSTYPE,XOPR,IHWT,
     +                   PARNAMTEMP,PAROPT,IDRY,PCSS,NSETS,
     +                   PRM,MPRAR,NPLIST,WP)
        IF (IFAIL.NE.0) GOTO 9891

      ENDIF
C
C  CALL ROUTINES TO RECORD THE SET SUMMARY STATISTICS
c   CALIBRATION SETS FIRST
      WRITE(IOUTP,660) ' CALCULATE SET SUMMARY STATISTICS  '
      IOP = 1
      CALL SPRD1SETS1SM(H,HOBS,UWH,UWHOBS,ND,MPR,IPR,NPLIST,NSETS,
     +                 NSETDIM,ISETTYP,ISETNUM,SUMSTAT,SETNAM,
     +                 IOP,IOSTAR,IAPLOT,ISETPLT,NAMES,RES,UWRES,
     +                 ISYMBOL,NPE,OBSTYPE,IFAIL)
      IF (IFAIL.NE.0) GOTO 9891

c   PREDICTION SETS SECOND
      IOP = 2
      CALL SPRD1SETS1SM(H,HOBS,UWH,UWHOBS,ND,MPR,IPR,NPLIST,NSETS,
     +                 NSETDIM,ISETTYP,ISETNUM,SUMSTAT,SETNAM,
     +                 IOP,IOSTAR,IAPLOT,ISETPLT,NAMES,RES,UWRES,
     +                 ISYMBOL,NPE,OBSTYPE,IFAIL)
      IF (IFAIL.NE.0) GOTO 9891

C   FORMAT STATEMENTS FOR 600 BLOCK
601   FORMAT(/,1X,A,' OBSERVATION RUN ',T50,A,/,1X,T50,A)
602   FORMAT(/,1X,A,' PREDICTION RUN ',T50,A,/,1X,T50,A)
603   FORMAT(/,1X,A,' SENSITIVITY RUNTYPE ',T50,A,/,1X,T50,A)
604   FORMAT(/,1X,A,' CALIBRATION RUNTYPE ',T50,A)
620   FORMAT(/,1X,'PROCESSING DATA FOR CALCULATION OF THE PARAMETER ',
     +            'CORRELATION MATRIX')
650   FORMAT(/,1X,'ERROR ENCOUNTERED CALCULATING PARAMETER CORRELATION',
     +       /,1X,'AND COVARIANCE MATRICES - STOPPING (MODPREDICT)')
660   FORMAT(//,1X,'====================',A,'====================')
699   FORMAT(/,1X,'ERROR READING MODFLOW OUTPUT',
     +            ' - 600 BLOCK - STOPPING (MODPREDICT)')

C==== 700 BLOCK ========================================================
C==== WRAP UP AND CLOSE ALL FILES                               ========

      WRITE(IOUTP,700) '      RUN FILES SUMMARY      '
700   FORMAT('======================',A,'=========================',/)

      SELECT CASE (RUNTYPE)
        CASE (1)
C       LOCATION OF OBS_ONLY CASE OUTPUT FILES
          WRITE(IOUTP,711) TRIM(ADJUSTL(OBSBASE))//'.*'
          WRITE(IOUTP,711) TRIM(ADJUSTL(PREDBASE))//'.*'
        CASE (2)
C       LOCATION OF OBS_SEN CASE OUTPUT FILES
          WRITE(IOUTP,721) TRIM(ADJUSTL(OBSBASE))//'.*'
          WRITE(IOUTP,721) TRIM(ADJUSTL(PREDBASE))//'.*'
        CASE (3)
C       LOCATION OF OBS_SEN_PES CASE OUTPUT FILES
          IF (MAXITER.EQ.0) THEN
            WRITE(IOUTP,731)
            WRITE(IOUTP,743) TRIM(ADJUSTL(OBSBASE))//'.*'
            WRITE(IOUTP,744) TRIM(ADJUSTL(PREDBASE))//'.*'
          ELSEIF (MAXITER.GT.0) THEN
            WRITE(IOUTP,741)
            WRITE(IOUTP,742) TRIM(ADJUSTL(PESBASE))//'.*'
            WRITE(IOUTP,743) TRIM(ADJUSTL(OBSBASE))//'.*'
            WRITE(IOUTP,744) TRIM(ADJUSTL(PREDBASE))//'.*'
          ENDIF
        CASE DEFAULT
          WRITE(*,799)
          WRITE(IOUTP,799)
          CLOSE(IOUTP)
          STOP
      END SELECT

      WRITE(IOUTP,*)
      WRITE(IOUTP,710) ' PREDICTIVE ANALYSIS COMPLETE '
      WRITE(IOUTP,710) '=============================='
710   FORMAT('=======================',A,'=======================')

C  FORMAT STATEMENTS FOR 700 BLOCK

711   FORMAT(1X,'"OBSERVATION" RUNTYPE OUTPUT FILES',T70,A)
721   FORMAT(1X,'"SENSITIVITY" RUNTYPE OUTPUT FILES',T70,A)
731   FORMAT(1X,'"MAXITER = 0" RUNTYPE OUTPUT FILES',T70,A)
741   FORMAT(1X,'RUNTYPE = "CALIBRATION"')
742   FORMAT(3X,'"CALIBRATION" RUN OUTPUT (OBSERVATIONS ONLY)',T70,A)
743   FORMAT(3X,'"MAXITER = 0" RUN OUTPUTS FOR OBSERVATIONS',T70,A)
744   FORMAT(3X,'"MAXITER = 0" RUN OUTPUTS FOR PREDICTIONS',T70,A)
799   FORMAT(/,1X,'ERROR WRITING RUNS SUMMARY',
     +            ' - 700 BLOCK - STOPPING (MODPREDICT)')

C==== 800 BLOCK - END OF MAIN PROGRAM ==================================
C==== DEALLOCATE ALL ALLOCATED ARRAYS AND STOP                  ========

890   WRITE(*,891)
891   FORMAT(//,1X,'== PREDICTION RUN COMPLETED SUCCESSFULLY ==',
     +        /,1X,'===========================================')

C     WE COME DIRECTLY TO THIS LINE IF WE HAVE AN ERROR ABOVE
9891  IF(IERR.EQ.0.AND.IFAIL.EQ.0) CALL UCLOSEALL(IUNIT,NIUNIT)

C     DEALLOCATE SETS ARRAYS
      DEALLOCATE (ISETTYP,ISETPRN,ISENSCAL,ISETPLT,VMULT,SETNAM,
     +            SUMSTAT,ISYMBOL,STAT=IERR)
      IF (IERR.NE.0) THEN
        GOTO 9872
      ENDIF
C     DEALLOCATE PARAMETER SENSITIVITY ARRAYS
      DEALLOCATE(PARNAM,ISENS,LN,B,BL,BU,BSCAL,PAROPT,PARNAMTEMP,
     +           IPPTR,PESTEXT,EQNAM,NIPRNAM,PRM,WP,STAT=IERR)
      IF (IERR.NE.0) THEN
        GOTO 9872
      ENDIF
C     DEALLOCATE OBSERVATION ARRAYS
      DEALLOCATE(OBSNME,PREDNME,OBSNAME,OBSNAMED,OBSTYPE,XOPR,
     +           H,HOBS,UWH,UWHOBS,RES,UWRES,NAMES,IPLOTOP,IPLOTD,
     +           IAPLOT,ISETNUM,XWTQ,XWTQS,HWT,WT,S_SU,SPS,SPR,SPP,
     +           STATIST,ISTATIST,STAT=IERR)
      IF (IERR.NE.0) THEN
        GOTO 9872
      ENDIF

      IF (IFAIL.EQ.0) STOP 'NORMAL TERMINATION OF MOD-PREDICT'

9870  IF (IERR.NE.0) WRITE(IOUTP,9871)
      IF (IERR.NE.0) WRITE(*,9871)
9871  FORMAT(//,1X,'ERROR ALLOCATING ARRAYS - STOPPING (MODPREDICT)')
9872  IF (IERR.NE.0) WRITE(IOUTP,9873)
      IF (IERR.NE.0) WRITE(*,9873)
9873  FORMAT(/,1X,'ERROR DEALLOCATING ARRAYS - STOPPING (MODPREDICT)')
      CALL UCLOSEALL(IUNIT,NIUNIT)

      STOP 'MOD-PREDICT TERMINATED WITH ERRORS - CHECK MODPREDICT.OUT'
      END
C=======================================================================
