c=======================================================================
c     SUBROUTINES FOR MOD-PREDICT
c=======================================================================

c=======================================================================
      SUBROUTINE SPRD1OB1AL(IFAIL,IIN,MOBFILE,NQ,NQC,NQT,ND)
c=======================================================================
C     READ OBSERVATION PACKAGES FOR DIMENSIONS, RETURN TO MAIN PROGRAM
C     VERSION 1, JUN 2003, MJT (BORROWS FROM MF2K CODE)
C      - READS DROB,RVOB,CHOB,GBOB (DTOB?)

      USE DRIVER
      IMPLICIT NONE

      INTEGER IERR,IFAIL,IIN,NQ,NQC,NQT,ND,ILINE,NBLNK,ISTART,ISTOP,LLOC
      REAL R
      CHARACTER*(*) MOBFILE
      LOGICAL LOP
c     ------------------------------------------------------------------

      INQUIRE(UNIT=IIN,OPENED=LOP)
      IF (LOP) THEN
          REWIND(IIN)
        ELSE
          OPEN(IIN,FILE=MOBFILE,STATUS='OLD',IOSTAT=IERR)
          IF(IERR.NE.0) THEN
            WRITE(IOUTP,2) MOBFILE(1:NBLNK(MOBFILE))
2           FORMAT('ERROR OPENING FILE ',A,'.')
            IFAIL = 1
            RETURN
          END IF
      END IF

C     READ HEADERS
      ILINE=0
10    ILINE=ILINE+1
      READ(IIN,'(A)',ERR=9100,END=9100) CLINE
      IF(CLINE.EQ.' ') GO TO 10
      CALL Ulshift(CLINE)
      IF(CLINE(1:1).EQ.'#') THEN
        GO TO 10
      END IF

C --- ITEM 1
      LLOC = 1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NQ,R,IOUTP,IIN)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NQC,R,IOUTP,IIN)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NQT,R,IOUTP,IIN)

C     RETURN WITH DIMENSIONS
      ND = ND + NQT
      RETURN

9100  WRITE(IOUTP,9110) MOBFILE(1:NBLNK(MOBFILE))
9110  FORMAT('ERROR READING MODFLOW OBSERVATION FILE ',A,'.')
9120  WRITE(IOUTP,9130)
9130  FORMAT('STOP EXECUTION (SPRD1OB1AL)')

      IFAIL = 1
      RETURN

      END

c=======================================================================
      SUBROUTINE SPRD1OB1RP(IFAIL,IIN,IOBS,OBSNME,MOBFILE,
     +  IPACKAGE,NQCMAX,NQMAX,NQTMAX,NQ,NQC,NQT,
     +  IPRED,IPRN,ND,MPR,IPR,OBPAC,NOBPAC,NIUNIT,AFNAM,
     +  FFNAM,NQT1,NHT,NT,IQ1,NC,IWTQD,NAMES,INAMES,IAPLOT,VMULT,NSETS,
     +  ISETPLT,ISETTYP,IOMIT,ISYMBOL,NDMH,OBSTYPE,XOPR,
     +  STATIST,ISTATIST)
c=======================================================================
C     READ DROB/RVOB/CHOB/GBOB PACKAGES FULLY
C     VERSION 1, JUN 2003, MJT (BORROWS FROM MF2K CODE)

C     - IDENTIFY MEMBERS OF PREDICTION/OBSERVATION/OMIT SETS
C     - SCALE STATISTIC BY VMULT FOR SET
C     - WRITE ANY NEW PAKCAGE INPUT FILES AS REQUIRED

      USE DRIVER
      IMPLICIT NONE

      INTEGER IOBS,IPACKAGE,IOWTQ,J,IFAIL,NQ,NQC,NQT,ILINE,NBLNK,I,
     +        IPROW,IPCOL,M,ICROW,ICCOL,ONE,K,IOMIT, IPRN,IIN,
     +        IOBHEADER,LLOC,OIOUT,PIOUT,IQ1OLD,IQ2OLD, IPRED,NC,NC1,
     +        NC2,L,NQT1,NQT2,ND,IGETUNIT,IROWS,ICOLS, I4,NT,NT1,NT2,
     +        NHT,N,MPR,IPR,IQ1,IQ2,IQ,ISTOP,ISTART,NIUNIT,IERR,NSETS,
     +        NQMAX,NQCMAX,NQTMAX,NTOLD,NCOLD,IWTQD,INAMES,MM,
     +        NDMH,IFOUND,INAMESOLD,KR,KC,MR,MC,NQOO,NQPP
C      NIL,
      INTEGER IST(ND),NOBPAC,OBPAC(NOBPAC),IREFSP(3,ND),
     +        NQOB(NQTMAX), NQCL(NQTMAX),IPLOT(ND+IPR+MPR),
     +        IAPLOT(ND+IPR+MPR),ISETPLT(NSETS,ISETCNT),ISETTYP(NSETS),
     +        PNQOB(NQTMAX),ONQOB(NQTMAX),ISYMBOL(NSETS),
     +        ISTATIST(ND+IPR+MPR)
      REAL    R,EVF,TOMULT,WTVAR,RTEMP
      REAL    TOFFSET(ND),STAT(ND),VMULT(NSETS),HOBS(ND+IPR+MPR),
     +        QCLS(5,NQCMAX),WTQ(IWTQD,IWTQD),TWTQ(IWTQD,IWTQD),
     +        RWTQ(IWTQD,IWTQD),STATIST(ND+IPR+MPR)
      CHARACTER*1 LNUM_OB(NQTMAX,NQMAX),XOPR(ND+IPR+MPR)
      CHARACTER*300 OBHEADERS(20)
      CHARACTER*4  ACHAR
      CHARACTER*100 FFNAM(3,NIUNIT),AFNAM(NIUNIT)
      CHARACTER*20 FMTIN,FMTOUT,AFMT
      CHARACTER*12 APACKAGE,OBSNME(ND+IPR+MPR), NAMES(ND+MPR+IPR),
     +             OBSTYPE(ND+IPR+MPR)
      character*(*) mobfile
      CHARACTER*7 NO_FILE
      LOGICAL LOP
c     ------------------------------------------------------------------

      IFAIL=0

      NO_FILE = 'NO_FILE'

      IF(IPACKAGE.EQ.2)THEN
        APACKAGE='ADV'
      ELSE IF(IPACKAGE.EQ.3)THEN
        APACKAGE='CONC'
        WRITE(IOUTP,4) APACKAGE
4       FORMAT(/,1X,'OBSERVATION TYPE ',A,' NOT PRESENTLY SUPPORTED')
        IFAIL = 1
        RETURN
      ELSE IF(IPACKAGE.EQ.4)THEN
        APACKAGE='DRAIN'
      ELSE IF(IPACKAGE.EQ.5)THEN
        APACKAGE='RIVER'
      ELSE IF(IPACKAGE.EQ.6)THEN
        APACKAGE='GHB'
      ELSE IF(IPACKAGE.EQ.7)THEN
        APACKAGE='STREAM'
        WRITE(IOUTP,4) APACKAGE
        IFAIL = 1
        RETURN
      ELSE IF(IPACKAGE.EQ.8)THEN
        APACKAGE='CONST_HEAD'
      ELSE IF(IPACKAGE.EQ.9)THEN
        APACKAGE='DTOB'
        WRITE(IOUTP,4) APACKAGE
        IFAIL = 1
        RETURN
      ELSE IF(IPACKAGE.EQ.10)THEN
        APACKAGE='SFOB'
        WRITE(IOUTP,4) APACKAGE
        IFAIL = 1
        RETURN
      ELSE
        WRITE(IOUTP,7)
7       FORMAT(/,1X,'ERROR ENCOUNTERED WITH OBSERVATION PACKAGES')
        IFAIL = 1
        RETURN
      END IF

C     OPEN AND READ THE FILE

      INQUIRE(UNIT=IIN,OPENED=LOP)
      IF (LOP) THEN
          REWIND(IIN)
        ELSE
          OPEN(IIN,FILE=MOBFILE,STATUS='OLD',IOSTAT=IERR)
          IF(IERR.NE.0) THEN
            WRITE(IOUTP,8) MOBFILE(1:NBLNK(MOBFILE))
8           FORMAT('ERROR OPENING FILE ',A,'.')
            IFAIL = 1
            RETURN
          END IF
      END IF

C     MAINLY USE LOCAL POINTERS UNLIKE MF2K - THIS IS BECAUSE OF 'OMIT'
      NT = 0
      NC = 0
      NTOLD = NT
      NCOLD = NC
      IQ1 = 1
      ONE = 1
      WTVAR = 0.
      WTQ = 0.
      RWTQ = 0.
      TWTQ = 0.
      INAMESOLD = INAMES

C     READ AND STORE HEADERS
      ILINE=0
10    ILINE=ILINE+1
      READ(IIN,'(A)',ERR=9100,END=9200) CLINE
      IF(CLINE.EQ.' ') GO TO 10
      CALL Ulshift(CLINE)
      IF(CLINE(1:1).EQ.'#') THEN
        OBHEADERS(ILINE) = CLINE
        GO TO 10
      ELSE
        IOBHEADER = ILINE-1
      END IF

C --- ITEM 1
      LLOC = 1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NQ,R,IOUTP,IIN)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NQC,R,IOUTP,IIN)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NQT,R,IOUTP,IIN)
      NQOO = NQ       !NUMBER OF CELL GROUPS IN NEW OBS-ONLY FILE
      NQPP = NQ       !NUMBER OF CELL GROUPS IN NEW PRED-ONLY FILE

C     IFF (ISS.GT.0) THEN ECHO DIMENSIONS, THEN READ REST OF FILE
      WRITE (IOUTP,15) NQ, NQC, NQT
15    FORMAT ('   NUMBER OF FLOW-OBSERVATION CELL GROUPS...: ',I6,/,
     +        '   NUMBER OF CELLS IN CELL GROUPS...........: ',I6,/,
     +        '   NUMBER OF CELL FLOWS.....................: ',I6)

C --  ITEM 2
      ILINE = ILINE + 1
      READ(IIN,*) TOMULT, EVF, IOWTQ
      IF (IOWTQ.GT.0) IOWTQ = 1
      IF (IOWTQ.GT.0) IWTMAT = 1
      IF(IOWTQ.LT.0)THEN
        WRITE(IOUTP,18) MOBFILE(1:NBLNK(MOBFILE))
18      FORMAT(A,': ILLEGAL IOWTQ VALUE.')
        GO TO 9870
      END IF
      IF(EVF.LE.0.0)THEN
        WRITE(IOUTP,19) MOBFILE(1:NBLNK(MOBFILE))
19      FORMAT(A,': ILLEGAL EVF VALUE.')
        GO TO 9870
      END IF

C     INITIALIZE VARIABLES
      IQ2 = IQ1 + NQ - 1
      IQ1OLD = IQ1
      IQ2OLD = IQ2

C     LOOP THROUGH CELL GROUPS (ITEMS 3, 4, AND 5)
      DO 120 IQ = IQ1,IQ2
C       READ ITEM 3
        READ (IIN,*) NQOB(IQ), NQCL(IQ)
        PNQOB(IQ) = NQOB(IQ)
        ONQOB(IQ) = NQOB(IQ)
C       SET FLAG FOR SETTING ALL FACTORS TO 1
        I4 = 0
        IF (NQCL(IQ).LT.0) THEN
          I4 = 1
C          NQCL(IQ) = -NQCL(IQ)                                         !KEEP THEM NEGATIVE
        ENDIF
C       READ TIME STEPS, MEASURED FLOWS, AND WEIGHTS.
        NT1 = NT + 1
        NT2 = NT + NQOB(IQ)
        DO 30 J = NT1, NT2
          N = NHT + J
C---------READ ITEM 4
          READ (IIN,*) OBSNME(N),IREFSP(1,N),TOFFSET(N),HOBS(N),
     +                                        STAT(N),IST(N),IPLOT(N)
C       IDENTIFY IF THIS IS A CALIBRATION / PREDICTION / OMIT SET MEMBER
C       OR SIMPLY AN OBSERVATION THAT IS NOT A SET MEMBER
          IFOUND = 0
          DO K = 1,NSETS
           DO MM = 1,ISYMBOL(K)
C           IS THIS PLOT-SYMBOL LISTED AS A SET-MEMBER?
            IF (IPLOT(N).EQ.ISETPLT(K,MM)) THEN
C             WHAT TYPE OF SET
              IF (ISETTYP(K).EQ.0) THEN
C               OMIT
                LNUM_OB(J,IQ) = 'X'
                IOMIT = IOMIT + 1
                ONQOB(IQ) = ONQOB(IQ)-1
                PNQOB(IQ) = PNQOB(IQ)-1
                IFOUND = 1
              ELSE IF(ISETTYP(K).EQ.1) THEN
C               CALIBRATION
                IOBS = IOBS + 1
                LNUM_OB(J,IQ) = 'C'
                IREFSP(3,N) = IREFSP(1,N)
                PNQOB(IQ) = PNQOB(IQ)-1
                IFOUND = 1
              ELSE IF(ISETTYP(K).EQ.2) THEN
C               PREDICTION
                IPRED = IPRED + 1
                LNUM_OB(J,IQ) = 'P'
                IREFSP(2,N) = IREFSP(1,N)
                ONQOB(IQ) = ONQOB(IQ)-1
                IFOUND = 1
              ELSE
                WRITE(IOUTP,20)
20              FORMAT(/,1X,'ERROR ENCOUNTERED WITH SET TYPE')
                GOTO 9890
              END IF
            END IF
           END DO
          END DO
          IF (IFOUND.EQ.0) THEN
C           NOT A MEMBER OF ANY SET SO IS JUST A VALID OBSERVATION
            IOBS = IOBS + 1
            LNUM_OB(J,IQ) = 'O'
            IREFSP(3,N) = IREFSP(1,N)
            PNQOB(IQ) = PNQOB(IQ)-1
          ENDIF

c         IF NO V-C MATRIX CALCULATE WEIGHT MATRIX ENTRY IF NOT 'OMIT'
          IF ((IOWTQ.EQ.0).AND.(LNUM_OB(J,IQ).NE.'X')) THEN
            RTEMP = STAT(N)
C           VMULT SCALING
            CALL SPRD1SETS1VM(IFAIL,RTEMP,IST(N),VMULT,NSETS,
     +                                MOBFILE,IPLOT(N),ISETPLT,ISYMBOL)
C           MF2K SCALING
            CALL UWTCALC(IFAIL,HOBS(N),IST(N),RTEMP,EVF,WTVAR,N)
            WMROW=WMROW+1
            WMCOL=WMCOL+1
            XWTQ(WMCOL,WMROW) = WTVAR
          END IF

C         LOAD GLOBAL ITEMS
   28     INAMES          = INAMES + 1
          NAMES(INAMES)   = OBSNME(N)
          IAPLOT(INAMES)  = IPLOT(N)
          OBSTYPE(INAMES) = APACKAGE
          XOPR(INAMES)    = LNUM_OB(J,IQ)
          ISTATIST(INAMES)= IST(N)
          STATIST(INAMES) = RTEMP

   30   CONTINUE

C       LAYER, ROW, COLUMN, AND FACTOR (ITEM 5)
        NC1 = NC + 1
        NC2 = NC + ABS(NQCL(IQ))
        DO 40 L = NC1, NC2
          READ (IIN,*) (QCLS(I,L),I=1,4)
          IF (I4.EQ.1) QCLS(4,L) = 1.
   40   CONTINUE
C ----- UPDATE COUNTERS
        NC = NC2
        NT = NT2
  120 CONTINUE

C   CHECK THE COUNTER FOR NQ
      DO IQ = IQ1,IQ2
          IF (PNQOB(IQ).LE.0) NQPP=NQPP-1
          IF (ONQOB(IQ).LE.0) NQOO=NQOO-1
      END DO

C --- IF A COVARIANCE MATRIX IS PRESENT - READ IT (ITEM 6)
      NQT2 = NQT1 + NQT - 1
      IF (IOWTQ.GT.0 .AND. NQT.GT.0) THEN
        READ (IIN,*) FMTIN, IPRN
        WRITE(IOUTP,300) FMTIN
300     FORMAT(3X,'READING COVARIANCE MATRIX WITH FORMAT ',A)
        DO I = 1,NQT
          READ (IIN,FMTIN) (WTQ(I,J),J=1,NQT)
C         MF2K SCALING
          DO J = 1, NQT
            RWTQ(I,J) = WTQ(I,J)*EVF
          END DO
C         IDENTIFY AND SCALE ENTRIES FOR THE FULL WEIGHT MATRIX
C         ROWS FIRST
          DO KR = 1,NSETS
            DO MR = 1,ISYMBOL(KR)
C             IS THE ROW PLOT-SYMBOL LISTED AS AN 'OMIT' SET-MEMBER?
              IF (IPLOT(INAMESOLD+I).EQ.ISETPLT(KR,MR)) THEN
                IF(ISETTYP(KR).EQ.0) THEN
C                 OMIT THIS ROW
                  GOTO 325
                END IF
              END IF
            END DO
          END DO
C         RETAINED THIS ROW:
          WMROW=WMROW+1
          WMCOLOLD=WMCOL
C         COLUMNS NEXT
          DO J = 1, NQT
            DO KC = 1,NSETS
              DO MC = 1,ISYMBOL(KC)
C               IS THE COL PLOT-SYMBOL LISTED AS AN 'OMIT' SET-MEMBER?
                IF (IPLOT(INAMESOLD+J).EQ.ISETPLT(KC,MC)) THEN
                  IF(ISETTYP(KC).EQ.0) THEN
C                   OMIT THIS COLUMN
                    GOTO 324
                  ELSE
C                   CALL SPRD1SETS1VM A MAXIMUM OF TWICE:
C                   ONCE FOR ROW
                    CALL SPRD1SETS1VM(IFAIL,RWTQ(I,J),ONE,VMULT,
     +                   NSETS,MOBFILE,IPLOT(INAMESOLD+I),
     +                   ISETPLT,ISYMBOL)
C                   ONCE FOR COLUMN
                    CALL SPRD1SETS1VM(IFAIL,RWTQ(I,J),ONE,VMULT,
     +                   NSETS,MOBFILE,IPLOT(INAMESOLD+J),
     +                   ISETPLT,ISYMBOL)
                  END IF
                END IF
              END DO
            END DO
C           IF WE ARE HERE: LOAD INTO FULL WEIGHT MATRIX
            WMCOLOLD=WMCOLOLD+1
            XWTQ(WMCOLOLD,WMROW) = RWTQ(I,J)
324       END DO
325     END DO
        WRITE(IOUTP,350)
350     FORMAT(3X,'- COVARIANCES READ OKAY')
        WMCOL = WMCOLOLD
        NQT1 = NQT2 + 1
      END IF
      IQ1 = IQ2 + 1
      NQT1 = NQT2 + 1
      CLOSE(IIN)
      IF (WMROW.NE.WMCOL) THEN
          WRITE(IOUTP,360) APACKAGE
360       FORMAT(/,1X,'ERROR BUILDING WEIGHT MATRIX FOR ')
          IFAIL = 1
          RETURN
      ENDIF

C== IF IPRED.GT.0 AND IOBS.GT.0 WRITE THE NEW OBSERVATION PACKAGE FILES

      IF (((IOBS.GT.0).AND.(IPRED.GT.0)).OR.((IOBS.GT.0).AND.
     +    (IOMIT.GT.0)).OR.((IPRED.GT.0).AND.(IOMIT.GT.0))) THEN

C    == OBSERVATION ONLY FILE
        IF (IOBS.GT.0) THEN

        FFNAM(1,OBPAC(IPACKAGE)) = OBS_PREF//TRIM(MOBFILE)              !load in for obs-only runs
        FFNAM(3,OBPAC(IPACKAGE)) = OBS_PREF//TRIM(MOBFILE)              !load in for pes runs
        OIOUT = IGETUNIT(1,95)
        OPEN(OIOUT,FILE=FFNAM(1,OBPAC(IPACKAGE)),
     +                                        STATUS='UNKNOWN',err=8000)
        DO I=1,IOBHEADER
            WRITE(OIOUT,'(A)') ADJUSTL(TRIM(OBHEADERS(I)))
        END DO
        WRITE(OIOUT,1100) 'MOD-PREDICT PRODUCED THIS ',TRIM(APACKAGE)
1100    FORMAT('#',1X,A,A,' FILE FOR OBSERVATIONS')

C       ADJUST FOR IPRED AND IOMIT
        WRITE(OIOUT,*) NQOO,NQC,NQT-IPRED-IOMIT
        WRITE(OIOUT,*) TOMULT,EVF,IOWTQ

        END IF

C    == PREDICTION ONLY FILE
        IF (IPRED.GT.0) THEN

        FFNAM(2,OBPAC(IPACKAGE)) = PRE_PREF//TRIM(MOBFILE)
        PIOUT = IGETUNIT(1,95)
        OPEN(PIOUT,FILE=FFNAM(2,OBPAC(IPACKAGE)),
     +                                        STATUS='UNKNOWN',err=8000)
        DO I=1,IOBHEADER
            WRITE(PIOUT,'(A)') ADJUSTL(TRIM(OBHEADERS(I)))
        END DO
        WRITE(PIOUT,1200) 'MOD-PREDICT PRODUCED THIS ',TRIM(APACKAGE)
1200    FORMAT('#',1X,A,A,' FILE FOR PREDICTIONS')

C       ADJUST FOR IOBS AND IOMIT
        WRITE(PIOUT,*) NQPP,NQC,NQT-IOBS-IOMIT
        WRITE(PIOUT,*) TOMULT,EVF,IOWTQ

        END IF

C    == WRITE THE ENTRIES

        DO IQ = IQ1OLD,IQ2OLD
          IF (ONQOB(IQ).GT.0) WRITE(OIOUT,*) ONQOB(IQ),NQCL(IQ)
          IF (PNQOB(IQ).GT.0) WRITE(PIOUT,*) PNQOB(IQ),NQCL(IQ)
          NT1 = NTOLD + 1
          NT2 = NTOLD + NQOB(IQ)
          DO J = NT1, NT2
            N = NHT + J
            IF (IOWTQ.LE.0) THEN
C           IF NO V-C MATRIX, SCALE STATISTIC BY VMULT BEFORE WRITING
              CALL SPRD1SETS1VM(IFAIL,STAT(N),IST(N),VMULT,NSETS,
     +                                MOBFILE,IPLOT(N),ISETPLT,ISYMBOL)
            END IF
            IF ((LNUM_OB(J,IQ).EQ.'O').OR.(LNUM_OB(J,IQ).EQ.'C')) THEN
              WRITE(OIOUT,*) OBSNME(N),IREFSP(1,N),TOFFSET(N),HOBS(N),
     +                         STAT(N),IST(N),IPLOT(N)
            ELSEIF (LNUM_OB(J,IQ).EQ.'P') THEN
              WRITE(PIOUT,*) OBSNME(N),IREFSP(1,N),TOFFSET(N),HOBS(N),
     +                         STAT(N),IST(N),IPLOT(N)
            ENDIF
          END DO
          NC1 = NCOLD + 1
          NC2 = NCOLD + ABS(NQCL(IQ))
          DO L = NC1, NC2
            IF (ONQOB(IQ).GT.0) WRITE (OIOUT,1300) (QCLS(I,L),I=1,4)
            IF (PNQOB(IQ).GT.0) WRITE (PIOUT,1300) (QCLS(I,L),I=1,4)
1300        FORMAT (4X,F8.0,F6.0,F7.0,F9.2)
          END DO
C       --UPDATE COUNTERS
          NCOLD = NC2
          NTOLD = NT2
        END DO

C     IF THERE IS A COVARIANCE MATRIX - WRITE IT OUT

        IF (IOWTQ.GT.0) THEN
          CALL UCASETRANS(FMTIN,'hi')
          IF (INDEX(FMTIN,'F').GE.1) THEN
            AFMT =FMTIN(INDEX(FMTIN,'F'):LEN_TRIM(FMTIN))
          ELSEIF (INDEX(FMTIN,'G').GT.1) THEN
            AFMT =FMTIN(INDEX(FMTIN,'G'):LEN_TRIM(FMTIN))
          ENDIF
          AFMT = ADJUSTL(AFMT)

c       OBSERVATIONS ONLY MATRIX

          IF (IOBS.GT.0) THEN

C         PREP THE FORMAT
          WRITE(ACHAR,'(I4)') IOBS
          ACHAR= ADJUSTL(ACHAR)
          FMTOUT = '('//TRIM(ACHAR)//AFMT//')'
          WRITE(OIOUT,*) FMTOUT,IPRN
C         LOAD AND PRINT THE TEMP COVARIANCE ARRAY
          TWTQ  = 0.
          IROWS = 0
          IPROW = NHT
          ICROW = 0
C         ROWS FIRST
          DO J = 1,NQ
            DO I = 1,NQOB(J)
              IPROW = IPROW + 1
              ICROW = ICROW + 1
              IF((LNUM_OB(I,J).EQ.'O').OR.(LNUM_OB(I,J).EQ.'C')) THEN
                IROWS = IROWS + 1
                ICOLS = 0
                ICCOL = 0
                IPCOL = NHT
C               NOW COLUMNS
                DO M = 1,NQ
                  DO N = 1,NQOB(M)
                    IPCOL = IPCOL + 1
                    ICCOL = ICCOL + 1
                    IF((LNUM_OB(N,M).EQ.'O').OR.(LNUM_OB(N,M).EQ.'C'))
     +                                                            THEN
                      ICOLS=ICOLS+1
C                     CALL SPRD1SETS1VM A MAXIMUM OF TWICE:
C                     ONCE FOR ROW
                      IF (LNUM_OB(I,J).EQ.'C')
     +                CALL SPRD1SETS1VM(IFAIL,WTQ(ICROW,ICCOL),ONE,
     +                 VMULT,NSETS,MOBFILE,IPLOT(IPROW),ISETPLT,ISYMBOL)
C                     ONCE FOR COLUMN
                      IF (LNUM_OB(N,M).EQ.'C')
     +                CALL SPRD1SETS1VM(IFAIL,WTQ(ICROW,ICCOL),ONE,
     +                 VMULT,NSETS,MOBFILE,IPLOT(IPCOL),ISETPLT,ISYMBOL)
C                     LOAD THE TEMPORARY MATRIX
                      TWTQ(IROWS,ICOLS) = WTQ(ICROW,ICCOL)
                    END IF
                  END DO
                END DO
                WRITE(OIOUT,FMTOUT) (TWTQ(IROWS,N),N=1,IOBS)
              END IF
            END DO
          END DO

          END IF

c       PREDICTIONS ONLY MATRIX

          IF (IPRED.GT.0) THEN

C         PREP THE FORMAT
          WRITE(ACHAR,'(I4)') IPRED
          ACHAR= ADJUSTL(ACHAR)
          FMTOUT = '('//TRIM(ACHAR)//AFMT//')'
          WRITE(PIOUT,*) FMTOUT,IPRN
C         LOAD AND PRINT THE TEMP COVARIANCE ARRAY
          TWTQ  = 0.
          IROWS = 0
          IPROW = NHT
          ICROW = 0
C         ROWS FIRST
          DO J = 1,NQ
            DO I = 1,NQOB(J)
              IPROW = IPROW + 1
              ICROW = ICROW + 1
              IF (LNUM_OB(I,J).EQ.'P') THEN
                IROWS = IROWS + 1
                ICOLS = 0
                ICCOL = 0
                IPCOL = NHT
C               NOW COLUMNS
                DO M = 1,NQ
                  DO N = 1,NQOB(M)
                    IPCOL = IPCOL + 1
                    ICCOL = ICCOL + 1
                    IF (LNUM_OB(N,M).EQ.'P') THEN
                      ICOLS=ICOLS+1
C                     CALL SPRD1SETS1VM TWICE:
C                     ONCE FOR ROW
                      CALL SPRD1SETS1VM(IFAIL,WTQ(ICROW,ICCOL),ONE,
     +                 VMULT,NSETS,MOBFILE,IPLOT(IPROW),ISETPLT,ISYMBOL)
C                     ONCE FOR COLUMN
                      CALL SPRD1SETS1VM(IFAIL,WTQ(ICROW,ICCOL),ONE,
     +                 VMULT,NSETS,MOBFILE,IPLOT(IPCOL),ISETPLT,ISYMBOL)
                      TWTQ(IROWS,ICOLS) = WTQ(ICROW,ICCOL)
                    END IF
                  END DO
                END DO
                WRITE(PIOUT,FMTOUT) (TWTQ(IROWS,N),N=1,IPRED)
              END IF
            END DO
          END DO

          END IF
        ENDIF
        IF (IOBS.GT.0) CLOSE(OIOUT)
        IF (IPRED.GT.0) CLOSE(PIOUT)

      ELSE IF ((IPRED.EQ.0).AND.(IOBS.EQ.0)) THEN
C       THEY WERE ALL OMITS - DON'T USE IT
        FFNAM(1,OBPAC(IPACKAGE)) = NO_FILE
        FFNAM(2,OBPAC(IPACKAGE)) = NO_FILE
        WRITE(IOUTP,1400)
1400    FORMAT(3X,'NOTE: ALL ENTRIES ARE "OMIT": FILE WILL NOT BE USED')
      ELSE IF ((IPRED.EQ.0).AND.(IOBS.NE.0)) THEN
C       USE THE FILE AS IT IS: DON'T USE A PREDICTION FILE
        FFNAM(1,OBPAC(IPACKAGE)) = TRIM(AFNAM(OBPAC(IPACKAGE)))         !load for obs-only runs
        FFNAM(2,OBPAC(IPACKAGE)) = NO_FILE
        FFNAM(3,OBPAC(IPACKAGE)) = TRIM(AFNAM(OBPAC(IPACKAGE)))         !load for pes runs
      ELSE IF ((IPRED.NE.0).AND.(IOBS.EQ.0)) THEN
C       USE THE FILE AS IT IS: DON'T USE AN OBSERVATION FILE
        FFNAM(1,OBPAC(IPACKAGE)) = NO_FILE
        FFNAM(2,OBPAC(IPACKAGE)) = TRIM(AFNAM(OBPAC(IPACKAGE)))
        FFNAM(3,OBPAC(IPACKAGE)) = NO_FILE
      END IF
      RETURN

605   FORMAT (/,' OBSERVATION ',I6,' EQUALS ZERO, THE STATISTIC ',
     &        'CAN NOT BE A',/,' COEFFICIENT OF VARIATION (ISTAT=2)',
     &        ' -- STOP EXECUTION (SPRD1OB1RP)')
560   FORMAT (/,' FOR OBS ',I6,' STATISTIC RELATED TO WEIGHT < OR =0',/,
     &        ' -- STOP EXECUTION (SPRD1OB1RP)',/)
8000  WRITE(*,8010)
8010  FORMAT(1X,'ERROR PROCESSING NEW MODFLOW HEAD OBSERVATION FILE(S)')
      CLOSE(PIOUT)
      CLOSE(OIOUT)
      GO TO 9890
C9000  WRITE(IOUTP,9010) MOBFILE(1:NBLNK(MOBFILE))
C9010  FORMAT('CANNOT OPEN MODFLOW OBSERVATION FILE ',A,'.')
C      GO TO 9870
9100  WRITE(IOUTP,9110) MOBFILE(1:NBLNK(MOBFILE))
9110  FORMAT('ERROR READING MODFLOW OBSERVATION FILE ',A,'.')
      GO TO 9870
9200  WRITE(IOUTP,9210) MOBFILE(1:NBLNK(MOBFILE))
9210  FORMAT('UNEXPECTED END ENCOUNTERED TO MODFLOW ',
     +'OBSERVATION FILE ',A,'.')
      GO TO 9870
C9450  WRITE(IOUTP,9460) MOBFILE(1:NBLNK(MOBFILE))
C9460  FORMAT('ERROR READING COVARIANCE MATRIX FROM MODFLOW ',
C     +'OBSERVATION FILE ',A,'.')
C      GO TO 9870
C9500  WRITE(IOUTP,9510) MOBFILE(1:NBLNK(MOBFILE))
C9510  FORMAT('UNEXPECTED END TO COVARIANCE MATRIX IN MODFLOW ',
C     +'OBSERVATION FILE ',A,'.')
C      GO TO 9870
9870  CONTINUE
9890  CONTINUE
      INQUIRE(UNIT=IIN,OPENED=LOP)
      IF (LOP) CLOSE(IIN)
      WRITE(IOUTP,9895)
9895  FORMAT('STOP EXECUTION (SPRD1OB1RP)')
      IFAIL=1
      RETURN

      END

c=======================================================================
      SUBROUTINE SPRD1HOB1AL(IFAIL,MHOBFILE,IIN,NH,MOBS,MAXM,NHT,
     +                          MOBSAR,NHAR,ND,NHOBLINES)
C=======================================================================
c     READ HOB FOR DIMENSIONS, RETURN DIMENSIONS TO MAIN PROGRAM
C     VERSION 1, JUN 2003, MJT
C     NOTE - DIMENSIONING VARIABLE NHT COMES FROM THIS ROUTINE (EQ. NH)

      USE DRIVER
      IMPLICIT NONE

      INTEGER NBLNK,IIN,IERR,IFAIL,NH,NHT,MAXM,MOBS,ISTART,ISTOP,ILINE,
     +        ND,NHAR,MOBSAR,LLOC,NHOBLINES
      REAL R
      CHARACTER*(*) MHOBFILE
      LOGICAL LOP
c     ------------------------------------------------------------------

      INQUIRE(UNIT=IIN,OPENED=LOP)
      IF (LOP) THEN
          REWIND(IIN)
        ELSE
          OPEN(IIN,FILE=MHOBFILE,STATUS='OLD',IOSTAT=IERR)
          IF(IERR.NE.0) THEN
            WRITE(IOUTP,2) MHOBFILE(1:NBLNK(MHOBFILE))
2           FORMAT('ERROR OPENING FILE ',A,'.')
            IFAIL = 1
            RETURN
          END IF
      END IF

C     READ HEADERS
      ILINE=0
10    ILINE=ILINE+1
      READ(IIN,'(A)',ERR=9100,END=9100) CLINE
      IF(CLINE.EQ.' ') GO TO 10
      CALL Ulshift(CLINE)
      IF(CLINE(1:1).EQ.'#') THEN
        GO TO 10
      END IF

C     ITEM 1
      LLOC=1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NH,R,IOUTP,IIN)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,MOBS,R,IOUTP,IIN)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,MAXM,R,IOUTP,IIN)

C     RETURN WITH DIMENSIONS
      ND = ND + NH
      NHT = NHT + NH
      NHAR = NH
      IF (NH.EQ.0) NHAR = 1
      MOBSAR = MOBS
      IF (MOBS.EQ.0) MOBSAR = 1
20    ILINE=ILINE+1
      READ(IIN,'(A)',ERR=9100,END=9200) CLINE
      GO TO 20
9200  NHOBLINES = ILINE
      REWIND(IIN)
      RETURN

9100  WRITE(IOUTP,9110) MHOBFILE(1:NBLNK(MHOBFILE))
9110  FORMAT('ERROR READING MODFLOW HEAD OBSERVATION FILE ',A,'.')
      WRITE(IOUTP,9120)
9120  FORMAT('STOP EXECUTION (SPRD1HOB1AL)')
      IFAIL = 1
      RETURN

      END

c=======================================================================
      SUBROUTINE SPRD1HOB1RP(IFAIL,IOBS,OBSNME,PREDNME,MHOBFILE,IIN,
     +  IPRED,NH,MOBS,MAXM,MPR,IPR,ND,NHAR,FFNAM,MOBSAR,AFNAM,NHT,
     +  NIUNIT,NHOBLINES,NAMES,INAMES,IAPLOT,VMULT,NSETS,ISETPLT,
     +  ISETTYP,IOMIT,ISYMBOL,IHWT,OBSTYPE,XOPR,STATIST,ISTATIST)
C=======================================================================
C     READ HOB PACKAGE FULLY
C     VERSION 1, JUN 2003, MJT (BORROWS FROM MF2K CODE)

C     - IDENTIFY MEMBERS OF PREDICTION/OBSERVATION/OMIT SETS
C     - SCALE STATISTIC BY VMULT FOR SET
C     - WRITE ANY NEW PAKCAGE INPUT FILES AS REQUIRED

      USE DRIVER
      IMPLICIT NONE

      INTEGER I, ITT, IWT, K, M, MAXM, ML, ML1,
     +        MLAY, MM, MOBS, N1, ND, NDER, NH, NT, NTC,MN,
     +        IPR, MPR, IFAIL,IIN,IOBS,IPRED,LLOC,N,ILINE,NBLNK,
     +        NHAR, IHEADER,ISTART,ISTOP,IOMIT,N1OMIT,NHADJUST,
     +        MOBSAR, NHT, IGETUNIT, ITTCNT, IHWT,
     +        PIOUT, OIOUT,NIUNIT,IERR,NHOBLINES,INAMES,NSETS,IFOUND
C      IOFF, J, JOFF,JREFSP,
      INTEGER IPLOT(ND+IPR+MPR), IHVAR(3),IREFSP(3,ND),ISYMBOL(NSETS),
     +        IAPLOT(ND+IPR+MPR),ISETPLT(NSETS,ISETCNT),ISETTYP(NSETS),
     +        ISTATIST(ND+IPR+MPR)
      REAL    TOFFSET,ROFF,COFF,R,TOMULTH,EVH, HOBS,WTVAR,PR, WT1, WT2,
     +        RHVAR(3),VMULT(NSETS),STATIST(ND+IPR+MPR),RDUM
      DIMENSION NDER(5,NHAR), HOBS(ND+IPR+MPR), COFF(NHAR), ROFF(NHAR),
     +        MLAY(MAXM,MOBSAR), TOFFSET(ND),PR(MAXM,MOBSAR),IWT(ND),
     +        WT1(ND), WT2(ND), ITT(ND)
      CHARACTER*1 LNUM_HOB(NHOBLINES),XOPR(ND+IPR+MPR)
      CHARACTER*(*) MHOBFILE
      CHARACTER*12 OBSNME(ND+IPR+MPR),PREDNME(ND),OBSNOM(ND)
      CHARACTER*12 NAMES(ND+MPR+IPR),OBSTYPE(ND+IPR+MPR)
      CHARACTER*100 FFNAM(3,NIUNIT), AFNAM(NIUNIT)
      CHARACTER*300 HEADERS(20)
      CHARACTER*4 SPACES
      CHARACTER*7 NO_FILE
      LOGICAL LOP,MULTIHEAD
c     ------------------------------------------------------------------

C   INITIALIZE

      IFAIL = 0
      IPRED = 0
      IOBS  = 0
      ML    = 0
      NT    = 0
      NTC   = 0
      ITT   = 0
      MLAY  = 0
      PR    = 0.0
      NDER  = 0
      WT    = 0.
      WT1   = 0.
      WT2   = 0.
      IREFSP = 0
      NO_FILE = 'NO_FILE'
      SPACES  = '    '
      LNUM_HOB = ' '
      WTVAR = 0.

C   MAIN ROUTINE

      INQUIRE(UNIT=IIN,OPENED=LOP)
      IF (LOP) THEN
          REWIND(IIN)
        ELSE
          OPEN(IIN,FILE=MHOBFILE,STATUS='OLD',IOSTAT=IERR)
          IF(IERR.NE.0) THEN
            WRITE(IOUTP,2) MHOBFILE(1:NBLNK(MHOBFILE))
2           FORMAT('ERROR OPENING FILE ',A,'.')
            IFAIL = 1
            RETURN
          END IF
      END IF

C   READ AND STORE HEADERS: IHEADER = NUMBER OF HEADER LINES

      ILINE=0
10    ILINE=ILINE+1
      READ(IIN,'(A)',ERR=9100,END=9200) CLINE
      IF(CLINE.EQ.' ') GO TO 10
      CALL Ulshift(CLINE)
      IF(CLINE(1:1).EQ.'#') THEN
        HEADERS(ILINE) = CLINE
        GO TO 10
      ELSE
        IHEADER = ILINE - 1
      END IF

C   ITEM 1
      LLOC=1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NH,R,IOUTP,IIN)
      IHVAR(1) = NH
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,MOBS,R,IOUTP,IIN)
      IHVAR(2) = MOBS
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,MAXM,R,IOUTP,IIN)
      IHVAR(3) = MAXM

C   ITEM 2
      ILINE = ILINE+1
      READ(IIN,*) TOMULTH, EVH
      RHVAR(1) = TOMULTH
      RHVAR(2) = EVH
      IF(EVH.LE.0.0)THEN
        WRITE(IOUTP,15) MHOBFILE(1:NBLNK(MHOBFILE))
15      FORMAT(A,' - ILLEGAL EVH VALUE')
        GO TO 9890
      END IF

C   LOOP THROUGH HEAD OBSERVATIONS
      ITTCNT = 0
      DO 90 N = 1, NH
C      FIRST TRANSIENT OBSERVATIONS AT ONE LOCATION (..NOT THE HEADER..)
          IF (N.GT.1) THEN
            IF (NDER(4,N-1).LT.0.OR.NTC.LT.NT) THEN
              IF (NDER(4,N-1).LT.0) THEN
                N1 = N - 1
                NT = -NDER(4,N1)
                NTC = 1
C               ITEM 6 (FIRST OCCURENCE) FOR THIS TRANSIENT OBSERVATION
                READ (IIN,*) OBSNOM(N1), IREFSP(1,N1), TOFFSET(N1),
     +                    HOBS(N1), WT1(N1), WT2(N1), IWT(N1), IPLOT(N1)
C               IS THE WHOLE GROUP OMITTED?
                IF (N1OMIT.EQ.1) THEN
                  LNUM_HOB(N1) = 'X'
                  GOTO 39
                ENDIF
C               CHECK FOR CALIBRATION / PREDICTION / OMIT
                IFOUND = 0
                DO K = 1,NSETS
                  DO MM =1,ISYMBOL(K)
C                   IS THIS PLOT-SYMBOL LISTED AS A SET-MEMBER?
                    IF(IPLOT(N1).EQ.ISETPLT(K,MM)) THEN
C                     WHAT TYPE OF SET
                      IF (ISETTYP(K).EQ.0) THEN
C                       OMIT
                        LNUM_HOB(N1) = 'X'
                        IREFSP(2,MN) = IREFSP(2,MN)+1
                        IREFSP(3,MN) = IREFSP(3,MN)+1
                        IFOUND = 1
                      ELSEIF (ISETTYP(K).EQ.1) THEN
C                       CALIBRATION
                        IF(.NOT.MULTIHEAD) IOBS = IOBS + 1              !MJT OCT2005
                        LNUM_HOB(N1) = 'C'
                        OBSNME(IOBS) = OBSNOM(N1)
                        IREFSP(3,MN) = IREFSP(3,MN)+1
                        IFOUND = 1
                        IF(MULTIHEAD)MULTIHEAD=.FALSE.                  !MJT OCT2005
                      ELSEIF (ISETTYP(K).EQ.2) THEN
C                       PREDICTION
                        IF(.NOT.MULTIHEAD) IPRED = IPRED + 1            !MJT OCT2005
                        LNUM_HOB(N1) = 'P'
                        PREDNME(IPRED) = OBSNOM(N1)
                        IREFSP(2,MN) = IREFSP(2,MN)+1
                        IFOUND = 1
                        IF(MULTIHEAD)MULTIHEAD=.FALSE.                  !MJT OCT2005
                      ELSE
                        WRITE(IOUTP,20)
20                      FORMAT(/,1X,'ERROR ENCOUNTERED WITH SET TYPE')
                        GOTO 9890
                      END IF
                    END IF
                  END DO
                END DO
                IF (IFOUND.EQ.0) THEN
C                 NOT A MEMBER OF ANY SET SO IS JUST A VALID OBSERVATION
                  LNUM_HOB(N1) = 'O'
                  OBSNME(IOBS) = OBSNOM(N1)
                  IREFSP(3,MN) = IREFSP(3,MN)+1
                ENDIF
C               RELOAD THE GLOBAL DATA FOR THIS FIRST OCCURENCE
                NAMES(INAMES)   = OBSNOM(N1)
                OBSTYPE(INAMES) = 'HEADS'
                IAPLOT(INAMES)  = IPLOT(N1)
                XOPR(INAMES)    = LNUM_HOB(N1)
                ISTATIST(INAMES)= IWT(N1)
                RDUM = WT1(N1)
C               VMULT SCALING FOR THE STATISTIC
                CALL SPRD1SETS1VM(IFAIL,RDUM,IWT(N1),VMULT,NSETS,
     +                          MHOBFILE,IPLOT(N1),ISETPLT,ISYMBOL)
                STATIST(INAMES) = RDUM
              ENDIF
C             SUBSEQUENT OBSERVATIONS AT ONE LOCATION
   39         NTC = NTC + 1
C             ASSIGN INFORMATION WHICH STAYS THE SAME
              DO 40 I = 1, 3
                NDER(I,N) = NDER(I,N1)
   40         CONTINUE
              ROFF(N) = ROFF(N1)
              COFF(N) = COFF(N1)
              IF (NDER(1,N1).LT.0) THEN
                ML1 = ML
                ML = ML + 1
                DO 60 M = 1, MAXM
                  PR(M,ML) = PR(M,ML1)
                  MLAY(M,ML) = MLAY(M,ML1)
   60           CONTINUE
              ENDIF
C             READ INFORMATION UNIQUE TO THIS OBSERVATION (ITEM 6)
              READ (IIN,*) OBSNOM(N), IREFSP(1,N), TOFFSET(N), HOBS(N),
     +                     WT1(N), WT2(N), IWT(N), IPLOT(N)
C             IS THE WHOLE GROUP OMITTED?
              IF (N1OMIT.EQ.1) THEN
                LNUM_HOB(N) = 'X'
                IOMIT = IOMIT + 1
                GOTO 70
              ENDIF
C             CHECK FOR CALIBRATION / PREDICTION / OMIT
              IFOUND = 0
              DO K = 1,NSETS
                DO MM =1,ISYMBOL(K)
C                 IS THIS PLOT-SYMBOL LISTED AS A SET-MEMBER?
                  IF(IPLOT(N).EQ.ISETPLT(K,MM)) THEN
C                   WHAT TYPE OF SET
                    IF (ISETTYP(K).EQ.0)THEN
C                     OMIT
                      LNUM_HOB(N) = 'X'
                      IOMIT = IOMIT + 1
                      IREFSP(2,MN) = IREFSP(2,MN)+1
                      IREFSP(3,MN) = IREFSP(3,MN)+1
                      IFOUND = 1
                    ELSEIF (ISETTYP(K).EQ.1)THEN
C                     CALIBRATION
                      IF(.NOT.MULTIHEAD) IOBS = IOBS + 1                !MJT OCT2005
                      LNUM_HOB(N) = 'C'
                      OBSNME(IOBS) = OBSNOM(N)
                      IREFSP(3,MN) = IREFSP(3,MN)+1
                      IFOUND = 1
                      IF(MULTIHEAD)MULTIHEAD=.FALSE.                    !MJT OCT2005
                    ELSEIF (ISETTYP(K).EQ.2)THEN
C                     PREDICTION
                      IF(.NOT.MULTIHEAD) IPRED = IPRED + 1              !MJT OCT2005
                      LNUM_HOB(N) = 'P'
                      PREDNME(IPRED) = OBSNOM(N)
                      IREFSP(2,MN) = IREFSP(2,MN)+1
                      IFOUND = 1
                      IF(MULTIHEAD)MULTIHEAD=.FALSE.                    !MJT OCT2005
                    ELSE
                      WRITE(IOUTP,65)
65                    FORMAT(/,1X,'ERROR ENCOUNTERED WITH SET TYPE')
                      GOTO 9890
                    END IF
                  ENDIF
                END DO
              END DO
              IF (IFOUND.EQ.0) THEN
C             NOT A MEMBER OF ANY SET SO IS JUST A VALID OBSERVATION
                IF(.NOT.MULTIHEAD) IOBS = IOBS + 1                      !MJT OCT2005
                LNUM_HOB(N) = 'O'
                OBSNME(IPRED) = OBSNOM(N)
                IREFSP(3,MN) = IREFSP(3,MN)+1
                IF(MULTIHEAD)MULTIHEAD=.FALSE.                          !MJT OCT2005
              ENDIF
70            INAMES = INAMES + 1
              NAMES(INAMES)   = OBSNOM(N)
              OBSTYPE(INAMES) = 'HEADS'
              IAPLOT(INAMES)  = IPLOT(N)
              XOPR(INAMES)    = LNUM_HOB(N)
              ISTATIST(INAMES)= IWT(N)
              IF (ITT(ITTCNT).EQ.1) RDUM = WT1(N)
              IF (ITT(ITTCNT).EQ.2) RDUM = WT2(N)
C             VMULT SCALING FOR THE STATISTIC
              CALL SPRD1SETS1VM(IFAIL,RDUM,IWT(N),VMULT,NSETS,
     +                          MHOBFILE,IPLOT(N),ISETPLT,ISYMBOL)
              STATIST(INAMES) = RDUM
              GOTO 80
            ENDIF
          ENDIF
C   ==  READ ITEM 3 (FOR N=1 OR N>1 AND IREFSP>0)
C   ==  USE N1OMIT AS FLAG AND MN AS ROW FOR THE [IREFSP] COUNTER
          N1OMIT = 0
          MN = N
          READ (IIN,*) OBSNOM(N), (NDER(I,N),I=1,3), IREFSP(1,N),
     +      TOFFSET(N), ROFF(N), COFF(N), HOBS(N), WT(N),IWT(N),IPLOT(N)
          IREFSP(2,N) = IREFSP(1,N)
          IREFSP(3,N) = IREFSP(1,N)

C         CHECK FOR CALIBRATION / PREDICTION / OMIT
          IFOUND = 0
          DO K = 1,NSETS
            DO MM =1,ISYMBOL(K)
              IF(IPLOT(N).EQ.ISETPLT(K,MM)) THEN
C               IS THIS PLOT-SYMBOL LISTED AS A SET-MEMBER?
                IF (ISETTYP(K).EQ.0) THEN
C                 OMIT:
C                 SINCE THIS IS MASTER HEADER ALL MULTI-TIME OBS FOR
C                 THIS LOCATION ARE OMITTED: USE N1OMIT FLAG TO INDICATE
                  IOMIT = IOMIT + 1
                  N1OMIT = 1
                  IREFSP(2,N) = 0
                  IREFSP(3,N) = 0
                  LNUM_HOB(N) = 'X'
                  IFOUND = 1
                ELSEIF (ISETTYP(K).EQ.1) THEN
C                 CALIBRATION
                  IOBS = IOBS + 1
                  LNUM_HOB(N) = 'O'
                  MULTIHEAD=.TRUE.                                      !MJT OCT2005
                  IF (IREFSP(1,N).GT.0) IREFSP(3,N) = IREFSP(3,N)-1
                  IFOUND = 1
                ELSEIF (ISETTYP(K).EQ.2) THEN
C                 PREDICTION
                  IPRED = IPRED + 1
                  LNUM_HOB(N) = 'P'
                  MULTIHEAD=.TRUE.                                      !MJT OCT2005
                  IF (IREFSP(1,N).GT.0) IREFSP(2,N) = IREFSP(2,N)-1
                  IFOUND = 1
                ELSE
                  WRITE(IOUTP,73)
73                FORMAT(/,1X,'ERROR ENCOUNTERED WITH SET TYPE')
                  GOTO 9890
                END IF
              ENDIF
            END DO
          END DO
          IF (IFOUND.EQ.0) THEN
C         NOT A MEMBER OF ANY SET SO IS JUST A VALID OBSERVATION
            IOBS = IOBS + 1
            LNUM_HOB(N) = 'O'
            IF (IREFSP(1,N).GT.0) IREFSP(3,N) = IREFSP(3,N)-1
          ENDIF

75        OBSNME(N)       = OBSNOM(N)
          INAMES          = INAMES + 1
          NAMES(INAMES)   = OBSNOM(N)
          OBSTYPE(INAMES) = 'HEADS'
          IAPLOT(INAMES)  = IPLOT(N)
          XOPR(INAMES)    = LNUM_HOB(N)
          ISTATIST(INAMES)= IWT(N)
C         VMULT SCALING FOR THE STATISTIC
          RDUM = WT(N)
          CALL SPRD1SETS1VM(IFAIL,RDUM,IWT(N),VMULT,NSETS,
     +                          MHOBFILE,IPLOT(N),ISETPLT,ISYMBOL)
          STATIST(INAMES) = RDUM
          IF (IREFSP(1,N).LT.0) THEN
            NDER(4,N) = IREFSP(1,N)
          ENDIF

C-------INITIALIZE SOME VARIABLES
          K = NDER(1,N)
C-------READ INFORMATION FOR MULTILAYER OBSERVATIONS (ITEM 4)
          IF (K.LT.0) THEN
            ML = ML + 1
            READ (IIN,*) (MLAY(M,ML),PR(M,ML),M=1,-K)
          ENDIF
C-------READ FLAG FOR USING TEMPORAL CHANGES IN HEAD (ITEM 5)
          IF (NDER(4,N).LT.0) THEN
            ITTCNT = ITTCNT+1
            READ (IIN,*) ITT(ITTCNT)
          ENDIF
   80   CONTINUE
   90 CONTINUE
      CLOSE(IIN)

C      WRITE(IOUTP,*) 'IPRED:',IPRED                                     !MJT OCT2005
C      WRITE(IOUTP,*) ' IOBS:',IOBS                                      !MJT OCT2005
C      WRITE(IOUTP,*) 'IOMIT:',IOMIT                                     !MJT OCT2005

C === WRITE NEW OBSERVATION- AND PREDICTION-ONLY HOB FILES IF NECESSARY

      IF ((IOBS.GT.0).AND.(IPRED.GT.0)) THEN

C       OBSERVATION AND PREDICTION HOB FILE NAMES
        FFNAM(1,28) = OBS_PREF//TRIM(MHOBFILE)                          !load for obs-only runs
        FFNAM(2,28) = PRE_PREF//TRIM(MHOBFILE)
        FFNAM(3,28) = OBS_PREF//TRIM(MHOBFILE)                          !load for pes runs

C    == OBSERVATION ONLY FILE
        OIOUT = IGETUNIT(1,95)
        OPEN(OIOUT,FILE=FFNAM(1,28),STATUS='UNKNOWN',err=8000)
        DO I=1,IHEADER
            WRITE(OIOUT,'(A)') ADJUSTL(TRIM(HEADERS(I)))
        END DO
        WRITE(OIOUT,7000) 'MOD-PREDICT PRODUCED THIS '
7000    FORMAT('#',1X,A,' HOB FILE FOR OBSERVATIONS')
        NHADJUST=IHVAR(1)-IPRED-IOMIT                                   !MJT OCT2005 ASSIGN TO VARIABLE FOR CHECKING
        WRITE(OIOUT,*) NHADJUST,IHVAR(2),IHVAR(3)                       !MULTILAYER OBSERVATIONS GET COMPLICATED!
        WRITE(OIOUT,*) RHVAR(1),RHVAR(2)                                !MULTILAYER OBSERVATIONS GET COMPLICATED!

C    == PREDICTION ONLY FILE
        PIOUT = IGETUNIT(1,95)
        OPEN(PIOUT,FILE=FFNAM(2,28),STATUS='UNKNOWN',err=8000)
        DO I=1,IHEADER
            WRITE(PIOUT,'(A)') ADJUSTL(TRIM(HEADERS(I)))
        END DO
        WRITE(PIOUT,7500) 'MOD-PREDICT PRODUCED THIS '
7500    FORMAT('#',1X,A,' HOB FILE FOR PREDICTIONS')
        NHADJUST=IHVAR(1)-IOBS-IOMIT                                    !MJT OCT2005 ASSIGN TO VARIABLE FOR CHECKING
        WRITE(PIOUT,*) NHADJUST,IHVAR(2),IHVAR(3)                       !MULTILAYER OBSERVATIONS GET COMPLICATED!
        WRITE(PIOUT,*) RHVAR(1),RHVAR(2)                                !MULTILAYER OBSERVATIONS GET COMPLICATED!

        N  = 0
        ML = 0
        ITTCNT = 0
        IHWT = 0

        DO                                                              !MJT OCT2005 REMOVED (J=1,IHVAR(1)) COUNTER
          N=N+1
          IF ((LNUM_HOB(N).EQ.'O').OR.(LNUM_HOB(N).EQ.'C')) THEN

C           IF THIS IS ONLY ONE: SCALE STATISTIC BY VMULT BEFORE WRITING
            IF (IREFSP(2,N).GT.0) THEN
              IF (LNUM_HOB(N).EQ.'C') THEN
                CALL SPRD1SETS1VM(IFAIL,WT(N),IWT(N),VMULT,
     +                        NSETS,MHOBFILE,IPLOT(N),ISETPLT,ISYMBOL)
              END IF
              CALL UWTCALC(IFAIL,HOBS(N),IWT(N),WT(N),EVH,WTVAR,N)
              IHWT = IHWT + 1
              HWT(N) = WTVAR
            ENDIF
            WRITE(OIOUT,1000) OBSNOM(N), (NDER(I,N),I=1,3),IREFSP(2,N),
     +          TOFFSET(N),ROFF(N),COFF(N),HOBS(N),WT(N),IWT(N),IPLOT(N)
            IF ((NDER(1,N).LT.0)) THEN
              ML = ML + 1
              WRITE (OIOUT,*) (MLAY(M,ML),PR(M,ML),M=1,-NDER(1,N))
            ENDIF
            IF (IREFSP(2,N).LT.0) THEN
              ITTCNT = ITTCNT + 1
              WRITE(OIOUT,*) SPACES, ITT(ITTCNT)
              DO K = 1,ABS(IREFSP(2,N))
                IF (ITT(ITTCNT).EQ.1) THEN
C                 IF A CALIBRATION SET MEMEBER SCALE THIS STATISTIC
                  IF (LNUM_HOB(N).EQ.'C') THEN
                    CALL SPRD1SETS1VM(IFAIL,WT1(N),IWT(N),VMULT,
     +                       NSETS,MHOBFILE,IPLOT(N),ISETPLT,ISYMBOL)
                  END IF
                  CALL UWTCALC(IFAIL,HOBS(N),IWT(N),WT1(N),EVH,WTVAR,N)
                ELSEIF (ITT(ITTCNT).EQ.2) THEN
                  IF (K.EQ.1) WT2(N) = WT1(N)
                  IF (LNUM_HOB(N).EQ.'C') THEN
                    CALL SPRD1SETS1VM(IFAIL,WT2(N),IWT(N),VMULT,
     +                       NSETS,MHOBFILE,IPLOT(N),ISETPLT,ISYMBOL)
                  ENDIF
                  CALL UWTCALC(IFAIL,HOBS(N),IWT(N),WT2(N),EVH,WTVAR,N)
                ENDIF
C               WRITE THE OBSERVATION
                WRITE (OIOUT,1100) OBSNOM(N), IREFSP(1,N), TOFFSET(N),
     +                         HOBS(N), WT1(N), WT2(N), IWT(N), IPLOT(N)
                IHWT = IHWT + 1
                HWT(N) = WTVAR
                N = N + 1                     !COUNTER AFTER NOT BEFORE!
              END DO
              N=N-1
            ENDIF

          ELSEIF (LNUM_HOB(N).EQ.'P') THEN

C           IF THIS IS ONLY ONE: SCALE STATISTIC BY VMULT BEFORE WRITING
            IF (IREFSP(3,N).GT.0) THEN
              CALL SPRD1SETS1VM(IFAIL,WT(N),IWT(N),VMULT,
     +                         NSETS,MHOBFILE,IPLOT(N),ISETPLT,ISYMBOL)
              CALL UWTCALC(IFAIL,HOBS(N),IWT(N),WT(N),EVH,WTVAR,N)
              IHWT = IHWT + 1
              HWT(N) = WTVAR
            END IF
            WRITE(PIOUT,1000) OBSNOM(N), (NDER(I,N),I=1,3), IREFSP(3,N),
     +          TOFFSET(N),ROFF(N),COFF(N),HOBS(N),WT(N),IWT(N),IPLOT(N)
            IF ((NDER(1,N).LT.0)) THEN
              ML = ML + 1
              WRITE (PIOUT,*) (MLAY(M,ML),PR(M,ML),M=1,-NDER(1,N))
            ENDIF
            IF (IREFSP(3,N).LT.0) THEN
              ITTCNT = ITTCNT + 1
              WRITE(PIOUT,*) SPACES, ITT(ITTCNT)
              DO K = 1,ABS(IREFSP(3,N))
C               SCALE STATISTIC BY VMULT BEFORE WRITING
                IF (ITT(ITTCNT).EQ.1) THEN
                  CALL SPRD1SETS1VM(IFAIL,WT1(N),IWT(N),VMULT,
     +                          NSETS,MHOBFILE,IPLOT(N),ISETPLT,ISYMBOL)
                  CALL UWTCALC(IFAIL,HOBS(N),IWT(N),WT1(N),EVH,WTVAR,N)
                ELSEIF (ITT(ITTCNT).EQ.2) THEN
                  IF (K.EQ.1) WT2(N) = WT1(N)
                  CALL SPRD1SETS1VM(IFAIL,WT2(N),IWT(N),VMULT,
     +                          NSETS,MHOBFILE,IPLOT(N),ISETPLT,ISYMBOL)
                  CALL UWTCALC(IFAIL,HOBS(N),IWT(N),WT2(N),EVH,WTVAR,N)
                ENDIF
C               WRITE THE PREDICTION
                WRITE (PIOUT,1100) OBSNOM(N), IREFSP(1,N), TOFFSET(N),
     +                         HOBS(N), WT1(N), WT2(N), IWT(N), IPLOT(N)
                IHWT = IHWT + 1
                HWT(N) = WTVAR
                N = N + 1                     !COUNTER AFTER NOT BEFORE!
              END DO
              N=N-1
            ENDIF
          ENDIF
          IF(N.GE.NHOBLINES) EXIT                                       !MJT OCT2005 ADDED EXIT
        END DO

1000    FORMAT (1X,A12,4(1X,I4),5(1X,G12.6),2(1X,I5))
1100    FORMAT (1X,A12,1X,I4,4(1X,G12.6),2(1X,I5))
        CLOSE(OIOUT)
        CLOSE(PIOUT)

      ELSE IF ((IPRED.EQ.0).AND.(IOBS.NE.0)) THEN
C       USE THE FILE AS IT IS: DON'T USE A PREDICTION FILE
        FFNAM(1,28) = TRIM(AFNAM(28))
        FFNAM(2,28) = NO_FILE
        FFNAM(3,28) = TRIM(AFNAM(28))
      ELSE IF ((IPRED.NE.0).AND.(IOBS.EQ.0)) THEN
C       USE THE FILE AS IT IS: DON'T USE AN OBSERVATION FILE
        FFNAM(1,28) = NO_FILE
        FFNAM(2,28) = TRIM(AFNAM(28))
        FFNAM(3,28) = NO_FILE
      ENDIF
      RETURN

8000  WRITE(*,8010)
8010  FORMAT(1X,'ERROR PROCESSING NEW MODFLOW HEAD OBSERVATION FILE(S)')
      CLOSE(PIOUT)
      CLOSE(OIOUT)
      GO TO 9890
C9000  WRITE(IOUTP,9010) MHOBFILE(1:NBLNK(MHOBFILE))
C9010  FORMAT('CANNOT OPEN MODFLOW HEAD OBSERVATION FILE ',A,'.')
C      GO TO 9890
9100  WRITE(IOUTP,9110) MHOBFILE(1:NBLNK(MHOBFILE))
9110  FORMAT('ERROR READING MODFLOW HEAD OBSERVATION FILE ',A,'.')
      GO TO 9890
9200  WRITE(IOUTP,9210) MHOBFILE(1:NBLNK(MHOBFILE))
9210  FORMAT('UNEXPECTED END ENCOUNTERED TO MODFLOW HEAD ',
     +'OBSERVATION FILE ',A,'.')
      GO TO 9890

9890  IFAIL = 1
      CLOSE(IIN)
      WRITE(IOUTP,9900)
9900  FORMAT('STOP EXECUTION (SPRD1HOB1RP)')
      RETURN

      END

C=======================================================================
      SUBROUTINE SPRD1ADV2AL(NIUNIT,IUNIT,AFNAM,IFAIL,ND,NPTH,NTT2,
     +                                                            KTDIM)
C=======================================================================
C     READ ADV2 FOR DIMENSIONS, RETURN DIMENSIONS TO MAIN PROGRAM
C     VERSION 1, JUN 2003, MJT

      USE DRIVER
      IMPLICIT NONE

      INTEGER NIUNIT,IUNIT(NIUNIT),IFAIL,ND,NPTH,NTT2,KTDIM,IERR,
     +        IOUADV,LLOC,NBLNK,ISTOP,ISTART,ILINE
      REAL DUM
      CHARACTER*100 AFNAM(NIUNIT)
      CHARACTER*200 LINE
      LOGICAL LOP
c     ------------------------------------------------------------------

      IOUADV = IUNIT(29)
      INQUIRE(UNIT=IUNIT(29),OPENED=LOP)
      IF (LOP) THEN
          REWIND(IUNIT(29))
        ELSE
          OPEN(IUNIT(29),FILE=AFNAM(29),STATUS='OLD',IOSTAT=IERR)
          IF(IERR.NE.0) THEN
            WRITE(IOUTP,2) AFNAM(29)(1:NBLNK(AFNAM(29)))
    2       FORMAT('ERROR OPENING .ADV FILE ',A,'.')
            IFAIL = 1
            RETURN
          END IF
      END IF

C     READ HEADERS
      ILINE=0
10    ILINE=ILINE+1
      READ(IOUADV,'(A)',ERR=999,END=999) LINE
      IF(LINE.EQ.' ') GO TO 10
      CALL Ulshift(LINE)
      IF(LINE(1:1).EQ.'#') THEN
        GO TO 10
      END IF

      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NPTH,DUM,0,IOUADV)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NTT2,DUM,0,IOUADV)
      IF (NLAY.EQ.1) THEN
        KTDIM = 2
      ELSE
        KTDIM = 3
      ENDIF
C     RETURN WITH DIMENSIONS
      ND = ND + KTDIM*NTT2
      CLOSE(IOUADV)
      RETURN

  999 WRITE(IOUTP,1000) AFNAM(29)(1:NBLNK(AFNAM(29)))
 1000 FORMAT(//,1X,'ERROR PROCESSING .ADV FILE ',A)
      IFAIL = 1
      WRITE(IOUTP,1050)
 1050 FORMAT('STOP EXECUTION (SPRD1ADV2AL)')
      RETURN

      END

C=======================================================================
      SUBROUTINE SPRD1ADV2RP(NIUNIT,IUNIT,IPR,MPR,NQT,NHT,AFNAM,
     +                     FFNAM,IOBS,IPRED,IFAIL,ND,
     +                     OBSNME,NPTH,NTT2,KTDIM,IWTQD,NAMES,
     +                     INAMES,IAPLOT,VMULT,NSETS,ISETPLT,ISETTYP,
     +                     IOMIT,ISYMBOL,OBSTYPE,XOPR,STATIST,ISTATIST)
C=======================================================================
C     READ ADV2 PACKAGE FULLY
C     VERSION 1, JUN 2003, MJT (BORROWS FROM MF2K CODE)

C     - IDENTIFY MEMBERS OF PREDICTION/OBSERVATION/OMIT SETS
C     - SCALE STATISTIC BY VMULT FOR SET
C     - WRITE ANY NEW PACKAGE INPUT FILES AS REQUIRED
C
C     NOTE:   FOR EACH 'OBSERVATION' IN THE ADV INPUT FILE THIS
C             TRANSLATES INTO KTDIM OBSERVATIONS IN THE UNDERSCORE FILES

      USE DRIVER
      IMPLICIT NONE

      INTEGER IOUADV, NPTH, NTT2, IOUTT2,KTDIM,KTFLG,KTREV,II,ND, NBOTM,
     +        NIUNIT, LLOC, IDUM, NTTOB1, NTTOB2, IPR, MPR,IROW,ICOL,
     +        IOWTQAD, IERR, NBLNK, IPRED, NHT, NQT, IOWTQ,ISTOP,ISTART,
     +        N, I, I2, IPNT, IPRN,IXWT, IYWT, IZWT, J, K,NTPNT,T2LAY,
     +        T2COL, T2ROW, IOBS,ILINE, NPTHPR, NPTHOB, IFAIL,IOBHEADER,
     +        OIOUT,PIOUT,IGETUNIT,IWTQD,IR,IC,IT, L, INAMES,NSETS,ONE,
     +        IPROW,IPCOL,IOMIT,MM,NN,IFOUND,INAMESOLD,KR,MR,KC,MC,
     +        IACOL
      INTEGER ICLS(3,NPTH), NPNT(NPTH), NPNT_OB(NPTH), NPNT_PR(NPTH),
     +        IPCNT(NPTH), IOCNT(NPTH), IPLOT(ND+IPR+MPR),IUNIT(NIUNIT),
     +        IT2OFF(3,ND),IIWT(3,ND),IAPLOT(ND+MPR+IPR),ISYMBOL(NSETS),
     +        ISETPLT(NSETS,ISETCNT),ISETTYP(NSETS),IOMCNT(NPTH),
     +        ISTATIST(ND+IPR+MPR)
      REAL    FSNK, ADVSTP, DUM, BLANK, T2COF, T2LOF, T2ROF, ZWT,XWT,YWT
      REAL    POFF(3,NPTH),TT2(NTT2),RT2OFF(3,ND),PRST(NCOL,NROW,NLAY),
     +        WTQ(IWTQD,IWTQD),WTQT(IWTQD),RXWT(IWTQD),RYWT(IWTQD),
     +        RZWT(IWTQD),VMULT(NSETS),RDUMWT,RONE,WTVAR,
     +        STATIST(ND+IPR+MPR)
C PRST(NCOL,NROW,NBOTM)
      CHARACTER*24  ANAME
      CHARACTER*100 AFNAM(NIUNIT),FFNAM(3,NIUNIT)
      CHARACTER*4   ACHAR,SPACES
      CHARACTER*20  FMTIN,FMTOUT,AFMT
      CHARACTER*200 LINE
      CHARACTER*12  OBSNME(ND+IPR+MPR),NAMES(ND+IPR+MPR),
     +              OBSTYPE(ND+IPR+MPR)
      CHARACTER*300 OBHEADERS(20)
      CHARACTER*1   OBPRED(NPTH,NTT2),XOPR(ND+IPR+MPR)
      CHARACTER*7 NO_FILE
      LOGICAL LOP
c     ------------------------------------------------------------------

C   MAINLY LOCAL POINTERS UNLIKE MF2K - THIS IS BECUASE OF 'OMIT'
      ANAME = 'POROSITY'
      IPRED = 0
      IOBS  = 0
      IOMIT = 0
      ILINE = 0
      ONE   = 1
      RONE  = 1.0
      SPACES = '    '
      INAMESOLD = INAMES
      NO_FILE='NO_FILE'
      IPLOT = -99

  200 FORMAT (' NUMBER OF PARTICLES ............................')
  505 FORMAT (/,' ERRORS IN ADVECTIVE-TRANSPORT DATA -- STOP EXECUTION')
  540 FORMAT (I3,'-',I3,1X,A12,2X,G15.8,3I4,1X,3(F6.3,1X))
  545 FORMAT (40I5)

C==== START READ_ADV2 ROUTINE ====

      IOUADV = IUNIT(29)
      INQUIRE(UNIT=IUNIT(29),OPENED=LOP)
      IF (LOP) THEN
          REWIND(IUNIT(29))
        ELSE
          OPEN(IUNIT(29),FILE=AFNAM(29),STATUS='OLD',IOSTAT=IERR)
          IF(IERR.NE.0) THEN
            WRITE(IOUTP,2) AFNAM(29)(1:NBLNK(AFNAM(29)))
    2       FORMAT('ERROR OPENING .ADV FILE ',A,'.')
            IFAIL = 1
            RETURN
          END IF
      END IF

C     READ AND STORE HEADERS
      ILINE=0
10    ILINE=ILINE+1
      READ(IOUADV,'(A)',ERR=999,END=999) LINE
      IF(LINE.EQ.' ') GO TO 10
      CALL ULSHIFT(LINE)
      IF(LINE(1:1).EQ.'#') THEN
        OBHEADERS(ILINE) = LINE
        GO TO 10
      ELSE
        IOBHEADER = ILINE-1
      END IF

      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NPTH,DUM,0,IOUADV)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NTT2,DUM,0,IOUADV)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IOUTT2,DUM,0,IOUADV)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,KTFLG,DUM,0,IOUADV)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,KTREV,DUM,0,IOUADV)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,ADVSTP,0,IOUADV)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,FSNK,0,IOUADV)
      NPTHPR = NPTH
      NPTHOB = NPTH
      IF (NLAY.EQ.1) THEN
        KTDIM = 2
      ELSE
        KTDIM = 3
      ENDIF
      IF (KTREV.NE.-1 .AND. KTREV.NE.1) THEN
        WRITE (IOUTP,5)
  5     FORMAT (
     +  ' KTREV NEEDS TO BE EQUAL TO -1 OR 1.  STOP EXECUTION ',
     +  '(READADV)')
        IFAIL = 1
        RETURN
      ENDIF

C   READ POROSITIES (ITEM 1)
      DO K = 1, NLAY
       CALL U2DREL(PRST(1,1,K),ANAME,NROW,NCOL,K,IOUADV,0)
c       ACNTRL(K) = CNTRL
C       IF(LAYCBD(K).NE.0) CALL U2DREL(PRST(1,1,K+1),                   !LBOTM
C     &      ANAME(2),NROW,NCOL,K,IOUADV,IOUTP)
      END DO

C   READ OBSERVATIONS
      NTPNT = 0
      IPCNT = 0
      IOCNT = 0
      IOMCNT = 0
      IF (KTDIM.NE.1) THEN
        IF (NLAY.GT.1) KTDIM = 3
c       I2 WAS COUNTER FOR ALL OBSERVATIONS FROM ALL PACKAGES           !USE WMROW AND WMCOL AS COUNTERS
C        I2 = NHT + NQT + 1
C         NOW I2 IS LOCAL
        I2 = 1
        DO 80 I = 1, NPTH
C-------  READ ADV ITEM 2
          READ(IOUADV,'(A)',ERR=999,END=999) LINE
          ILINE = ILINE + 1
          LLOC = 1
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NPNT(I),DUM,IOUTP,IOUADV)
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ICLS(1,I),DUM,IOUTP,
     +                                                           IOUADV)
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ICLS(2,I),DUM,IOUTP,
     +                                                           IOUADV)
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ICLS(3,I),DUM,IOUTP,
     +                                                           IOUADV)
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,POFF(1,I),IOUTP,IOUADV)
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,POFF(2,I),IOUTP,IOUADV)
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,POFF(3,I),IOUTP,IOUADV)
          IF(NPNT(I).LE.0) THEN
            WRITE(IOUTP,505)
            WRITE(IOUTP,*) ' NPNT MUST BE LARGER THAN 0'
            STOP
          ENDIF
          NPNT_OB(I) = NPNT(I)
          NPNT_PR(I) = NPNT(I)
C         COUNTERS FOR NPTH FOR EACH OF PREDICTIONS AND OBSERVATIONS
          DO 70 IPNT = 1, NPNT(I)
            NTPNT = NTPNT + 1
C           COUNTERS BELOW WOULD BE USED FOR FULL WEIGHT MATRIX
C            I11 = I2 - NHT
C            I12 = I11 + 1
C            I13 = I11 + 2
C---------- READ ADV ITEM 3
            READ(IOUADV,'(A)',ERR=999,END=999) LINE
            ILINE = ILINE + 1
            LLOC = 1
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,N,DUM,IOUTP,IOUADV)
            OBSNME(I2)=LINE(ISTART:ISTOP)
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,T2LAY,DUM,IOUTP,IOUADV)
            IT2OFF(1,I2)=T2LAY
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,T2ROW,DUM,IOUTP,IOUADV)
            IT2OFF(2,I2)=T2ROW
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,T2COL,DUM,IOUTP,IOUADV)
            IT2OFF(3,I2)=T2COL
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,T2LOF,IOUTP,IOUADV)
            RT2OFF(1,I2)=T2LOF
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,T2ROF,IOUTP,IOUADV)
            RT2OFF(2,I2)=T2ROF
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,T2COF,IOUTP,IOUADV)
            RT2OFF(3,I2)=T2COF
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,XWT,IOUTP,IOUADV)
            RXWT(I2) = XWT
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IXWT,DUM,IOUTP,IOUADV)
            IIWT(1,I2) = IXWT
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,YWT,IOUTP,IOUADV)
            RYWT(I2) = YWT
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IYWT,DUM,IOUTP,IOUADV)
            IIWT(2,I2) = IYWT
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,ZWT,IOUTP,IOUADV)
            RZWT(I2) = ZWT
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IZWT,DUM,IOUTP,IOUADV)
            IIWT(3,I2) = IZWT
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,TT2(NTPNT),IOUTP,
     &                  IOUADV)
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IPLOT(I2),DUM,IOUTP,
     &              IOUADV)

C           COUNT PREDICTIONS AND OBSERVATIONS: ADJUST NPTH COUNTERS
            IFOUND = 0
            DO K = 1,NSETS
            DO MM =1,ISYMBOL(K)
C             IS THIS PLOT SYMBOL A SET MEMBER?
              IF(IPLOT(I2).EQ.ISETPLT(K,MM)) THEN
C               WHAT TYPE OF SET
                IF (ISETTYP(K).EQ.0) THEN
C                 OMIT
C                 SINCE THIS IS MASTER HEADER ALL MULTI-TIME OBS FOR
C                 THIS LOCATION ARE OMIITED: USE N1OMIT FLAG TO INDICATE
                  IOMIT = IOMIT + 1*KTDIM                               !CHECK IF THIS SHOULD REALLY BE KTDIM OMITS(!)
                  IOMCNT(I) = IOMCNT(I)+1
                  NPNT_OB(I) = NPNT_OB(I) - 1
                  NPNT_PR(I) = NPNT_PR(I) - 1
                  OBPRED(I,IPNT) = 'X'
                  IFOUND = 1
                ELSEIF (ISETTYP(K).EQ.1) THEN
C                 CALIBRATION
                  IOBS = IOBS + 1*KTDIM
                  IOCNT(I) = IOCNT(I) + 1
                  OBPRED(I,IPNT) = 'C'
                  NPNT_PR(I) = NPNT_PR(I) - 1
                  IFOUND = 1
                ELSEIF (ISETTYP(K).EQ.2) THEN
C                 PREDICTION
                  IPRED = IPRED + 1*KTDIM
                  IPCNT(I) = IPCNT(I) + 1
                  OBPRED(I,IPNT) = 'P'
                  NPNT_OB(I) = NPNT_OB(I) - 1
                  IFOUND = 1
                ELSE
                  WRITE(IOUTP,40)
40                FORMAT(/,1X,'ERROR ENCOUNTERED WITH SET TYPE')
                  GOTO 999
                END IF
              ENDIF
            END DO
            END DO
C           NOT A MEMBER OF ANY SET SO IS JUST A VALID OBSERVATION
            IF (IFOUND.EQ.0) THEN
              IOBS = IOBS + 1*KTDIM
              IOCNT(I) = IOCNT(I) + 1
              OBPRED(I,IPNT) = 'O'
              NPNT_PR(I) = NPNT_PR(I) - 1
            ENDIF
55          CONTINUE

c           DON'T KNOW YET IF THERE IS A V-C MATRIX - SO, MAKE THESE
C           WEIGHT STATISTIC CALCULATIONS IN CASE
C           **IF WEIGHT INCLUDES HOBS: STOP - NOT IMPLEMENTED IN V.1 FOR ADV YET**
            IF ((IXWT.EQ.2).OR.(IYWT.EQ.2).OR.(IZWT.EQ.2)) STOP
            DO NN=1,KTDIM
              RDUMWT = 0.
              IF (NN.EQ.1) RDUMWT=RXWT(I2)
              IF (NN.EQ.2) RDUMWT=RYWT(I2)
              IF (NN.EQ.3) RDUMWT=RZWT(I2)
C             VMULT SCALING
              CALL SPRD1SETS1VM(IFAIL,RDUMWT,IIWT(NN,I2),VMULT,NSETS,
     +                            AFNAM(29),IPLOT(I2),ISETPLT,ISYMBOL)
C             LOAD THE GLOBAL ARRAYS/LISTS
              INAMES = INAMES + 1
              NAMES(INAMES)   = OBSNME(I2)
              OBSTYPE(INAMES) = 'ADV'
              IAPLOT(INAMES)  = IPLOT(I2)
              XOPR(INAMES)    = OBPRED(I,IPNT)
              STATIST(INAMES) = RDUMWT
              ISTATIST(INAMES)= IIWT(NN,I2)
C             MF2K SCALING
              CALL UWTCALC(IFAIL,RT2OFF(1,I2),IIWT(NN,I2),              !IF STATTYPE=2 TO BE IMPLMENTED, REPLACE (RT2OFF(1,I2)) WITH THE CORRECT HOBS VALUE FOR THE X,Y,OR Z COMPONENT
     +                                            RDUMWT,RONE,WTVAR,N)
C             IF IT IS NOT AN OMIT, INCREMENT THE WEIGHT MATRIX
              IF (OBPRED(I,IPNT).NE.'X') THEN
                WMROW=WMROW+1
                WMCOL=WMCOL+1
                XWTQ(WMCOL,WMROW) = WTVAR
              END IF
            END DO

C           INCREMENT I2 AS A SINGLE COUNTER (NOT BY KTDIM)
            I2 = I2 + 1

   70     CONTINUE
          IF(IPCNT(I)+IOMCNT(I).EQ.NPNT(I)) NPTHOB = NPTHOB - 1
          IF(IOCNT(I)+IOMCNT(I).EQ.NPNT(I)) NPTHPR = NPTHPR - 1
   80   CONTINUE

C     READ WEIGHT MATRIX

        IROW = 0
        IAROW=0
        READ (IOUADV,*) IOWTQAD
        IF (IOWTQAD.GT.0) THEN
          IWTMAT = 1
          WRITE(IOUTP,90) AFNAM(29)
  90      FORMAT(3X,'READING/PARSING FULL WEIGHT MATRIX FROM ',A)
C          IOWTQ = 1
          READ (IOUADV,*) FMTIN, IPRN
          NTTOB1 = 1
          NTTOB2 = NTT2*KTDIM
          DO I = NTTOB1, NTTOB2
            ICOL = 0
            IACOL=0
            IF (MOD(I,KTDIM).EQ.ONE) IROW=IROW+1
C           DEBUG
            READ(IOUADV,FMTIN)(BLANK,J=NTTOB1,I-1),(WTQ(I,J),J=I,NTTOB2)
            DO 110 J = I, NTTOB2
              IF (I.EQ.J) THEN
                IF (WTQ(I,J).LT.0.0) WTQ(I,J) = -WTQ(I,J)
              ELSE
                WTQ(J,I) = WTQ(I,J)
              ENDIF
  110       CONTINUE
C           IDENTIFY AND SCALE ENTRIES FOR THE FULL WEIGHT MATRIX
C            - ROWS FIRST (THERE ARE KTDIM ROWS FOR EACH OBSERVATION)
            DO KR=1,NSETS
              DO MR=1,ISYMBOL(KR)
C               IS THE ROW PLOT-SYMBOL LISTED AS AN 'OMIT' SET MEMBER?
                IF (IPLOT(IROW).EQ.ISETPLT(KR,MR)) THEN
                  IF (ISETTYP(KR).EQ.0) THEN
C                   OMIT THIS ROW
                    GOTO 120
                  ENDIF
                ENDIF
              END DO
            END DO
C           RETAINED THIS ROW
            IAROW=IAROW+1
            WMROW = WMROW+1
            WMCOLOLD = WMCOL
C           COLUMNS NEXT
            DO J = NTTOB1, NTTOB2
              IF (MOD(J,KTDIM).EQ.ONE) ICOL=ICOL+1
C             DEBUG
              DO KC=1,NSETS
                DO MC=1,ISYMBOL(KC)
C                 IS THE COL PLOT-SYMBOL LISTED AS AN 'OMIT' SET MEMBER?
                  IF (IPLOT(ICOL).EQ.ISETPLT(KC,MC)) THEN
                    IF (ISETTYP(KC).EQ.0) THEN
C                     OMIT THIS COLUMN
                      GOTO 115
                    ELSE
                      IACOL=IACOL+1
C                     CALL SPRD1SETS1VM A MAXIMUM OF TWICE:
C                     ONCE FOR ROW
                      CALL SPRD1SETS1VM(IFAIL,WTQ(I,J),ONE,VMULT,
     +                   NSETS,AFNAM(29),IPLOT(INAMESOLD+IROW),
     +                   ISETPLT,ISYMBOL)
C                     ONCE FOR COLUMN
                      CALL SPRD1SETS1VM(IFAIL,WTQ(I,J),ONE,VMULT,
     +                   NSETS,AFNAM(29),IPLOT(INAMESOLD+ICOL),
     +                   ISETPLT,ISYMBOL)
                    END IF
                  END IF
                END DO
              END DO
C             IF WE ARE HERE: LOAD INTO FULL WEIGHT MATRIX
              IACOL=IACOL+1
              WMCOLOLD=WMCOLOLD+1
              XWTQ(WMCOLOLD,WMROW) = WTQ(I,J)
  115       END DO
  120     END DO
          WRITE(*,*) IAROW,IACOL
          IF (IAROW.EQ.IACOL) THEN
            WRITE(IOUTP,130)
  130       FORMAT(3X,'READ WEIGHT MATRIX - OK')
          ELSE
            WRITE(IOUTP,132)
  132       FORMAT(3X,'ERROR READING OR PREPARING ADV WEIGHT MATRIX')
            GOTO 999
          ENDIF
          WMCOL = WMCOLOLD
        ENDIF
      ENDIF
      CLOSE(IOUADV)

C====IF IPRED.GT.0 AND IOBS.GT.0 WRITE THE NEW OBSERVATION PACKAGE FILES

      IF (((IOBS.GT.0).AND.(IPRED.GT.0)).OR.((IOBS.GT.0).AND.
     +    (IOMIT.GT.0)).OR.((IPRED.GT.0).AND.(IOMIT.GT.0))) THEN

C    == OBSERVATION ONLY FILE
        IF (IOBS.GT.0) THEN

        FFNAM(1,29) = OBS_PREF//TRIM(AFNAM(29))
        FFNAM(3,29) = OBS_PREF//TRIM(AFNAM(29))
        OIOUT = IGETUNIT(1,95)
        OPEN(OIOUT,FILE=FFNAM(1,29),STATUS='UNKNOWN',err=888)
        DO I=1,IOBHEADER
            WRITE(OIOUT,'(A)') ADJUSTL(TRIM(OBHEADERS(I)))
        END DO
        WRITE(OIOUT,1100) 'MOD-PREDICT PRODUCED THIS ADV'
1100    FORMAT('#',1X,A,' FILE FOR OBSERVATIONS')
C       ITEM 1
        WRITE(OIOUT,1500) NPTHOB,NTT2-INT((IPRED/KTDIM)+(IOMIT/KTDIM)),
     +                 IOUTT2,KTFLG,KTREV,ADVSTP,FSNK
C       POROSITY
        DO K = 1, NLAY
          IPRN = 1
           CALL ULAPRWC1(PRST(1,1,K),NCOL,NROW,K,OIOUT,IPRN,ANAME)
        END DO
        I2 = 1
        NTPNT = 0
        DO I = 1, NPTH
          IF (NPNT_OB(I).GT.0) THEN
            WRITE(OIOUT,1110) SPACES, NPNT_OB(I),(ICLS(J,I),J=1,3),
     +                                           (POFF(J,I),J=1,3)
1110        FORMAT(1X,A4,T9,4(I5),3(F9.4))
          END IF
          DO IPNT = 1, NPNT(I)
            NTPNT = NTPNT + 1
            IF ((OBPRED(I,IPNT).EQ.'O').OR.(OBPRED(I,IPNT).EQ.'C')) THEN
C             IF NO C-V MATRIX AND OBSERVATION IS MEMBER OF CALIBRATION
C             SET THEN SCALE STATISTIC BY VMULT BEFORE WRITING
              IF ((IOWTQAD.EQ.0).AND.(OBPRED(I,IPNT).EQ.'C')) THEN
C               X-WEIGHT
                CALL SPRD1SETS1VM(IFAIL,RXWT(I2),IIWT(1,I2),VMULT,
     +                     NSETS,FFNAM(1,29),IPLOT(I2),ISETPLT,ISYMBOL)
C               Y-WEIGHT
                CALL SPRD1SETS1VM(IFAIL,RYWT(I2),IIWT(2,I2),VMULT,
     +                     NSETS,FFNAM(1,29),IPLOT(I2),ISETPLT,ISYMBOL)
C               Z-WEIGHT
                CALL SPRD1SETS1VM(IFAIL,RZWT(I2),IIWT(3,I2),VMULT,
     +                     NSETS,FFNAM(1,29),IPLOT(I2),ISETPLT,ISYMBOL)
              END IF
              WRITE(OIOUT,1220) OBSNME(I2),(IT2OFF(J,I2),J=1,3),
     +                      (RT2OFF(J,I2),J=1,3),RXWT(I2),IIWT(1,I2),
     +                      RYWT(I2),IIWT(2,I2),RZWT(I2),IIWT(3,I2),
     +                      TT2(NTPNT),IPLOT(I2)
1120          FORMAT(1X,A12,3(I5),3(F9.4),4(1X,G12.4,1X,I4))
            ENDIF
            I2 = I2 + 1
          END DO
        END DO
        WRITE (OIOUT,*) IOWTQAD

        END IF

C    == PREDICTION ONLY FILE
        IF (IPRED.GT.0) THEN

        FFNAM(2,29) = PRE_PREF//TRIM(AFNAM(29))
        PIOUT = IGETUNIT(1,95)
        OPEN(PIOUT,FILE=FFNAM(2,29),STATUS='UNKNOWN',err=888)
        DO I=1,IOBHEADER
          WRITE(PIOUT,'(A)') ADJUSTL(TRIM(OBHEADERS(I)))
        END DO
        WRITE(PIOUT,1200) 'MOD-PREDICT PRODUCED THIS ADV'
1200    FORMAT('#',1X,A,' FILE FOR PREDICTIONS')
C       ITEM 1
        WRITE(PIOUT,1500) NPTHPR,NTT2-INT((IOBS/KTDIM)+(IOMIT/KTDIM)),
     +                 IOUTT2,KTFLG,KTREV,ADVSTP,FSNK
C       POROSITY
        DO K = 1, NLAY
          IPRN = 1
           CALL ULAPRWC1(PRST(1,1,K),NCOL,NROW,K,PIOUT,IPRN,ANAME)
        END DO
        I2 = 1
        NTPNT = 0
        DO I = 1, NPTH
          IF (NPNT_PR(I).GT.0) THEN
            WRITE(PIOUT,1210) SPACES,NPNT_PR(I),(ICLS(J,I),J=1,3),
     +                                          (POFF(J,I),J=1,3)
1210        FORMAT(1X,A4,T9,4(I5),3(F9.4))
          END IF
          DO IPNT = 1, NPNT(I)
            NTPNT = NTPNT + 1
            IF (OBPRED(I,IPNT).EQ.'P') THEN
C             IF NO C-V MATRIX: SCALE STATISTIC BY VMULT BEFORE WRITING
              IF (IOWTQAD.EQ.0) THEN
C               X-WEIGHT
                CALL SPRD1SETS1VM(IFAIL,RXWT(I2),IIWT(1,I2),VMULT,
     +                      NSETS,FFNAM(2,29),IPLOT(I2),ISETPLT,ISYMBOL)
C               Y-WEIGHT
                CALL SPRD1SETS1VM(IFAIL,RYWT(I2),IIWT(2,I2),VMULT,
     +                      NSETS,FFNAM(2,29),IPLOT(I2),ISETPLT,ISYMBOL)
C               Z-WEIGHT
                CALL SPRD1SETS1VM(IFAIL,RZWT(I2),IIWT(3,I2),VMULT,
     +                      NSETS,FFNAM(2,29),IPLOT(I2),ISETPLT,ISYMBOL)
              END IF
              WRITE(PIOUT,1220) OBSNME(I2),(IT2OFF(J,I2),J=1,3),
     +                      (RT2OFF(J,I2),J=1,3),RXWT(I2),IIWT(1,I2),
     +                      RYWT(I2),IIWT(2,I2),RZWT(I2),IIWT(3,I2),
     +                      TT2(NTPNT),IPLOT(I2)
1220          FORMAT(1X,A12,3(I5),3(F9.4),4(1X,G12.4,1X,I4))
            END IF
            I2 = I2 + 1
          END DO
        END DO
        WRITE (PIOUT,*) IOWTQAD

        END IF

C       IF A COVARIANCE MATRIX IS PRESENT - WRITE IT
C       PREP THE FORMAT
        IF (IOWTQAD.GT.0) THEN
          CALL UCASETRANS(FMTIN,'hi')
C         PREP THE FORMAT
          IF (INDEX(FMTIN,'F').GE.1) THEN
            AFMT =FMTIN(INDEX(FMTIN,'F'):LEN_TRIM(FMTIN))
          ELSEIF (INDEX(FMTIN,'G').GT.1) THEN
            AFMT =FMTIN(INDEX(FMTIN,'G'):LEN_TRIM(FMTIN))
          ENDIF
          AFMT = ADJUSTL(AFMT)

C    ===OBSERVATIONS ONLY FILE MATRIX
          IF (IOBS.GT.0) THEN

          WRITE(ACHAR,'(I4)') IOBS
          ACHAR= ADJUSTL(ACHAR)
          FMTOUT = '('//TRIM(ACHAR)//AFMT//')'
          WRITE(OIOUT,*) FMTOUT,IPRN
C         LOAD AND PRINT TEMP MATRIX FROM WTQ MATRIX
          IR=0
          IPROW=0
c         ONE COUNT PER OBS/PRED
          DO I = 1, NPTH
            DO IPNT = 1, NPNT(I)
              IPROW = IPROW + 1
              IF((OBPRED(I,IPNT).EQ.'O').OR.(OBPRED(I,IPNT).EQ.'C'))THEN
                WTQT=0.
C               DOWN ROWS
                DO J=1,KTDIM
                  IR = IR+1
                  IT = 0
                  IC = 0
                  IPCOL = 0
                  DO II = 1, NPTH
                    DO N = 1, NPNT(II)
                      IPCOL = IPCOL + 1
                      IF((OBPRED(II,N).EQ.'O').OR.(OBPRED(II,N).EQ.'C'))
     +                                                              THEN
C                       ALONG COLUMNS
                        DO K=1,KTDIM
                          IT = IT+1
                          IC = IC+1
C                         CALL SPRD1SETS1VM A MAXIMUM OF TWICE:
C                         ONCE FOR ROW
                          IF (OBPRED(I,IPNT).EQ.'C')
     +                    CALL SPRD1SETS1VM(IFAIL,WTQ(IR,IC),ONE,VMULT,
     +                                   NSETS,FFNAM(1,29),IPLOT(IPROW),
     +                                   ISETPLT,ISYMBOL)
C                         ONCE FOR COLUMN
                          IF (OBPRED(II,N).EQ.'C')
     +                    CALL SPRD1SETS1VM(IFAIL,WTQ(IR,IC),ONE,VMULT,
     +                                   NSETS,FFNAM(1,29),IPLOT(IPCOL),
     +                                   ISETPLT,ISYMBOL)
C                         LOAD TEMPORARY MATRIX
                          WTQT(IT) = WTQ(IR,IC)
                        END DO
                      ELSE
                        DO K=1,KTDIM
                          IC = IC+1
                        END DO
                      END IF
                    END DO
                  END DO
                  WRITE(OIOUT,FMTOUT) (WTQT(L),L=1,IT)
                END DO
              ELSE
                IC = 0
                DO K=1,KTDIM
                  IR = IR+1
                END DO
              ENDIF
            END DO
          END DO

          ENDIF

C    ===PREDICTIONS ONLY FILE MATRIX
          IF (IPRED.GT.0) THEN

          WRITE(ACHAR,'(I4)') IPRED
          ACHAR= ADJUSTL(ACHAR)
          FMTOUT = '('//TRIM(ACHAR)//AFMT//')'
          WRITE(PIOUT,*) FMTOUT,IPRN
C         LOAD AND PRINT TEMP MATRIX FROM WTQ MATRIX
          IR=0
          IPROW=0
c         ONE COUNT PER OBS/PRED
          DO I = 1, NPTH
            DO IPNT = 1, NPNT(I)
              IPROW = IPROW + 1
              IF (OBPRED(I,IPNT).EQ.'P') THEN
                WTQT=0.
C               DOWN ROWS
                DO J=1,KTDIM
                  IR = IR+1
                  IT = 0
                  IC = 0
                  IPCOL = 0
                  DO II = 1, NPTH
                    DO N = 1, NPNT(II)
                      IPCOL = IPCOL + 1
                      IF (OBPRED(II,N).EQ.'P') THEN
C                       ALONG COLUMNS
                        DO K=1,KTDIM
                          IT = IT+1
                          IC = IC+1
C                         CALL SPRD1SETS1VM TWICE:
C                         ONCE FOR ROW
                          CALL SPRD1SETS1VM(IFAIL,WTQ(IR,IC),ONE,VMULT,
     +                                   NSETS,FFNAM(2,29),IPLOT(IPROW),
     +                                   ISETPLT,ISYMBOL)
C                         ONCE FOR COLUMN
                          CALL SPRD1SETS1VM(IFAIL,WTQ(IR,IC),ONE,VMULT,
     +                                   NSETS,FFNAM(2,29),IPLOT(IPCOL),
     +                                   ISETPLT,ISYMBOL)
C                         LOAD TEMP MATRIX
                          WTQT(IT) = WTQ(IR,IC)
                        END DO
                      ELSE
                        DO K=1,KTDIM
                          IC = IC+1
                        END DO
                      END IF
                    END DO
                  END DO
                  WRITE(PIOUT,FMTOUT) (WTQT(L),L=1,IT)
                END DO
              ELSE
                IC = 0
                DO K=1,KTDIM
                  IR = IR+1
                END DO
              ENDIF
            END DO
          END DO

          END IF

        ENDIF
        IF (IOBS.GT.0) CLOSE(OIOUT)
        IF (IPRED.GT.0) CLOSE(PIOUT)

      ELSE IF ((IPRED.EQ.0).AND.(IOBS.EQ.0)) THEN
C       THEY WERE ALL OMITS - DON'T USE IT
        FFNAM(1,29) = NO_FILE
        FFNAM(2,29) = NO_FILE
        FFNAM(3,29) = NO_FILE
        WRITE(IOUTP,1400)
1400    FORMAT(3X,'NOTE: ALL ENTRIES ARE "OMIT": FILE WILL NOT BE USED')
      ELSE IF ((IPRED.EQ.0).AND.(IOBS.NE.0)) THEN
C       USE THE FILE AS IT IS: DON'T USE A PREDICTION FILE
        FFNAM(1,29) = TRIM(AFNAM(29))
        FFNAM(2,29) = NO_FILE
        FFNAM(3,29) = TRIM(AFNAM(29))
      ELSE IF ((IPRED.NE.0).AND.(IOBS.EQ.0)) THEN
C       USE THE FILE AS IT IS: DON'T USE AN OBSERVATION FILE
        FFNAM(1,29) = NO_FILE
        FFNAM(2,29) = TRIM(AFNAM(29))
        FFNAM(3,29) = NO_FILE
      END IF

      WRITE(IOUTP,400)
  400 FORMAT(3X,'IPRED > 0: WRITTEN NEW ADV FILES - OK')
      RETURN

  810 FORMAT('ERROR OPENING .ADV FILE ',A,'.')
  811 FORMAT('#',1X,A,'THIS IS THE ',A,A)

  888 WRITE(IOUTP,889) AFNAM(29)(1:NBLNK(AFNAM(29)))
  889 FORMAT(//,1X,'ERROR PROCESSING NEW ADV FILE(S) ',A)
      IFAIL = 1
      RETURN

 1500 FORMAT(5(1X,I5),2(1X,G12.8))

  999 WRITE(IOUTP,1000) AFNAM(29)(1:NBLNK(AFNAM(29)))
 1000 FORMAT(//,1X,'ERROR PROCESSING ADV FILE ',A)
      IFAIL = 1
      WRITE(IOUTP,1050)
1050  FORMAT('STOP EXECUTION (SPRD1ADV2RP)')
      RETURN

      END

c=======================================================================
      SUBROUTINE SPRD1OBS1AL(IFAIL,ISCALS,ISEN,IUOBS,OUTNAM,FNAM)
c=======================================================================
C     VERSION 19990726 ERB
C     OBTAIN OUTNAM FOR GRAPH-DATA OUTPUT FILES AND READ ISCALS.

      USE DRIVER
      IMPLICIT NONE

      INTEGER IUOBS,IFAIL,LLOC,IDUM,ISTOP,ISTART,LENG,NONB_LEN,
     +        ISCALS,ISLASH,IERR,ISEN
      REAL RDUM
      CHARACTER*200 LINE, OUTNAM, OUTNAMU
      CHARACTER*100 FNAM
      logical lop
c     ------------------------------------------------------------------

  505 FORMAT (3X,'COMPOSITE SCALED SENSITIVITIES WILL BE PRINTED')
  510 FORMAT (3X,'UNSCALED OBSERVATION SENSITIVITIES WILL BE PRINTED')
  515 FORMAT (3X,'DIMENSIONLESS SCALED OBSERVATION SENSITIVITIES WILL ',
     &        ' BE PRINTED')
  520 FORMAT (3X,'ONE-PERCENT SCALED OBSERVATION SENSITIVITIES WILL BE',
     &        ' PRINTED')
  530 FORMAT (/,1X,'OUTNAM = "NONE" - MF2K GRAPH-DATA OUTPUT FILES ',
     &        'WILL NOT BE PRINTED. ',/,
     +        1X,'MOD-PREDICT REQUIRES THESE FILES TO RUN CORRECTLY - ',
     +           'STOPPING (SPRD1OBS1AL)')
  540 FORMAT (3X,'OBSERVATION GRAPH-DATA OUTPUT FILES',/,
     &        3X,'  WILL BE PRINTED AND NAMED USING THE BASE: ',A)
  550 FORMAT(/,
     &       ' WARNING: ERROR IN OPENING PARAMETER-VALUE OUTPUT FILE',/,
     &       '   -- TABLE OF PARAMETER VALUES AND STATISTICS FOR ALL ',
     &       ' ITERATIONS WILL NOT BE',/,'   PRODUCED (OBS1BAS6AL)',/)
  560 FORMAT (3X,'OBSERVATION GRAPH-DATA OUTPUT FILES',/,
     &        3X,'  WILL BE PRINTED AND NAMED USING THE PATH: ',A)
C
      INQUIRE(UNIT=IUOBS,OPENED=LOP)
      IF (LOP) THEN
          REWIND(IUOBS)
        ELSE
          OPEN(IUOBS,FILE=ADJUSTL(FNAM),STATUS='OLD',IOSTAT=IERR)
          IF(IERR.NE.0) THEN
            WRITE(IOUTP,2) ADJUSTL(FNAM)
2           FORMAT('ERROR OPENING FILE ',A,'.')
            IFAIL = 1
            RETURN
          END IF
      END IF

      OUTPATH = ' '
      IFAIL = 0
      CALL URDCOM(IUOBS,0,LINE)
      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,IDUM,RDUM,IOUTP,IUOBS)
      OUTNAM = LINE(ISTART:ISTOP)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ISCALS,RDUM,IOUTP,IUOBS)
      CALL UCASE(OUTNAM,OUTNAMU,1)
      IF (OUTNAMU.EQ.'NONE') THEN
        OUTNAM = OUTNAMU
        WRITE (IOUTP,530)
        IFAIL = 1
        RETURN
      END IF
C     CHECK FOR OUT PATH AND FILE NAME
      IF (INDEX(OUTNAM,'\').GT.0) then
        DO
          ISLASH = INDEX(OUTNAM,'\')
          IF (ISLASH.GT.0) THEN
            OUTPATH = TRIM(ADJUSTL(OUTPATH))//OUTNAM(1:ISLASH)
            OUTNAM = OUTNAM(ISLASH+1:LEN(OUTNAM))
          ELSE
            GOTO 1000
          ENDIF
        END DO
1000    LENG = NONB_LEN(OUTNAM,200)
        WRITE (IOUTP,540) OUTNAM(1:LENG)
        LENG = NONB_LEN(OUTPATH,200)
        IF (LENG.GT.0) THEN
          WRITE (IOUTP,560) OUTPATH(1:LENG)
        ENDIF
      END IF

      IF (ISEN.GT.0) THEN
        IF (ISCALS.LT.0) WRITE (IOUTP,505)
        IF (ISCALS.EQ.0) WRITE (IOUTP,510)
        IF (ISCALS.EQ.1 .OR. ISCALS.EQ.3) WRITE (IOUTP,515)
        IF (ISCALS.EQ.2 .OR. ISCALS.EQ.3) WRITE (IOUTP,520)
      ENDIF
C
      RETURN
      END

C=======================================================================
      SUBROUTINE SPRD1OBS1WR(IFAIL,ISCALS,RUNTYPE,IUNIT,NIUNIT,OBSBASE,
     +                    PREDBASE,PESBASE,FFNAM)
C=======================================================================
C     WRITE OBS PROCESS FILE(S) NEEDED FOR EACH RUNTYPE
C     VERSION 1, JUN 2003, MJT

      USE DRIVER
      IMPLICIT NONE

      INTEGER IFAIL,ISCALS,ISEN,RUNTYPE,NIUNIT,IIOUT,IERR,IUNIT(NIUNIT)
      CHARACTER*100 FFNAM(3,NIUNIT)
      CHARACTER*200 RUNTEXT,OBSBASE,PREDBASE,PESBASE
c     ------------------------------------------------------------------

      IERR = 0
      IFAIL = 0
      WRITE(IOUTP,6)
      IIOUT = IUNIT(27)

      IF (RUNTYPE.EQ.1) RUNTEXT = 'OBS ONLY CASE'
      IF (RUNTYPE.EQ.2) RUNTEXT = 'OBS-SEN CASE'
      IF (RUNTYPE.EQ.3) RUNTEXT = 'OBS-SEN-PES CASE'

C     IF RUNTYPE = 3 MAKE AN OBS FILE FOR THE PES RUN
      IF (RUNTYPE.EQ.3) THEN
        WRITE(IOUTP,1) FFNAM(3,27)
1       FORMAT(3X,'OBS FILE FOR PES-RUN  - ',A)
        OPEN(IIOUT,FILE = FFNAM(3,27))
          WRITE(IIOUT,3) 'MOD-PREDICT PRODUCED THIS '
3         FORMAT('#',1X,A,'OBS FILE FOR CALIBRATION CONDITIONS')
          WRITE(IIOUT,130) TRIM(ADJUSTL(PESBASE)),ISCALS
        CLOSE(IIOUT)
      END IF

C     IF RUNTYPE = 1, 2, OR 3 - OBS FILES FOR THE OBS AND PRED CASES
C     OBSERVATION OBS FILE
      WRITE(IOUTP,10) FFNAM(1,27)
10    FORMAT(3X,'OBS FILE FOR OBS-RUN  - ',A)
      OPEN(IIOUT,FILE = FFNAM(1,27))
        WRITE(IIOUT,13) 'MOD-PREDICT PRODUCED THIS '
13      FORMAT('#',1X,A,' OBS FILE FOR OBSERVATIONS')
        WRITE(IIOUT,130) TRIM(ADJUSTL(OBSBASE)),ISCALS
      CLOSE(IIOUT)

C     PREDICTION OBS FILE
      WRITE(IOUTP,22) FFNAM(2,27)
22     FORMAT(3X,'OBS FILE FOR PRED-RUN - ',A)
      OPEN(IIOUT,FILE = FFNAM(2,27))
        WRITE(IIOUT,24) 'MOD-PREDICT PRODUCED THIS '
24       FORMAT('#',1X,A,' OBS FILE FOR PREDICTIONS')
        WRITE(IIOUT,130) TRIM(ADJUSTL(PREDBASE)),ISCALS
      CLOSE(IIOUT)

6     FORMAT(/,1X,'WRITING OBS FILES')
      WRITE(IOUTP,100) RUNTEXT
100   FORMAT(3X,'WRITTEN OBS FILE(S) FOR ',A)
      IF (IERR.NE.0) THEN
        WRITE(IOUTP,110)
110     FORMAT(1X,'ERROR ENCOUNTERED WITH OBS FILES',A)
      ENDIF
120   FORMAT(A,1X,I2,1X,A)
130   FORMAT(A,1X,I2)

      RETURN
      END

C=======================================================================
      SUBROUTINE SPRD1SEN1AL(IFAIL,IUNIT,NIUNIT,NPLIST,ISENALL,IUHEAD,
     +                      MXSEN,IPRINTS,ISENSU,ISENPU,ISENFM)
C=======================================================================
C     READ SEN FILE FOR NPLIST,ISENSU,ISEN, RETURN DIMENSIONS TO MAIN
C     VERSION 1, JUN 2003, MJT

      USE DRIVER
      IMPLICIT NONE

      INTEGER NPLIST,ISENALL,IUHEAD,MXSEN,IPRINTS,ISENSU,ISENPU,ISENFM,
     +        IFAIL,NIUNIT,IUNIT(NIUNIT),ILINE

C     READ HEADERS
      ILINE=0
10    ILINE=ILINE+1
      READ(IUNIT(25),'(A)',ERR=998,END=998) CLINE
      IF(CLINE.EQ.' ') GO TO 10
      CALL Ulshift(CLINE)
      IF(CLINE(1:1).EQ.'#') THEN
        GO TO 10
      END IF
      BACKSPACE(IUNIT(25))

      READ(IUNIT(25),*,ERR=998) NPLIST,ISENALL,IUHEAD,MXSEN
      READ(IUNIT(25),*,ERR=998) IPRINTS,ISENSU,ISENPU,ISENFM
      REWIND(IUNIT(25))
      RETURN

998   WRITE(IOUTP,999)
999   FORMAT(1X,'ERROR READING SEN FILE',/)
      IFAIL = 1
      WRITE(IOUTP,1000)
1000  FORMAT('STOP EXECUTION (SPRD1SEN1AL)')
      RETURN

      END

C=======================================================================
      SUBROUTINE SPRD1SEN1RP(IFAIL,IUNIT,NIUNIT,NPLIST,ISENALL,
     +                       IUHEAD,MXSEN,IPRINTS,ISENSU,ISENPU,ISENFM,
     +                       PARNAM,ISENS,LN,B,BL,BU,BSCAL,NPE,NPDIM)
C=======================================================================
C     READ SEN FILE FULLY
C     VERSION 1, JUN 2003, MJT (BORROWS HEAVILY FROM MF2K CODE)
C=======================================================================
      USE DRIVER
      IMPLICIT NONE

      INTEGER NIUNIT,NPE,INAM1,INAM2,N,IFAIL,I,LLOC,ILINE,NPLIST,
     +        ISENALL,IUHEAD,MXSEN,IPRINTS,ISENSU,ISENPU,ISENFM,ISTOP,
     +        ISTART,NPDIM
C      ISS,
      INTEGER LN(NPDIM),ISENS(NPDIM),IUNIT(NIUNIT)
      REAL    R,B(NPDIM),BL(NPDIM),BU(NPDIM),BSCAL(NPDIM)
      CHARACTER*200 LINE
      CHARACTER*10 PARNAM(NPDIM)
c     ------------------------------------------------------------------

      ISENS = 0

C     READ HEADERS
      ILINE=0
5     ILINE=ILINE+1
      READ(IUNIT(25),'(A)',ERR=998,END=998) CLINE
      IF(CLINE.EQ.' ') GO TO 5
      CALL Ulshift(CLINE)
      IF(CLINE(1:1).EQ.'#') THEN
        GO TO 5
      END IF
      BACKSPACE(IUNIT(25))
      READ(IUNIT(25),*,ERR=998) NPLIST,ISENALL,IUHEAD,MXSEN
      READ(IUNIT(25),*,ERR=998) IPRINTS,ISENSU,ISENPU,ISENFM

C     DETERMINE NPE FROM ISENALL AND ISENS
      IPPTR = 0
      IF (ISENALL.GT.0) THEN
        NPE = NPLIST
        IPPTR = 1
      ELSE IF (ISENALL.LT.0) THEN
        NPE = 0
      ELSE IF (ISENALL.EQ.0) THEN
C       READ AND SUM ISENS: LOAD PARNAM
        NPE = 0
        DO I = 1,NPLIST
10      READ(IUNIT(25),'(A)',END=20,ERR=998) LINE
        IF((LINE.EQ.' ').OR.(LINE(1:1).EQ.'#')) GO TO 10
        LLOC=1
        CALL URWORD(LINE,LLOC,INAM1,INAM2,0,N,R,IOUTP,IUNIT(25))
        PARNAM(I)=LINE(INAM1:INAM2)
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ISENS(I),R,IOUTP,IUNIT(25))
        IF (ISENS(I).GT.0) THEN
          NPE = NPE+1
          IPPTR(NPE) = I
        ENDIF
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,LN(I),R,IOUTP,IUNIT(25))
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,B(I),IOUTP,IUNIT(25))
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,BL(I),IOUTP,IUNIT(25))
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,BU(I),IOUTP,IUNIT(25))
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,N,BSCAL(I),IOUTP,IUNIT(25))
        END DO
      ENDIF

      CLOSE(IUNIT(25))
      RETURN

20    WRITE(IOUTP,21)
      WRITE(*,21)
21    FORMAT(/,1X,'UNEXPECTED END TO SEN FILE - STOPPING')
998   WRITE(IOUTP,999)
999   FORMAT(1X,'ERROR READING SEN FILE',/)
      IFAIL = 1
      WRITE(IOUTP,1000)
1000  FORMAT('STOP EXECUTION (SPRD1SEN1RP)')
      RETURN

      END

c=======================================================================
      SUBROUTINE SPRD1SEN1WR(IFAIL,AFNAM,IUNIT,NIUNIT,
     +                     NPLIST,ISENALL,IUHEAD,MXSEN,IPRINTS,ISENSU,
     +                     ISENPU,ISENFM,PARNAM,ISENS,LN,B,BL,BU,
     +                     BSCAL,PAROPT,PARNAMTEMP,SENFILEOPT,NPDIM)
c=======================================================================
c     WRITES NEW SEN FILE FOR RUNTYPE WITH OPTIMIZED PARAMETERS
C     VERSION 1, JUN 2003, MJT

      USE DRIVER
      IMPLICIT NONE

      LOGICAL MATCH
      INTEGER NIUNIT,IFAIL,NBLNK,I, NPLIST,ISENALL,IUHEAD,MXSEN,
     +        IPRINTS,ISENSU,ISENPU,ISENFM,NPDIM
      INTEGER LN(NPDIM),ISENS(NPDIM),IUNIT(NIUNIT)
      REAL    B(NPDIM),BL(NPDIM),BU(NPDIM),BSCAL(NPDIM)
      REAL    PAROPT(NPDIM),TVAL
      CHARACTER*200 SENFILEOPT,LINE
      CHARACTER*100 AFNAM(NIUNIT)
      CHARACTER*10 PARNAM(NPDIM),PARNAMTEMP(NPDIM)
      CHARACTER*14 APAROPT
c     ------------------------------------------------------------------

      SENFILEOPT = PAR_PREF//AFNAM(25)(1:NBLNK(AFNAM(25)))
      WRITE (IOUTP,100) SENFILEOPT
      OPEN(IUNIT(25),FILE=SENFILEOPT)

C   WRITE PREDICTION HEADER
      WRITE(IUNIT(25),10) 'MOD-PREDICT PRODUCED THIS ',
     +                                   SENFILEOPT(1:NBLNK(SENFILEOPT))
10    FORMAT('#',1X,A,' OPTIMIZED SENSITIVITY FILE ',A)

C   WRITE SEN PARAMETERS
      WRITE(IUNIT(25),'(4I6)') NPLIST,ISENALL,IUHEAD,MXSEN
      WRITE(IUNIT(25),'(4I6)') IPRINTS,ISENSU,ISENPU,ISENFM

C   DETERMINE NPE FROM ISENALL AND ISENS
C   (ASSUMES ALL PARAMETERS LISTED IN SEN FILE ARE LISTED IN _b FILE)
C   WRITES TO STRING TO COMBINE FORMATTING AND PRECISION
      DO I = 1,NPLIST
          IF (MATCH(PARNAM(I),PARNAMTEMP(I))) THEN
              LINE    = ' '
              LINE(1:10) = ADJUSTR(PARNAM(I))
              APAROPT = ' '
              WRITE(APAROPT,'(I4)') ISENS(I)
              LINE(12:15) = APAROPT
              APAROPT = ' '
              WRITE(APAROPT,'(I4)') LN(I)
              LINE = TRIM(LINE)//' '//APAROPT
              APAROPT = ' '
              CALL UWRTSIG(IFAIL,PAROPT(I),APAROPT,12,0,TVAL,0)
              LINE = TRIM(LINE)//' '//APAROPT
              APAROPT = ' '
              CALL UWRTSIG(IFAIL,BL(I),APAROPT,12,0,TVAL,0)
              LINE = TRIM(LINE)//' '//APAROPT
              APAROPT = ' '
              CALL UWRTSIG(IFAIL,BU(I),APAROPT,12,0,TVAL,0)
              LINE = TRIM(LINE)//' '//APAROPT
              APAROPT = ' '
              CALL UWRTSIG(IFAIL,BSCAL(I),APAROPT,12,0,TVAL,0)
              LINE = TRIM(LINE)//' '//APAROPT
              WRITE(IUNIT(25),'(A)') LINE
          ELSE
              WRITE(*,12)
              WRITE(IOUTP,12)
12            FORMAT(/,1X,'ERROR MATCHING PARAMETERS - STOPPING')
              GOTO 1000
          END IF
14    END DO

      CLOSE(IUNIT(25))
      RETURN

50    FORMAT(/,1X,'ERROR OPENING SEN FILE - STOPPING')
100   FORMAT(3X,'WRITING OPTIMAL PARAMETERS TO SENFILE: ',A)
999   FORMAT(1X,'ERROR OPENING SEN FILE',/)

1000  IFAIL = 1
      WRITE(IOUTP,1050)
1050  FORMAT('STOP EXECUTION (SPRD1SEN1WR)')
      RETURN

      END

C=======================================================================
      SUBROUTINE SPRD1PES1AL(IFAIL,AFNAM,IUNIT,NIUNIT,MAXITER,
     +                        NPESLINES,IPR,MPR,IPRAR,MPRAR)
C=======================================================================
C     READ PES, RETURN DIMENSIONS TO MAIN PROGRAM
C     VERSION 1, JUN 2003, MJT

      USE DRIVER
      IMPLICIT NONE

      INTEGER NIUNIT,IUNIT(NIUNIT),MAXITER,LLOC,ILINE,NPESLINES,IFAIL,
     +        IERR,NBLNK,ISTART,ISTOP,J,IPR,MPR,NPNG,IPRAR,MPRAR
      REAL R
      CHARACTER*100 AFNAM(NIUNIT)
c     ------------------------------------------------------------------

      OPEN(IUNIT(26),FILE=AFNAM(26),STATUS='OLD',IOSTAT=IERR)
      IF(IERR.NE.0) THEN
        WRITE(IOUTP,10) AFNAM(26)(1:NBLNK(AFNAM(26)))
10      FORMAT('ERROR OPENING EXISTING MODFLOW .PES FILE ',a,'.')
        GO TO 999
      END IF

C     READ JUST FOR MAXITER AND DIMENSIONING
      ILINE = 0
13    ILINE = ILINE + 1
      READ(IUNIT(26),'(A)',ERR=999,END=15) CLINE
      IF(CLINE(1:1).EQ.'#') GO TO 13
      LLOC = 1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,MAXITER,R,IOUTP,IUNIT(26))
      ILINE = ILINE + 1
      READ(IUNIT(26),'(A)',ERR=999,END=15) CLINE
      READ(IUNIT(26),'(A)',ERR=999,END=15) CLINE
      READ(IUNIT(26),'(A)',ERR=999,END=15) CLINE
      READ(IUNIT(26),'(A)',ERR=999,END=15) CLINE
      LLOC = 1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NPNG,R,IOUTP,IUNIT(26))
      ILINE = ILINE + 1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,IPR,R,IOUTP,IUNIT(26))
      ILINE = ILINE + 1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,MPR,R,IOUTP,IUNIT(26))
      ILINE = ILINE + 1
      IF (IPR.GT.0) THEN
          IPRAR = IPR
c         FULL MATRIX FOR PRIOR NOT ACTIVE IN VERSION 1 MODPREDICT
          WRITE(IOUTP,14)
          WRITE(*,14)
14        FORMAT(/,1X,'IPR > 0 INDICATES A FULL WEIGHT MATRIX IS USED ',
     +                'FOR PRIOR INFORMATION.                         ',
     +           /,1X,'THIS OPTION IS NOT ACTIVATED IN THIS VERSION OF',
     +                ' MODPREDICT.'                                   ,
     +           /,1X,'STOPPING (SPRD1PES1AL)')
          CLOSE(IUNIT(26))
          GOTO 999
        ELSE
          IPRAR = 1
      ENDIF
      IF (MPR.GT.0) THEN
          MPRAR = MPR
        ELSE
          MPRAR = 1
      ENDIF
      DO J=1,100000
          ILINE = ILINE + 1
          READ(IUNIT(26),'(A)',ERR=999,END=15) CLINE
      END DO
15    CLOSE(IUNIT(26))
      NPESLINES = ILINE
      RETURN

999   WRITE(IOUTP,1000) afnam(26)(1:NBLNK(afnam(26)))
1000  FORMAT(/,1X,'ERROR ENCOUNTERED WITH PES FILE ',A,' - STOPPING')
      IFAIL = 1
      WRITE(IOUTP,1050)
1050  FORMAT('STOP EXECUTION (SPRD1PES1AL)')
      RETURN

      END

C=======================================================================
      SUBROUTINE SPRD1PES1RP(ISS,IFAIL,AFNAM,IUNIT,NIUNIT,NPNG,IPR,MPR,
     +                    NPRIOR,IPRCOV,IPRINT,LPRINT,MAXITER,MAXCHANGE,
     +                    TOL,SOSC,NPESLINES,PESTEXT,NPLIST,ND,NIPRNAM,
     +                    EQNAM,NAMES,INAMES,IAPLOT,LN,NSETS,ISETPLT,
     +                    ISETTYP,IOMIT,ISYMBOL,PARNAM,VMULT,IPRAR,
     +                    MPRAR,NPDIM,PRM,WP)
C=======================================================================
C     READ PES FILE FULLY
C      - LOAD SET OF NECESSARY VARIABLES NECESSARY FOR WRITING NEW PES
C
C     OPERATION DEPENDS ON ISS:
C     ISS = 1     READ FULLY AND STORE ENTRIES
C     ISS = 2     READ FULLY, AND WRITE REPLICA WITH MAX-ITER=0

      USE DRIVER
      IMPLICIT NONE

      INTEGER IFAIL,NIUNIT,NPESLINES,IIOUT,ISS,IGETUNIT,IERR,NBLNK,I,
     +        ILINE,LLOC,ISTOP,ISTART,N,NIL,NPLIST,ND,INAMES,
     +        MAXITER,IPRCOV,IPRINT,LPRINT,NPNG,IPR,MPR,NPRIOR,
     +        NSETS,IP,IPRAR,IU,MPRAR,NPDIM
C      ISETN,
      INTEGER IUNIT(NIUNIT),ISETPLT(NSETS,ISETCNT),
     +        ISETTYP(NSETS),ISYMBOL(NSETS),IOMIT,
     +        IAPLOT(ND+IPR+MPR),LN(NPDIM),IPNG(NPDIM),
     +        IPLOT(ND+IPR+MPR),NIPR(IPRAR),ISENS(NPDIM)
      CHARACTER*100 AFNAM(NIUNIT)
      CHARACTER*200 PESTEXT(NPESLINES)
      CHARACTER*10 PARNEG(NPDIM),PARNAM(NPDIM),EQNAM(NPESLINES),
     +             NIPRNAM(NPESLINES),PARNAMU
      CHARACTER*83 FN
      REAL R, TOL,SOSC, MAXCHANGE,VMULT(NSETS),EV,DETWTP
      REAL WTP(IPRAR,IPRAR),BPRI(IPRAR),prm(nplist+1,MPRAR),
     +     WTPS(IPR+MPR,IPR+MPR),WP(MPRAR)
      DOUBLE PRECISION W3(IPRAR,IPRAR), W4(IPRAR)
      CHARACTER*12 NAMES(ND+IPR+MPR)
c     ------------------------------------------------------------------

      NIL = 0
C      ISETN = -99
      IU = IUNIT(26)
      EV = 1.0

      OPEN(IUNIT(26),FILE=AFNAM(26),STATUS='OLD',IOSTAT=IERR)
      IF(IERR.NE.0) THEN
        WRITE(IOUTP,10) AFNAM(26)(1:NBLNK(AFNAM(26)))
10      FORMAT('ERROR OPENING EXISTING MODFLOW .PES FILE ',a,'.')
        GO TO 999
      END IF

      IF (ISS.EQ.2) THEN
C       FOR THE NEW MAX-ITER=0 "PES" FILE
        IIOUT = IGETUNIT(1,95)
        FN = PAR_PREF//TRIM(ADJUSTL(AFNAM(26)))
        OPEN(IIOUT,FILE=FN,STATUS='UNKNOWN',IOSTAT=IERR)
        IF(IERR.NE.0) THEN
          WRITE(IOUTP,11) FN(1:NBLNK(FN))
11        FORMAT('ERROR OPENING "MAX-ITER=0" MODFLOW .PES FILE ',a,'.')
          GO TO 999
        END IF
        WRITE(IIOUT,12) 'MOD-PREDICT PRODUCED THIS ',FN(1:NBLNK(FN))
12      FORMAT('#',1X,A,' "MAX-ITER=0" .PES FILE ',A)
      ENDIF

C     WRITE NOTE THAT OMIT NOT ACTIVATED FOR PRIOR IN THIS VERSION
      WRITE(IOUTP,100)
100   FORMAT(3X,'(NOTE: "OMIT" NOT ACTIVATED FOR PRIOR IN MODPREDICT',
     +           ' VERSION-1)')

C     READ FULLY
      ILINE = 0
13    ILINE = ILINE + 1
      READ(IUNIT(26),'(A)',ERR=999) CLINE
      IF(CLINE(1:1).EQ.'#') GO TO 13
C     READ AND PARSE FIRST LINE
      LLOC = 1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,MAXITER,R,IOUTP,IUNIT(26))
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,3,N,MAXCHANGE,IOUTP,IUNIT(26))
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,3,N,TOL,IOUTP,IUNIT(26))
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,3,N,SOSC,IOUTP,IUNIT(26))
      IF(ISS.EQ.2)WRITE(IIOUT,*)NIL,MAXCHANGE,TOL,SOSC
C     READ AND STORE SECOND LINE
      ILINE = ILINE+1
      READ(IUNIT(26),'(A)',ERR=999) CLINE
      IF(ISS.EQ.2)WRITE(IIOUT,'(A)') CLINE
      PESTEXT(ILINE) = CLINE
C     READ AND PARSE THIRD LINE
      ILINE = ILINE+1
      READ(IUNIT(26),'(A)',ERR=999) CLINE
      LLOC = 1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,IPRCOV,R,IOUTP,IUNIT(26))
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,IPRINT,R,IOUTP,IUNIT(26))
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,LPRINT,R,IOUTP,IUNIT(26))
      IF (ISS.EQ.2)WRITE(IIOUT,'(3(1X,I3))') IPRCOV,IPRINT,LPRINT
C     READ AND STORE FOURTH LINE
      ILINE = ILINE+1
      READ(IUNIT(26),'(A)',ERR=999) CLINE
      IF(ISS.EQ.2)WRITE(IIOUT,'(A)') CLINE
      PESTEXT(ILINE) = CLINE
C     READ AND PARSE FIFTH LINE
      ILINE = ILINE+1
      READ(IUNIT(26),'(A)',ERR=999) CLINE
      LLOC = 1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NPNG,R,IOUTP,IUNIT(26))
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,IPR,R,IOUTP,IUNIT(26))
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,MPR,R,IOUTP,IUNIT(26))
      IF (ISS.EQ.2) WRITE(IIOUT,'(3(1X,I3))') NPNG,IPR,MPR
C     IF NEGATIVE PARAMETERS ALLOWED READ ONE INSTANCE OF LINE 6
      IF (NPNG.GT.0) THEN
        READ (IUNIT(26),*) (PARNEG(I),I=1,NPNG)
        IF (ISS.EQ.2) WRITE (IIOUT,*) (PARNEG(I),I=1,NPNG)
      ENDIF
      DO I = 1,NPNG
        CALL UCASE(PARNEG(I),PARNEG(I),1)
        DO IP = 1,NPLIST
          CALL UCASE(PARNAM(IP),PARNAMU,1)
          IF (PARNAMU.EQ.PARNEG(I)) THEN
            IPNG(I) = IP
            GOTO 6
          ENDIF
        END DO
        WRITE (IOUTP,640) PARNEG(I)
  640   FORMAT (/,' ERROR: PARAMETER NAME "',A,'" NOT DEFINED',/,
     &          ' -- STOP EXECUTION (SPRD1PES1RP)')
        IFAIL = 1
        RETURN
    6   CONTINUE
      END DO

C     PRIOR INFORMATION
      NPRIOR = IPR+MPR
      IF(NPRIOR.EQ.0) THEN
C     THERE IS NO PRIOR INFORMATION - NO LINES TO READ - RETURN
        WRITE(IOUTP,910) AFNAM(26)(1:NBLNK(AFNAM(26)))
        IF (ISS.EQ.2) THEN
          CLOSE(IIOUT)
          WRITE(IOUTP,911) FN(1:NBLNK(FN))
        END IF
      ELSE

C-------INITIALIZE NIPR AND WP
        IF (IPR.GT.0) NIPR = 0
        IF (MPR.GT.0) WP = 0.0

C  ==== READ FULL WEIGHT MATRIX FOR PRIOR INFORMATION (ITEMS 7, 8, 9)
c  ==== LEAVE MOST CHECKS TO MK2K ====
        IF (IPR.GT.0) THEN
            CALL SPRD1PES1WR(WTP,IPR,NIPR,IIOUT,IU,DETWTP,NPLIST,
     +                       MPR,EV,IERR,ISENS,NIPRNAM,IPRAR,IAPLOT,     !IAPLOT
     +                       INAMES,NAMES,ND,BPRI,LN,WTPS,W3,W4,ISS,
     +                       NIL,VMULT,NSETS,AFNAM(26),ISETPLT,ISYMBOL,
     +                       IFAIL,NPDIM)
            IF (IFAIL.NE.0) GOTO 1065
        END IF
        IF (MPR.GT.0) THEN
            CALL SPRD1PES1PI(EV,EQNAM,IIOUT,IU,LN,MPR,NPLIST,PRM,       !IAPLOT
     &                       WP,MPRAR,IAPLOT,NAMES,IPR,ND,IERR,
     &                       NIPR,IPRAR,IFAIL,PARNAM,ISS,AFNAM(26),
     +                       VMULT,NSETS,ISETPLT,ISYMBOL,NPDIM)
            IF (IFAIL.NE.0) GOTO 1065
        ENDIF

C       WRITE MESSAGE THAT FILE SUCCESSFULLY READ
        WRITE(IOUTP,910) AFNAM(26)(1:NBLNK(AFNAM(26)))
        IF (ISS.EQ.2) THEN
          CLOSE(IIOUT)
          WRITE(IOUTP,911) FN(1:NBLNK(FN))
        END IF
      END IF
      CLOSE(IUNIT(26))
      RETURN

535   FORMAT (//,' NIPR NAME',3X,'PLOT-SYMBOL',/,1X,10('-'),2X,11('-'))
560   FORMAT (1X,A10,2X,I7)
910   FORMAT(/,3X,'PES FILE ',A,' READ - OK')
911   FORMAT(3X,'"MAX-ITER=0" PES FILE ',A,' WRITTEN - OK')

999   WRITE(IOUTP,1000) afnam(26)(1:NBLNK(afnam(26)))
1000  FORMAT(/,1X,'ERROR ENCOUNTERED WITH PES FILE ',A,' - STOPPING')
      IFAIL = 1
      RETURN

1010  FORMAT(3X,'EQUATIONS OF PRIOR INFORMATION ON PARAMETERS')
1020  FORMAT(3X,' EQ. NAME   EQ. VALUE ',/
     +       3X,'---------- -----------')

C1059  WRITE(IOUTP,1060)
C1060  FORMAT(' END-OF-FILE REACHED DURING ATTEMPT TO ',
C     &        'READ PRIOR INFORMATION--STOP EXECUTION')
C      IFAIL = 1
1065  WRITE(IOUTP,1080)
1080  FORMAT('STOP EXECUTION (SPRD1PES1RP)')
      RETURN

      END

C=======================================================================
      SUBROUTINE SPRD1OBS1US(IFAIL,RUNTYPE,PREDBASE,
     +                     NPLIST,NPE,NDMH,NHT,H,HOBS,UWH,UWHOBS,
     +                     OBSNAME,OBSNAMED,PARNAMTEMP,PAROPT,NPDIM,
     +                     PESBASE,IPLOTOP,IPLOTD,MPR,IPR,ND,OBSBASE,
     +                     NHTP,NDMHP,NADVP,RES,UWRES,S_SU,SUMSQ)
C=======================================================================
C     READ UNDERSCORE FILES FROM MF2K RUNS

C     VERSION 1, JUN 2003 MJT (BORROWS HEAVILY FROM MF2K ROUTINES)

C     ACTION DEPENDS ON THE RUNTYPE PASSED FROM MAIN
C     - RUNTYPE CAN BE PASSED AS '4' WHICH INDICATES ONLY READ THE
C       'PES' UNDERSCORE FILES TO RETRIEVE THE OPTIMIZED PARAMETERS
C
C     IPLOTOP = PLOT-SYMBOL READ FROM "OBS" U_SCORE FILES FOR CHECKING
C     IPLOTD  = PLOT-SYMBOL READ FROM "SEN" U_SCORE FILES FOR CHECKING

C  FOR REFERENCE - LIST OF U_SCORES BELOW: NOT ALL ARE READ BY MODPREDICT

C      DATA (OBSSUF(I),I=1,6)/'._os','._ww','._ws','._r ','._w ','._nm'/
c     ._os - Unweighted simulated equivelents and observations
c     ._ww - Weighted simulated equivelents and observations
c     ._ws - Weighted simulated equivelents and residuals   **NOT READ**
c     ._r  - Unweighted residuals
c     ._w  - Weighted residuals
c     ._nm - Unweighted resids & prob. plotting positions   **NOT READ**
C      DATA (SENSUF(I),I=1,4)/'._sc','._sd','._s1','._su'/
c     ._sc - Composite scaled sensitivities and PARNAM
c     ._sd - Dimensionless scaled sensitivities, OBSNAM and PLOT-SYMBOL
c     ._s1 - 1% scaled sensitivities, OBSNAM and PLOT-SYMBOL
C     ._SU - UNSCALED SENSITIVITIES - NEW FILE CREATED FOR MODPREDICT
C      DATA (PESSUF(I),I=1,3)/'._ss','._pa','._b '/
c     ._ss - Sum Sq Wghted Resids                           **NOT READ**
c     ._pa - Parvals for each iteration                     **NOT READ**
c     ._b  - Parvals, SSWR, max, lambda

      USE DRIVER
      IMPLICIT NONE

      INTEGER IU,LENG,RUNTYPE,NPLIST,I,N,NPE,IIP,NN,NHTP,NDMHP,NDMH,NHT,
     +        IFAIL,ITER,MPR,IPR,ND,NADVP,NONB_LEN,IGETUNIT,J,LLOC,
     +        ISTOP,ISTART,IERR,IR,NPDIM,IPLOTOP(ND+MPR+IPR),
     +        IPLOTD(ND+MPR+IPR),IUGDO(6),IUSNO(4)
      CHARACTER*200 PREDBASE,PESBASE,OBSBASE
      CHARACTER*84 FN
      CHARACTER*20 HEADER_SD,FMT_SD
      CHARACTER*12 OBSNAME(ND+MPR+IPR),OBSNAMED(ND+MPR+IPR)
      CHARACTER*10 PARNAMTEMP(NPDIM)
      CHARACTER*3 AITN
      CHARACTER*4 ATEMP
      CHARACTER*8 PARTEXT
      REAL RR,TVAL,XP, SUMSQ
c      SUWH, OUWH,SWH, WTR,
      REAL H(ND+IPR+MPR),HOBS(ND+IPR+MPR),UWH(ND+IPR+MPR),
     +     UWHOBS(ND+IPR+MPR),RES(ND+IPR+MPR),UWRES(ND+IPR+MPR),
     +     PAROPT(NPDIM)
C      S_S1(NPDIM,ND),S_SD(NPDIM,ND),S_SC(NPDIM),
      DOUBLE PRECISION S_SU(NPDIM,ND)
c     ------------------------------------------------------------------

      IERR = 0

C  SET UP FORMATTED READS FOR THOSE HEADERS WHICH REQUIRE CHECKS

      WRITE(AITN,'(I3)') NPE
      AITN = ADJUSTL(AITN)
      FMT_SD = '(A20,'//TRIM(AITN)//'(2X,A10,3X))'
      LENG = NONB_LEN(PREDBASE,200)
C     IF NO PREDICTIONS - SHOULD BE NOTHING TO READ - STOP
      IF (NPRED.LT.1) THEN
        WRITE(*,2)
        WRITE(IOUTP,2)
2       FORMAT(/,1X,'NO PREDICTIONS FOR UNDERSCORE ROUTINE - STOPPING')
        GOTO 99
      END IF

C  REPORT NUMBER OF ITEMS TO BE READ FROM THE OBS UNDERSCORE FILE

      IF ((RUNTYPE.GT.1).AND.(RUNTYPE.NE.4)) THEN
          WRITE(IOUTP,3) NPRED+NOBS+MPR+IPR-NOMIT                       !MJT OCT2005
3         FORMAT(3X,'READING UNDERSCORES FOR ',I4,' OBS-PRED-PRIOR')
      END IF

C  OPEN AND READ THE APPROPRIATE UNDERSCORES FOR THE RUNTYPE
C  OBS PROCESS UNDERSCORES

      IF ((RUNTYPE.EQ.1).OR.(RUNTYPE.EQ.2).OR.(RUNTYPE.EQ.3)) THEN

C       LOOP TWICE - ONCE FOR OBS-PRIOR AND ONCE FOR PREDS

        DO IR = 1,2

          IUGDO = 0
          DO I=1,6
            IF (IR.EQ.1) THEN
              ISTART = 1
              ISTOP  = NPRED
              FN = PREDBASE(1:LENG)//OBSSUF(I)
            ELSE
              ISTART = NPRED+1
              ISTOP  = ND+IPR+MPR-NOMIT
              FN = OBSBASE(1:LENG)//OBSSUF(I)
            ENDIF
            IU = IGETUNIT(1,95)
            IUGDO(I) = IU
            IF (IUGDO(I).GT.0) THEN
              OPEN(IUGDO(I),FILE=TRIM(FN),STATUS='OLD',IOSTAT=IERR)
              IF (IERR.NE.0) THEN
                GOTO 99
              END IF
C             LOAD THE UNWEIGHTED SIMULATED EQUIVS HERE
              IF (I.EQ.1) then
                READ (IUGDO(I),*,END=4,ERR=99) (UWH(N), UWHOBS(N),
     +                          IPLOTOP(N), OBSNAME(N),N=ISTART,ISTOP)
              END IF
C             LOAD THE WEIGHTED SIMULATED EQUIVS HERE
              IF (I.EQ.2) then
                READ (IUGDO(I),*,END=4,ERR=99) (H(N), HOBS(N),
     +                          IPLOTOP(N), OBSNAME(N),N=ISTART,ISTOP)
              END IF
C             LOAD THE UNWEIGHTED "DIFFERENCES" HERE
              IF (I.EQ.4) then
                READ (IUGDO(I),*,END=4,ERR=99) (UWRES(N), IPLOTOP(N),
     +                                      OBSNAME(N),N=ISTART,ISTOP)
              END IF
C             LOAD THE WEIGHTED "DIFFERENCES" HERE
              IF (I.EQ.5) then
                READ (IUGDO(I),*,END=4,ERR=99) (RES(N), IPLOTOP(N),
     +                                      OBSNAME(N),N=ISTART,ISTOP)
              END IF
4             IF (OBSNAME(1).EQ.' ') THEN
                  CLOSE(IUGDO(I))
                  GOTO 99
              END IF
              WRITE(IOUTP,7) TRIM(FN)
              CLOSE(IUGDO(I))
            ELSE
              GOTO 99
            ENDIF
          END DO
        END DO
7       FORMAT(3X,'FILE ',A,' READ - OK')
        WRITE(IOUTP,400) 'ALL OBSERVATION UNDERSCORE '
      END IF
C     SUM OF SQUARED DIFFERENCES
      DO N=1,ND+IPR+MPR-NOMIT
        SUMSQ = SUMSQ + RES(N)**2.
      END DO

C  REPORT NUMBER OF PARAMETERS TO BE READ FROM THE SEN FILES

      IF (RUNTYPE.GT.1) THEN
        IF (NPE.LT.1) THEN
          WRITE(*,3)
          WRITE(IOUTP,12)
12        FORMAT(/,1X,'NO PARAMETERS FOR UNDERSCORE ROUTINE - STOPPING')
          GOTO 99
        ELSE
          WRITE(IOUTP,13) NPE
13        FORMAT(/,3X,'READING UNDERSCORES FOR ',I4,' PARAMETERS')
        END IF
      END IF

C  SEN PROCESS UNDERSCORE FILES

      IF ((RUNTYPE.EQ.2).OR.(RUNTYPE.EQ.3)) THEN

        IUSNO = 0
        DO IR = 1,2
          DO I=4,4
            IF (IR.EQ.1) THEN
              ISTART = 1
              ISTOP  = NPRED
              FN = PREDBASE(1:LENG)//SENSUF(I)
            ELSE
              ISTART = NPRED+1
              ISTOP  = ND-NOMIT
              FN = OBSBASE(1:LENG)//SENSUF(I)
            ENDIF
            IU = IGETUNIT(1,95)
            IUSNO(I) = IU
            IF (IUSNO(I).GT.0) THEN
              OPEN(IUSNO(I),FILE=TRIM(FN),STATUS='OLD',IOSTAT=IERR)
              IF (IERR.NE.0) THEN
                WRITE(*,*) 'PROBLEM ENCOUNTERED OPENING ',TRIM(FN)
                GOTO 99
              END IF
              IF (I.EQ.1) THEN
C               DON'T READ S_SC
              END IF
C           DIMENSIONLESS SCALED SENSITIVITIES
              IF (I.EQ.2) THEN
C               DON'T READ S_SD
              END IF
C           ONE-PERCENT SCALED SENSITIVITIES
              IF (I.EQ.3) THEN
C               DON'T READ S_S1
              END IF
C           UNSCALED SENSITIVITIES FROM NEW _SU FILE
              IF (I.EQ.4) THEN
                READ (IUSNO(I),FMT_SD,END=99,ERR=99)
     +                                 HEADER_SD,(PARNAMTEMP(N),N=1,NPE)
                DO N=ISTART,ISTOP
                  READ (IUSNO(I),15,END=99,ERR=99) OBSNAMED(N),
     +                                 IPLOTD(N),(S_SU(IIP,N),IIP=1,NPE)
                END DO
              END IF
15            FORMAT(1X,A12,1X,I6,500(1X,G14.7))
              WRITE(IOUTP,20) TRIM(FN)
              CLOSE(IUSNO(I))
            ELSE
              GOTO 99
            END IF
          END DO
        END DO
20      FORMAT(3X,'FILE ',A,' READ - OK')
        WRITE(IOUTP,400) 'ALL SENSITIVITY UNDERSCORE '
      END IF

C  PES PROCESS UNDERSCORES - WHEN RUNTYPE PASSED AS '4' READ OPTIMIZED VALUES

      IF (RUNTYPE.EQ.4) THEN
        ITER = 0
        IUGDO = 0
        DO I=1,3
          IU = IGETUNIT(1,95)
          IUGDO(I) = IU
        END DO
        DO I=3,3                                                        !READ ONLY THE "_B" FILE
          FN = PESBASE(1:LENG)//PESSUF(I)
          IF (IUGDO(I).GT.0) THEN
            OPEN(IUGDO(I),FILE=TRIM(FN),STATUS='OLD',IOSTAT=IERR)
            IF (IERR.NE.0) THEN
              GOTO 99
            END IF
            DO J=1,100000
              READ(IUGDO(I),'(A)',ERR=99,end=26) CLINE
C             IF PES FAILED LOAD 'FINAL' PARAMETERS AND EXIT THE DO
              IF (CLINE(1:27).EQ.' FINAL PARAMETER ESTIMATES:') THEN
                  WRITE(IOUTP,25)
25                FORMAT(3X,'PARAMETER ESTIMATION DID NOT CONVERGE',
     +                      ' - USING "FINAL PARAMETER ESTIMATES"')
                  EXIT
              ELSE IF(CLINE(1:21).EQ.' PARAMETER-VALUE SET ') THEN
C                 USE ITER TO TRACK THE FINAL ITERATION NUMBER
                  ATEMP=ADJUSTL(CLINE(22:25))
                  LLOC=1
                  CALL URWORD(ATEMP,LLOC,ISTART,ISTOP,2,ITER,RR,IOUTP,0)
              END IF
            END DO
26          CONTINUE
C           IF PES SUCCEEDED BACKSPACE TO LAST ITERATION PARAMETER VALUES
            IF (ITER.NE.0) THEN
              WRITE(IOUTP,27) ITER
27            FORMAT(3X,'- USING VALUES FROM ITERATION NO: ',I4)
              DO NN=1,NPLIST+1
                BACKSPACE(IUGDO(I))
              END DO
            ENDIF
            DO NN=1,NPLIST
              LLOC=1
              READ(IUGDO(I),'(A)',ERR=99,end=90) CLINE
              CALL URWORD(CLINE,LLOC,ISTART,ISTOP,0,N,RR,IOUTP,0)
              PARNAMTEMP(NN)=CLINE(ISTART:ISTOP)
              CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,N,RR,IOUTP,0)
              CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,N,RR,IOUTP,0)
              CALL URWORD(CLINE,LLOC,ISTART,ISTOP,3,N,XP,IOUTP,0)
              PAROPT(NN) = XP
              CALL UWRTSIG(IFAIL,PAROPT(NN),PARTEXT,8,0,TVAL,1)
              WRITE(IOUTP,32) PARNAMTEMP(NN),PARTEXT
32            FORMAT(3X,'- PARAMETER: ',A,'  VALUE: ',A)
            END DO
            CLOSE(IUGDO(I))
          ELSE
            GOTO 99
          ENDIF
        END DO
33      FORMAT(3X,'FILE ',A,' READ - OK')
        WRITE(IOUTP,400) 'ALL PARAMETER-ESTIMATION UNDERSCORE '

      ENDIF

400   FORMAT(3X,A,'FILES READ - OK')
      RETURN

90    WRITE(IOUTP,91) TRIM(FN)
91    FORMAT(/,1X'UNEXPECTED END TO PARAMETER FILE ',A)
      CLOSE(IUGDO(I))
      IFAIL = 1
      RETURN

99    WRITE(IOUTP,100)
      WRITE(*,100)
100   FORMAT(/,1X,'ERROR READING UNDERSCORE FILES - STOPPING')
      WRITE(IOUTP,101)
      WRITE(*,101)
101   FORMAT(/,1X,'CHECK .GLO AND/OR .LST FILES FOR ERRORS IN THE ',
     +             'MF2K RUN')

      IFAIL = 1
      WRITE(IOUTP,1000)
1000  FORMAT('STOP EXECUTION (SPRD1OBS1US)')
      RETURN

      END

C=======================================================================
      SUBROUTINE SPRD1PRD1RD(IFAIL,APRED,IPRD,MODNAMFILE)
C=======================================================================
c     READ THE MOD-PREDICT INPUT FILE TO OBTAIN MODFLOW EXECUTABLE
C     NAME, MODFLOW NAME FILE, PREFIXES
C     VERSION 1, FEB 2003 JED
C     MODIFIED MAR, JUN, AUG 2003 MJT

      USE DRIVER
      IMPLICIT NONE

      INTEGER  IFAIL,IBLOCK,ILINE,IIN,IERR,NBLNK,IPRD,
     +         LEFT_WORD(2),RIGHT_WORD(2),ISTART
      CHARACTER*50 ABLOCK,BLOCKA
      CHARACTER*100 MODNAMFILE
      CHARACTER*200 APRED
c     ------------------------------------------------------------------

      IFAIL = 0
      IIN   = IPRD
      OPEN(IIN,FILE=APRED,STATUS='OLD',IOSTAT=IERR)
      IF(IERR.NE.0) THEN
        WRITE(IOUTP,1) APRED(1:NBLNK(APRED))
1       FORMAT(//,1X,'ERROR OPENING PREDICTION INPUT FILE ',A)
        GO TO 999
      END IF
      WRITE(IOUTP,2) APRED
      WRITE(*,2) APRED
2     FORMAT(/,1X,'READING PREDICTION INPUT FILE ',A)

C     INTIALIZE
      ILINE  = 0
      IBLOCK = 0
      ISTART = 0

      DO
        ILINE = ILINE + 1
        READ(IIN,'(A)',ERR=999,END=100) CLINE
        IF(CLINE.EQ.' ') CYCLE
        IF(CLINE(1:1).eq.'#') CYCLE
        CLINE = ADJUSTL(CLINE)
        CALL ULINESPLIT(IFAIL,2,LEFT_WORD(1),RIGHT_WORD(1),CLINE)
        IF(IERR.NE.0)THEN
          WRITE(IOUTP,3) ILINE,TRIM(APRED)
3         FORMAT(//,1X,'TWO ENTRIES EXPECTED ON LINE ',I4,' OF FILE ',A)
          GO TO 999
        END IF
        ABLOCK = CLINE(LEFT_WORD(1):RIGHT_WORD(1))
        CALL UCASETRANS(ABLOCK,'hi')
        IF(TRIM(ABLOCK).EQ.'START')THEN
            IBLOCK = IBLOCK + 1
          ELSE
            IF (ISTART.EQ.0) THEN
              WRITE(IOUTP,4) ILINE,TRIM(APRED)
4             FORMAT(//,1X,'FIRST ITEM ON LINE ',I4,' OF FILE ',A,
     +           ' MUST BE "START".')
              GO TO 999
            END IF
        END IF
        ABLOCK=CLINE(LEFT_WORD(2):RIGHT_WORD(2))
        CALL UCASETRANS(ABLOCK,'hi')
        IF (ISTART.LE.0) THEN
          IF(IBLOCK.EQ.1) THEN
            IF (TRIM(ABLOCK).NE.'MF2K_DATA')THEN
              WRITE(IOUTP,5) ILINE,TRIM(APRED)
5             FORMAT(//,1X,'FIRST ITEM ON LINE ',I4,' OF FILE ',A,
     +           ' MUST BE "MF2K_DATA".')
              GO TO 999
            ELSE
              WRITE(IOUTP,*) '- READING BLOCK MF2K DATA'
              BLOCKA = ABLOCK
              READ(IIN,'(A)',ERR=999,END=100) CLINE
            END IF
          ELSE IF (IBLOCK.EQ.2) THEN
            IF (TRIM(ABLOCK).NE.'FILENAMES')THEN
              WRITE(IOUTP,6) ILINE,TRIM(APRED)
6             FORMAT(//,1X,'FIRST ITEM ON LINE ',I4,' OF FILE ',A,
     +           ' MUST BE "FILENAMES".')
              GO TO 999
            ELSE
              WRITE(IOUTP,*) '- READING BLOCK FILENAMES'
              BLOCKA = ABLOCK
              READ(IIN,'(A)',ERR=999,END=100) CLINE
            END IF
          END IF
        END IF
        ISTART = 1
        IF(CLINE.EQ.' ') CYCLE
        IF(CLINE(1:1).eq.'#') CYCLE
        CLINE = ADJUSTL(CLINE)
        CALL ULINESPLIT(IFAIL,2,LEFT_WORD(1),RIGHT_WORD(1),CLINE)
        IF(IERR.NE.0)THEN
          WRITE(IOUTP,8) ILINE,TRIM(APRED)
8         format(//,1X,'TWO ENTRIES EXPECTED ON LINE ',I4,' OF FILE ',A)
          GO TO 999
        END IF
        ABLOCK=CLINE(LEFT_WORD(1):RIGHT_WORD(1))
        CALL UCASETRANS(ABLOCK,'hi')
        IF(TRIM(ABLOCK).EQ.'MODFLOW_NAME_FILE')THEN
            MODNAMFILE=CLINE(LEFT_WORD(2):RIGHT_WORD(2))
            WRITE(IOUTP,9) ADJUSTL(MODNAMFILE)
9           FORMAT(3X,'MODFLOW NAME FILE               : ',A)
        ELSE IF(TRIM(ABLOCK).EQ.'MODFLOW_COMMAND')THEN
            MF2KCOM=CLINE(LEFT_WORD(2):RIGHT_WORD(2))
            WRITE(IOUTP,10) ADJUSTL(MF2KCOM)
10          FORMAT(3X,'MODFLOW COMMAND                 : ',A)
        ELSE IF(TRIM(ABLOCK).EQ.'OBSERVATION_RUN_FILENAME_BASE')THEN
            OBS_PREF = CLINE(LEFT_WORD(2):RIGHT_WORD(2))
            WRITE(IOUTP,13) ADJUSTL(OBS_PREF)
13          FORMAT(3X,'OBSERVATION RUN FILENAME BASE   : ',A)
        ELSE IF(TRIM(ABLOCK).EQ.'PREDICTION_RUN_FILENAME_BASE')THEN
            PRE_PREF = CLINE(LEFT_WORD(2):RIGHT_WORD(2))
            WRITE(IOUTP,14) ADJUSTL(PRE_PREF)
14          FORMAT(3X,'PREDICTION RUN FILENAME BASE    : ',A)
        ELSE IF(TRIM(ABLOCK).EQ.'PARAMETER_ESTIMATION_FILENAME_BASE')
     +         THEN
            PAR_PREF = CLINE(LEFT_WORD(2):RIGHT_WORD(2))
            WRITE(IOUTP,16) ADJUSTL(PAR_PREF)
16          FORMAT(3X,'PARAMETER ESTIMATION FILENAME BASE     : ',A)
        ELSE IF(TRIM(ABLOCK).EQ.'END')THEN
            WRITE(IOUTP,20) ADJUSTL(BLOCKA)
20          FORMAT(1X,'- READ BLOCK ',A)
            ISTART = 0
        ELSE
          WRITE(IOUTP,50) TRIM(ABLOCK),ILINE,TRIM(APRED)
50        FORMAT(' UNRECOGNIZED BLOCK TITLE "',A,'" AT LINE ',I4,
     +           ' OF PREDICTION INPUT FILE ',A)
          IFAIL = 1
          RETURN
        END IF
      END DO

100   IF (IBLOCK.EQ.1) THEN
        WRITE(IOUTP,101) APRED
101     FORMAT(/,3X,'"FILENAMES" BLOCK NOT FOUND IN FILE ',A,
     +         /,3X,'THE FOLLOWING DEFAULTS WILL BE USED: ',
     +         /,3X,'PREDICTIONS_ONLY:       "PR_"        ',
     +         /,3X,'OBSERVATIONS ONLY:      "OB_"        ',
     +         /,3X,'PARAMETER ESTIMATION:   "PE_"        ')
        PRE_PREF = 'PR_'
        OBS_PREF = 'OB_'
        PAR_PREF = 'PE_'
      END IF
      RETURN

999   WRITE(IOUTP,1000) APRED
1000  FORMAT(//,3X,'ERROR READING FILE ',A,' - STOPPING')
      IFAIL = 1
      WRITE(IOUTP,1050)
1050  FORMAT('STOP EXECUTION (SPRD1PRD1RD)')
      RETURN
      END

C=======================================================================
      SUBROUTINE SPRD1SETS1AL(IFAIL,IUS,NSETS)
C=======================================================================
C     READ SETS FILE, RETURN DIMENSIONS FOR ALLOCATION IN MAIN PROGRAM
C     VERSION 1, AUG 2003 MJT

      USE DRIVER
      IMPLICIT NONE

      INTEGER IUS,LLOC,ISTART,ISTOP,NSETS,IFAIL
      REAL RDUM
      CHARACTER*200 LINE
c     ------------------------------------------------------------------

      NSETS=0

C     READ NUMBER OF OBSERVATION SETS
      CALL URDCOM(IUS,0,LINE)
      LLOC = 1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,NSETS,RDUM,IOUTP,IUS)
      WRITE(IOUTP,30) NSETS
30    FORMAT(3X,'NUMBER OF SETS: ',I5)
C     NSETS CAN'T BE NEGATIVE
      IF (NSETS.LT.0) THEN
        WRITE (IOUTP,40)
40      FORMAT (/,1X,'NSETS CAN NOT BE NEGATIVE -- STOPPING')
        IFAIL = 1
      ENDIF
C     TURN OFF SETS FUNCTIONALITY IF THERE ARE NO SETS
      IF (NSETS.EQ.0)THEN
        WRITE(IOUTP,50)
50      FORMAT(/,1X,'NSETS PROVIDED AS ZERO - STOPPING')
        IFAIL = 1
      END IF
      IF (IFAIL.NE.0) THEN
          WRITE(IOUTP,1000)
1000      FORMAT('STOP EXECUTION (SPRD1SETS1AL)')
      ENDIF

      RETURN
      END

C=======================================================================
      SUBROUTINE SPRD1SETS1RP(IFAIL,NSETS,ISETTYP,ISETPRN,
     +                        ISENSCAL,ISETPLT,VMULT,IUS,SETNAM,ISYMBOL)
C=======================================================================
C     READ, CHECK AND STORE CALIBRATION/PREDICTION/PRIOR_INFORMATION
C     SET DATA.
C
C     VERSION 1, 20030211, JED
C     MODIFIED MAR/JUN/AUG 2003, MJT
C
C     THE ORIGINAL "ALLSIM" and "SENSCAL" OPTIONS ARE NOT ACTIVE BUT
C     SOME OF THE CODE IS LEFT IN FOR POSSIBLE FUTURE USE.

      USE DRIVER
      IMPLICIT NONE

      INTEGER NSETS,ISETTYP,ISETPRN,ISENSCAL,ISETPLT,K,ISYMBOL,
     +        IUS,IFAIL,I,LINLEN,LLOC,IDUM,ISTOP,ISTART,JJ,J,NONB_LEN
      REAL VMULT,RDUM
      CHARACTER*3 YESNO
      CHARACTER*12 SETNAM,AWORD,BWORD
      CHARACTER*200 LINE
      DIMENSION YESNO(2)
      DIMENSION ISETTYP(NSETS),ISETPRN(NSETS),ISENSCAL(NSETS),
     +          ISETPLT(NSETS,ISETCNT),VMULT(NSETS),SETNAM(NSETS),
     +          ISYMBOL(NSETS)
      DATA YESNO /'NO ','YES'/
c     ------------------------------------------------------------------
C
C-----SUPPLY DEFAULT VALUES TO SET VARIABLES.
      IFAIL = 0
      ISETTYP = 1
      ISETPRN = 0
      ISYMBOL = 1
      ISENSCAL = -99999999
      ISETPLT  = -99999999
      VMULT = 1.0
      LINLEN=LEN(LINE)
C
C-----THE SETS DATA IS NOW READ
      DO 200 I = 1,NSETS
        LLOC = 1
  210   READ(IUS,220,END=9000) LINE
  220   FORMAT(A)
        IF(LINE.EQ.' ') GO TO 210
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,0,IDUM,RDUM,IOUTP,IUS)
        SETNAM(I)=LINE(ISTART:ISTOP)
        IF(SETNAM(I).EQ.'-99999999')THEN
          WRITE(IOUTP,225)
  225     FORMAT(' ILLEGAL SET NAME --  -99999999')
          GO TO 9900
        END IF
  230   CONTINUE
        CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,IDUM,RDUM,IOUTP,IUS)
        IF(ISTART.EQ.LINLEN) GO TO 265
        AWORD=LINE(ISTART:ISTOP)
        IF(AWORD.EQ.'PRINT')THEN
          ISETPRN(I) = 1
        ELSE IF(AWORD.EQ.'NOPRINT')THEN
          ISETPRN(I) = 0
        ELSE IF(AWORD.EQ.'PREDICTION')THEN
          ISETTYP(I) = 2
        ELSE IF(AWORD.EQ.'CALIBRATION')THEN
          ISETTYP(I) = 1
        ELSE IF(AWORD.EQ.'OMIT')THEN
          ISETTYP(I) = 0
        ELSE IF(AWORD.EQ.'MULT')THEN
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,IDUM,RDUM,-1,IUS)
          IF(ISTART.EQ.LINLEN)GO TO 9100
          IF(LINE(ISTART:ISTOP).NE.'=') GO TO 9100
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,IDUM,VMULT(I),-1,IUS)
          IF(LINE(LINLEN:LINLEN).EQ.'E') GO TO 9200
          IF(VMULT(I).LE.0.0) GO TO 9300
        ELSE IF(AWORD.EQ.'SENSCAL')THEN
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,IDUM,RDUM,-1,IUS)
          IF(ISTART.EQ.LINLEN) GO TO 9100
          IF(LINE(ISTART:ISTOP).NE.'=') GO TO 9100
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ISENSCAL(I),RDUM,-1,IUS)
          IF(LINE(LINLEN:LINLEN).EQ.'E') GO TO 9200
          JJ=ISENSCAL(I)
          IF((JJ.NE.0).AND.(JJ.NE.1).AND.(JJ.NE.2).AND.(JJ.NE.3).
     &    AND.(JJ.NE.11).AND.(JJ.NE.12).AND.(JJ.NE.13))
     &    GO TO 9300
        ELSE IF(AWORD.EQ.'PLOT-SYMBOL')THEN
C         IF 'PLOT-SYMBOL' THEN THERE IS ONLY ONE IN THIS SET
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,IDUM,RDUM,-1,IUS)
          IF(ISTART.EQ.LINLEN) GO TO 9100
          IF(LINE(ISTART:ISTOP).NE.'=') GO TO 9100
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ISETPLT(I,1),RDUM,-1,IUS)
          IF(LINE(LINLEN:LINLEN).EQ.'E') GO TO 9200
          IF(ISETPLT(I,1).EQ.-99999999)THEN
            WRITE(IOUTP,260)
  260       FORMAT(/,' ILLEGAL PLOT-SYMBOL - DO NOT USE -99999999')
            GO TO 9900
          END IF
        ELSE IF(AWORD.EQ.'PLOT-SYMBOLS')THEN
C         IF 'PLOT-SYMBOLS' THEN THERE ARE MORE THAN ONE IN THIS SET
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,1,IDUM,RDUM,-1,IUS)
          IF(ISTART.EQ.LINLEN) GO TO 9100
          IF(LINE(ISTART:ISTOP).NE.'=') GO TO 9100
C         FIRST ITEM IS NUMBER OF PLOT-SYMBOLS IN THE SET
          CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ISYMBOL(I),RDUM,-1,IUS)
          IF(LINE(LINLEN:LINLEN).EQ.'E') GO TO 9200
          IF (ISYMBOL(I).LE.0) THEN
              WRITE(IOUTP,261) SETNAM(I)
  261         FORMAT(//,1X,'ISYMBOL MUST BE GREATER THAN ZERO IN SET ',
     +                      A,' - STOPPING')
              GOTO 9900
          ELSEIF(ISYMBOL(I).GT.20) THEN
              WRITE(IOUTP,262) SETNAM(I)
  262         FORMAT(//,1X,'ISYMBOL GREATER THAN 20 IN SET ',A,
     +                     ' - INCREASE SIZE OF PARAMETER "ISETCNT" IN',
     +                /,1X,' MODULE AND RECOMPILE MODPREDICT')
              GOTO 9900
          ENDIF
          DO K = 1,ISYMBOL(I)
            CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ISETPLT(I,K),
     +                                                      RDUM,-1,IUS)
            IF(LLOC.EQ.ISTART.AND.ISTART.EQ.200)THEN
              WRITE(IOUTP,263)
  263         FORMAT(//,1X,'ERROR: "PLOT-SYMBOLS" KEYWORD USED BUT ',
     +                     'INSUFFICIENT PLOT SYMBOLS FOLLOW.')
              GO TO 9900
            END IF
            IF(LINE(LINLEN:LINLEN).EQ.'E') GO TO 9200
            IF(ISETPLT(I,K).EQ.-99999999)THEN
              WRITE(IOUTP,264)
  264         FORMAT(/,' ILLEGAL PLOT-SYMBOL - DO NOT USE -99999999')
              GO TO 9900
            END IF
          END DO
        ELSE
          GO TO 9500
        END IF
        GO TO 230
  265   CONTINUE
  200 CONTINUE
C
C-----DUPLICATE SET NAMES ARE SEARCHED FOR
      IF(NSETS.GT.1)THEN
        DO 290 I = 1,NSETS-1
          DO 280 J = I+1,NSETS
            IF(SETNAM(I).EQ.SETNAM(J)) THEN
              WRITE(IOUTP,270) SETNAM(I)(1:NONB_LEN(SETNAM(I),12)),IUS
  270         FORMAT(/,' THE SAME SET NAME - "',A,'" IS USED MORE ',
     +        'THAN ONCE ON UNIT',I4)
              GO TO 9900
            END IF
  280     CONTINUE
  290   CONTINUE
      END IF
C
C-----DEFAULT VALUES ARE ADJUSTED FOR PREDICTION SETS.
      DO 300 I = 1,NSETS
        IF(ISETTYP(I).EQ.2)THEN
          IF(ISENSCAL(I).EQ.-99999999) ISENSCAL(I)=11
        ELSE IF(ISETTYP(I).EQ.1)THEN
          IF(ISENSCAL(I).EQ.-99999999) ISENSCAL(I)=0
        ELSE IF(ISETTYP(I).EQ.0)THEN
          ISENSCAL(I)=0
        END IF
  300 CONTINUE
      IFAIL=0
C
C-----SETS DATA IS RECORDED ON THE OUTPUT FILE
      WRITE(IOUTP,320)
  320 FORMAT(/,3X,'INFORMATION ON CALIBRATION/PREDICTION/PRIOR_INFO ',
     &'SETS LISTED IN SETS FILE')
      WRITE(IOUTP,330)
  330 FORMAT(3X,'DEFAULTS USED (EXCEPT FOR PLOT-SYMBOL) WHERE NO ',
     &'INFORMATION SUPPLIED')
      WRITE(IOUTP,340)
  340 FORMAT(/,3X,'SET NAME',T13,'TYPE',T27,'VARIANCE',T40,
     +'PLOT-SYMBOL',T53,'STATS AND ')
      WRITE(IOUTP,350)
  350 FORMAT(T27,'MULTIPLIER',T53,'SENSITIVITY?')

      WRITE(IOUTP,355)
  355 FORMAT(3X,'--------',T13,'------------',T27,'----------',T40,
     +       '-----------',T53,'------------')

      DO 400 I=1,NSETS
        IF(ISETTYP(I).EQ.0)THEN
          AWORD = 'OMIT'
        ELSE IF(ISETTYP(I).EQ.1)THEN
          AWORD = 'CALIBRATION'
        ELSE
          AWORD = 'PREDICTION'
        END IF
        DO K=1,ISYMBOL(I)
          IF(ISETPLT(I,K).EQ.-99999999)THEN
            BWORD = 'not supplied'
          ELSE
            BWORD=' '
            WRITE(BWORD(5:),'(I8)') ISETPLT(I,K)
            BWORD(5:)=ADJUSTL(BWORD(5:))
          END IF
          WRITE(IOUTP,360) SETNAM(I)(1:NONB_LEN(SETNAM(I),12)),
     +                   AWORD(1:NONB_LEN(AWORD,12)),
     +                   VMULT(I),
     +                   BWORD(1:NONB_LEN(BWORD,12)),
     +                   YESNO(ISETPRN(I)+1)
  360     FORMAT(3X,A,T13,A,T27,1PG12.5,T40,A,T53,A)
        END DO
  400 CONTINUE
      CLOSE(IUS)
      RETURN

 9000 CONTINUE
      WRITE(IOUTP,9010) IUS
 9010 FORMAT(/,' END-OF-FILE REACHED DURING ATTEMPT TO ',
     &       'READ SETS DATA ON UNIT',I4)
      GO TO 9900
 9100 CONTINUE
      WRITE(IOUTP,9110) AWORD(1:NONB_LEN(AWORD,12)),IUS
 9110 FORMAT(/,' "=" SIGN EXPECTED FOLLOWING "',A,'" KEYWORD ',
     &       'ON UNIT',I4)
      GO TO 9900
 9200 CONTINUE
      WRITE(IOUTP,9210) AWORD(1:NONB_LEN(AWORD,12)),IUS
 9210 FORMAT(/,' CANNOT READ NUMBER FOLLOWING "',A,'" KEYWORD ',
     &       'ON UNIT',I4)
      GO TO 9900
 9300 WRITE(IOUTP,9310) AWORD(1:NONB_LEN(AWORD,12)),IUS
 9310 FORMAT(/,' INAPPROPRIATE NUMBER FOLLOWING "',A,'" KEYWORD ',
     &       'ON UNIT',I4)
      GO TO 9900
C 9400 WRITE(IOUTP,9410) AWORD(1:NONB_LEN(AWORD,12)),IUS
C 9410 FORMAT(/,' INAPPROPRIATE ENTRY FOLLOWING "',A,'" KEYWORD ',
C     &       'ON UNIT',I4)
C      GO TO 9900
 9500 WRITE(IOUTP,9510) AWORD(1:NONB_LEN(AWORD,12)),IUS
 9510 FORMAT(/,' UNKNOWN SET KEYWORD "',A,'" ENCOUNTERED ON UNIT',I4)
      GO TO 9900

 9900 WRITE(IOUTP,*)
 9910 FORMAT(' STOP EXECUTION (SPRD1SETS1RP)')
      IFAIL = 1

      RETURN
      END

C=======================================================================
      SUBROUTINE SPRD1SETS1SM(H,HOBS,UWH,UWHOBS,ND,MPR,IPR,NPLIST,NSETS,
     &                      NSETDIM,ISETTYP,ISETNUM,SUMSTAT,
     +                      SETNAM,IOP,IOSTAR,IAPLOT,ISETPLT,NAMES,
     +                      RES,UWRES,ISYMBOL,NPE,OBSTYPE,IFAIL)
C=======================================================================
C     CALCULATE SUMMARY STATISTICS FOR SPECIFIED OBS/PRIOR/PRED SETS
C
C     VERSION 1, 20030211, JED
C     MODIFIED MAR, JUN, AUG, OCT 2003, MJT

      USE DRIVER
      IMPLICIT NONE

      REAL H, HOBS,UWHOBS,RES,SUMSTAT,UWH,LARGEST,SMALLEST,SOSWR,SE,
     +     SOABS,SOWABS,UWRES,RESMAX,UWRESMAX,RESMIN,UWRESMIN,AVGH,
     +     UWAVGH,RESAVG,UWRESAVG,USLARGEST,USSMALLEST,EVP
      INTEGER NGTREF,NLTREF,NSUMS,ISETPLT,I,NPLIST,NSETDIM, IPR, J, NDD,
     +        NSS, MPR, N, ND, NSETS, IOP, IOSTAR, ISETTYP,
     +        ISETNUM, ISYMBOL,K, NPE,PSOUT(6),IAPLOT(ND+IPR+MPR),IFAIL,
     +        IGETUNIT,IERR
C      NIPR,
      CHARACTER*12 SETNAM,OBSTYPE(ND+IPR+MPR),
     +             NAMES(ND+IPR+MPR)
      CHARACTER*200 FNAM
      DIMENSION H(ND+IPR+MPR), HOBS(ND+IPR+MPR),UWH(ND+IPR+MPR),
     +          UWHOBS(ND+IPR+MPR),RES(ND+IPR+MPR),UWRES(ND+IPR+MPR),
     +          ISETTYP(NSETDIM),SETNAM(NSETDIM),SUMSTAT(NSETDIM,20),
     +          ISETPLT(NSETDIM,ISETCNT),
     +          ISETNUM(ND+IPR+MPR),ISYMBOL(NSETS)
C     ------------------------------------------------------------------
c     IPR  -  no. of prior info eqns for which covariance matrix supplied
c     MPR  -  no. of prior info eqns just supplied as equations
c     ND   -  total no. of observations+predictions+omitted

C      NIPR    =1
      SUMSTAT = 0.
      ISETNUM = 0

C     FORMAT STATEMENTS FOR THE SUMMARY UNDERSCORE FILES

1     FORMAT(1x,' SETNAM     ',T12,' SETNUM     ',T24,' PLOTSYMBOL ',
     +       T36,'  OBSNAME   ',
     +       T50,'  WEIGHTED  ',T64,'  WEIGHTED  ',/,
     +       T50,' SIMULATED  ',T64,' OBSERVATION',/,
     +       T50,' EQUIVALENT ')
2     FORMAT(1x,' SETNAM     ',T12,' SETNUM     ',T24,' PLOTSYMBOL ',
     +       T36,'  OBSNAME   ',
     +       T50,' UNWEIGHTED ',T64,' UNWEIGHTED ',/,
     +       T50,' SIMULATED  ',T64,' OBSERVATION',/,
     +       T50,' EQUIVALENT ')
3     FORMAT(1X,' SETNAM     ',T12,' SETNUM     ',T24,' PLOTSYMBOL ',
     +       T36,'  OBSNAME   ',
     +       T50,' WEIGHTED   ',T64,' UNWEIGHTED ',
     +       T50,' DIFFERENCE ',T64,' DIFFERENCE ')
4     FORMAT(1X,' SETNAM     ',T12,' SETNUM     ',T24,' PLOTSYMBOL ',
     +       T36,'  OBSNAME   ',
     +       T50,'   SCALED   ',T64,'   SCALED   ',/,
     +       T50,' SIMULATED  ',T64,' OBSERVATION',/,
     +       T50,' EQUIVALENT ')
5     FORMAT(1X,' SETNAM     ',T12,' SETNUM     ',T24,' PLOTSYMBOL ',
     +       T36,'  OBSNAME   ',
     +       T50,'  UNSCALED  ',T64,'  UNSCALED  ',/,
     +       T50,' SIMULATED  ',T64,' OBSERVATION',/,
     +       T50,' EQUIVALENT ')
6     FORMAT(1X,' SETNAM     ',T12,' SETNUM     ',T24,' PLOTSYMBOL ',
     +       T36,'  OBSNAME   ',
     +       T50,'  SCALED    ',T64,'  UNSCALED  ',
     +       T50,' DIFFERENCE ',T64,' DIFFERENCE ')
C
       IF(NSETS.EQ.0) RETURN

C     SET UP IPLOT-ISETPLOT-SETNAME RELATIONSHIP & ECHO TABLE TO RUNFILE
      IF (IOP.EQ.1) THEN
        WRITE(IOUTP,10) 'CALIBRATION'
c       OPEN UNDERSCORE FILES CONTAINING CALIBRATION SET MEMBER SUMMARIES
        DO I=1,3
          PSOUT(I) = IGETUNIT(1,95)
          FNAM=TRIM(ADJUSTL(OUTPATH))//OBS_PREF//
     +         TRIM(ADJUSTL(BASENAM))//SUMSUF(I)
          OPEN(PSOUT(I),FILE=FNAM,STATUS='REPLACE',IOSTAT=IERR)
          IF (IERR.NE.0) THEN
            WRITE(IOUTP,8) FNAM
            IFAIL = 1
            RETURN
          END IF
          if (i.eq.1) WRITE(PSOUT(I),1)
          if (i.eq.2) WRITE(PSOUT(I),2)
          if (i.eq.3) WRITE(PSOUT(I),3)
        END DO
      ELSEIF (IOP.EQ.2) THEN
        WRITE(IOUTP,10) 'PREDICTION'
c       OPEN UNDERSCORE FILES CONTAINING PREDICTION SET MEMBER SUMMARIES
        DO I=1,3
          PSOUT(I) = IGETUNIT(1,95)
          FNAM=TRIM(ADJUSTL(OUTPATH))//PRE_PREF//
     +         TRIM(ADJUSTL(BASENAM))//SUMSUF(I+3)
          OPEN(PSOUT(I),FILE=FNAM,STATUS='REPLACE',IOSTAT=IERR)
          IF (IERR.NE.0) THEN
            WRITE(IOUTP,8) FNAM
            IFAIL = 1
            RETURN
          END IF
          if (i.eq.1) WRITE(PSOUT(I),4)
          if (i.eq.2) WRITE(PSOUT(I),5)
          if (i.eq.3) WRITE(PSOUT(I),6)
        END DO
      ENDIF
8     FORMAT(/,1X,'ERROR OPENING SUMMARY UNDERSCORE FILE ',A)
10    FORMAT(//,1X,'WRITING SUMMARY UNDERSCORES FOR MEMBERS OF ',A,
     +      ' SETS ==')
C
      DO I=1,NSETS
        DO J=1,ND+IPR+MPR
          DO K=1,ISYMBOL(I)
            IF((ISETPLT(I,K).EQ.IAPLOT(J)).AND.(ISETTYP(I).EQ.IOP))THEN
              ISETNUM(J) = I
c              WRITE(IOUTP,20) SETNAM(I),ISETNUM(J),IAPLOT(J),
c     +                        NAMES(J),H(J),HOBS(J),UWH(J),
c     +                        UWHOBS(J),RES(J),UWRES(J)
c20            FORMAT(1X,A12,T12,I8,T24,I8,T36,A12,T50,F12.4,T64,F12.4,
c     +                        T78,F12.4,T92,F12.4,T106,F12.4,T120,F12.4)
                WRITE(PSOUT(1),21) SETNAM(I),ISETNUM(J),IAPLOT(J),
     +                        NAMES(J),H(J),HOBS(J)
                WRITE(PSOUT(2),21) SETNAM(I),ISETNUM(J),IAPLOT(J),
     +                        NAMES(J),UWH(J),UWHOBS(J)
                WRITE(PSOUT(3),21) SETNAM(I),ISETNUM(J),IAPLOT(J),
     +                        NAMES(J),RES(J),UWRES(J)
21            FORMAT(1X,A12,T12,I8,T24,I8,T36,A12,T50,F12.4,T64,F12.4)
            ENDIF
          END DO
        END DO
      END DO

C     SUMMARY STATISTICS CALCULATIONS - BY SET

      DO 200 I=1,NSETS
        IF(ISETTYP(I).NE.IOP) GO TO 200
        SOSWR=0.0
        LARGEST=-1.0E35
        SMALLEST= 1.0E35
        USLARGEST=-1.0E35
        USSMALLEST= 1.0E35
        NGTREF=0
        NLTREF=0
        SOABS=0.0
        SOWABS=0.0
        NDD=0
        NSS=0
        RESMAX=0.
        UWRESMAX=0.
        RESMIN=0.
        UWRESMIN=0.
        AVGH = 0.
        UWAVGH = 0.
        RESAVG = 0.
        UWRESAVG = 0.
        SE = -1.0E35
        EVP = -1.0E35

C       ALL OBSERVATIONS/PREDICTIONS/PRIOR INFO TOGETHER

        IF (ND+IPR+MPR.GT.0) THEN
          DO 30 N = 1, ND+IPR+MPR
            IF(ISETNUM(N).NE.I) GO TO 30
            NSS=NSS+1
            NDD = NDD + 1
            IF(H(N).GT.LARGEST)LARGEST=H(N)
            IF(H(N).LT.SMALLEST)SMALLEST=H(N)
            IF(UWH(N).GT.USLARGEST)USLARGEST=UWH(N)
            IF(UWH(N).LT.USSMALLEST)USSMALLEST=UWH(N)
            AVGH = AVGH+H(N)
            UWAVGH = UWAVGH+UWH(N)
            IF(RES(N).GT.0.0)NLTREF=NLTREF+1
            IF(RES(N).LT.0.0)NGTREF=NGTREF+1
            IF(RES(N).LT.RESMIN)RESMIN=RES(N)
            IF(RES(N).GT.RESMAX)RESMAX=RES(N)
            RESAVG=RESAVG+RES(N)
            IF(UWRES(N).LT.UWRESMIN)UWRESMIN=UWRES(N)
            IF(UWRES(N).GT.UWRESMAX)UWRESMAX=UWRES(N)
            UWRESAVG=UWRESAVG+UWRES(N)
            SOABS=SOABS+ABS(UWRES(N))
            SOWABS=SOWABS+ABS(RES(N))
            SOSWR=SOSWR+(RES(N)*RES(N))
   30     CONTINUE
        ENDIF

180     IF(NDD.GT.0) THEN
          RESAVG=RESAVG/NDD
          UWRESAVG=UWRESAVG/NDD
          AVGH = AVGH/NDD
          UWAVGH = UWAVGH/NDD
          IF (NDD.GT.NPE) THEN
            EVP = SOSWR/(NDD-NPE)
            SE = SQRT(EVP)
          ENDIF
        END IF

C     STORE SUMMARY STATISTICS

        NSUMS = 16
C       SUMSTAT(I,20) CAN BE USED AS A FLAG FOR RECORDING ALL THE STATS
        IF(NSS.EQ.0)THEN
          SUMSTAT(I,20)=-3.0E35
        ELSE IF(NDD.EQ.0)THEN
          SUMSTAT(I,20)=-2.0E35
        ELSE
          SUMSTAT(I,1) = USLARGEST
          SUMSTAT(I,2) = USSMALLEST
          SUMSTAT(I,3) = UWAVGH
          SUMSTAT(I,4) = LARGEST
          SUMSTAT(I,5) = SMALLEST
          SUMSTAT(I,6) = AVGH
          SUMSTAT(I,7) = UWRESMAX
          SUMSTAT(I,8) = UWRESMIN
          SUMSTAT(I,9) = UWRESAVG
          SUMSTAT(I,10)= NGTREF
          SUMSTAT(I,11)= NLTREF
          SUMSTAT(I,12)= RESMAX
          SUMSTAT(I,13)= RESMIN
          SUMSTAT(I,14)= RESAVG
          SUMSTAT(I,15)= SOSWR
          SUMSTAT(I,16)= EVP
          SUMSTAT(I,17)= SE
        END IF
C
  200 CONTINUE

C   CLOSE THE SUMMARY OUTPUT UNDERSCORES

      DO I=1,3
         CLOSE(PSOUT(I))
      END DO

C   PRINT SUMMARY STATS

      CALL SPRD1SETS1RSS(NSETDIM,NSETS,SUMSTAT,ISETTYP,SETNAM,IOP,0,
     +                   IOSTAR,NSUMS)

      RETURN
      END

C=======================================================================
      SUBROUTINE SPRD1SETS1RSS(NSETDIM,NSETS,SUMSTAT,ISETTYP,
     +                                  SETNAM,IOP,ISCREEN,IOSTAR,NSUMS)
C=======================================================================
C     RECORD AND PRINT SUMMARY STATISTIC FOR ALL SETS ACCORDING TO IOP
C
C     VERSION 1, 20030211, JED
C     MODIFIED MAR, JUN, AUG 2003, MJT

      USE DRIVER
      IMPLICIT NONE

      INTEGER NSETDIM,NSETS,IOP,ISCREEN,IOSTAR,NSUMS,JJ,I,IFAIL,
     +        NONB_LEN1,IP,ITEMP, ISETTYP(NSETDIM)
C      ,IGETUNIT,IERR,JSCREEN,
      REAL SUMSTAT(NSETDIM,20),TVAL
      CHARACTER*(*) SETNAM(NSETDIM)
      CHARACTER*11 ATYPE
      CHARACTER*10 SUMMARY(18,2)
      CHARACTER*200 ATEMP
      CHARACTER*200 STEMP(NSETS)
      CHARACTER*10 ATEMP1
C     IOP=1 IE OBS-PRIOR HEADINGS FOR STATS
      DATA SUMMARY /'          ','          ','          ','          ',
     + '          ','          ',' UWRES-MAX',' UWRES-MIN',' UWRES-AVG',
     + ' NRESGT0  ',' NRESLT0  ','  RES-MAX ','  RES-MIN ','  RES-AVG ',
     + '  SOSWR   ','   EVP    ','    SE    ','          ',
C     IOP=2 IE PREDICTION HEADINGS FOR STATS
     + 'USLARGEST ','USSMALLEST','USAVERAGE ',' LARGEST  ',' SMALLEST ',
     + ' AVERAGE  ','USDIFF-MAX','USDIFF-MIN','USDIFF-AVG','  NGTREF  ',
     + '  NLTREF  ',' DIFF-MAX ',' DIFF-MIN ',' DIFF-AVG ','          ',
     + '          ','          ','          '/

c     ------------------------------------------------------------------
C
C-----CODE FOR ISCREEN IS AS FOLLOWS:-
C     ISCREEN = 0     - PRINT TO IOUTP ONLY
C     ISCREEN = 1     - PRINT TO SCREEN ONLY
C     ISCREEN = 2     = PRINT TO BOTH IOUTP AND SCREEN
C
      IFAIL = 0
      STEMP = ' '
      IF (IOP.EQ.1) THEN
        WRITE(*,2) 'CALIBRATION'
        WRITE(IOUTP,2) 'CALIBRATION'
      ELSEIF (IOP.EQ.2) THEN
        WRITE(*,2) 'PREDICTION'
        WRITE(IOUTP,2) 'PREDICTION'
2       FORMAT(/,1X,'RECORDING ',A,' SUMMARY STATISTICS:')
      ENDIF

C     CHECK FOR SET TYPES
      IF(NSETS.EQ.0) THEN
          WRITE(IOUTP,5)
5         FORMAT(/,1X,'NO SETS')
          RETURN
      END IF
      DO 10 I=1,NSETS
        IF(ISETTYP(I).EQ.IOP) GO TO 20
   10 CONTINUE
      RETURN
   20 CONTINUE
C
C      JSCREEN=0
      IF(IOP.EQ.1)THEN
        ATYPE='CALIBRATION'
      ELSE IF(IOP.EQ.2)THEN
        ATYPE='PREDICTION'
      ELSE
        WRITE(IOUTP,30)
   30   FORMAT(/,' ILLEGAL CALL TO SUBROUTINE OBS1BAS6RSS:- ',/,
     &  ' IOP MUST BE 1 OR 2.')
        STOP
      END IF
C
C   BECAUSE THE SUMMARY STATISTICS ARE A MIXTURE OF TEXT, INTEGER AND
C   REAL, WRITE THEM TO A STRING FOR PRINTING. THE UTILITY UWRTSIG
C   IS USED HERE TO MAXIMIZE PRECISION
C
      DO 100 I=1,NSETS
        IF(ISETTYP(I).NE.IOP) GO TO 100
        IF(SUMSTAT(I,20).LT.-2.9E35)THEN
          IF(ISCREEN.NE.1)
     +        STEMP(I) = '--- NO OBS/PRIOR/PRED BELONG TO THIS SET ---'
C     &    WRITE(IOUTP,535) SETNAM(I)(1:NONB_LEN1(SETNAM(I)))
C  535     FORMAT(1X,A,T15,
C     &    '--- NO OBS/PRIOR/PRED BELONG TO THIS SET ---')
        ELSE IF(SUMSTAT(I,20).LT.-1.9E35)THEN
          IF(ISCREEN.NE.1)
     +        STEMP(I) = '- ALL OBS/PRIOR/PRED AFFECTED BY DRY CELLS -'
C     &    WRITE(IOUTP,540) SETNAM(I)(1:NONB_LEN1(SETNAM(I)))
C  540     FORMAT(1X,A12,T15,
C     &    '--- ALL OBS/PRIOR/PRED AFFECTED BY DRY CELLS ---')
          ELSE
          ATEMP=' '
          IF (IOP.EQ.1) THEN
C         CALIBRATION SETS
            DO IP=7,17
              ATEMP1='           '
              IF ((IP.NE.10).AND.(IP.NE.11)) THEN
              CALL UWRTSIG(IFAIL,SUMSTAT(I,IP),ATEMP1(1:10),10,0,TVAL,0)
               ATEMP(IP*11:IP*11+10) = ATEMP1(1:10)
              ELSE
               ITEMP=NINT(SUMSTAT(I,IP))
               WRITE(ATEMP1(3:7),'(I5)') ITEMP
               ATEMP(IP*11:IP*11+10) = ATEMP1(1:10)
              ENDIF
            END DO
C            WRITE(IOUTP,542) SETNAM(I),ADJUSTL(ATEMP)
            STEMP(I) = ADJUSTL(ATEMP)
          ELSE IF (IOP.EQ.2) THEN
C         PREDICTION SETS
            DO IP=1,14
              ATEMP1=' '
              IF ((IP.NE.10).AND.(IP.NE.11)) THEN
               IF (SUMSTAT(I,IP).GT.-1.0E20) THEN
                 CALL UWRTSIG(IFAIL,SUMSTAT(I,IP),
     +                                         ATEMP1(1:10),10,0,TVAL,0)
                 ATEMP(IP*11:IP*11+10) = ATEMP1(1:10)
               ELSE
                 ATEMP(IP*11:IP*11+10) = ' ~ NAN ~  '
               ENDIF
              ELSE
               ITEMP=NINT(SUMSTAT(I,IP))
               WRITE(ATEMP1(3:7),'(I5)') ITEMP
               ATEMP(IP*11:IP*11+10) = ATEMP1(1:10)
              ENDIF
            END DO
            STEMP(I) = ADJUSTL(ATEMP)
C            WRITE(IOUTP,542) SETNAM(I),ADJUSTL(ATEMP)
C            WRITE(PSOUT,542) SETNAM(I),ADJUSTL(ATEMP)
          END IF
        END IF
  100 CONTINUE

      IF(ISCREEN.NE.1) THEN
        WRITE(IOUTP,500) ATYPE(1:NONB_LEN1(ATYPE))
500     FORMAT(/,1X,'== SUMMARY STATISTICS FOR ',A,' SETS ==',/)
C       CALIBRATION SETS
        IF (IOP.EQ.1) THEN
          WRITE(IOUTP,502)
502       FORMAT(1X,'------------',6(1x,'----------'))
          WRITE(IOUTP,503) 'SET NAME    ',(SUMMARY(JJ,IOP),JJ=7,12)
503       FORMAT(1X,A12,6(1X,A10))
          WRITE(IOUTP,502)
          DO I=1,NSETS
            IF(ISETTYP(I).EQ.IOP) THEN
              WRITE(IOUTP,542) SETNAM(I),STEMP(I)(1:66)
            END IF
          END DO
          WRITE(IOUTP,502)
          WRITE(IOUTP,*)
          WRITE(IOUTP,504)
504       FORMAT(1X,'------------',5(1x,'----------'))
          WRITE(IOUTP,505) 'SET NAME    ',(SUMMARY(JJ,IOP),JJ=13,17)
505       FORMAT(1X,A12,5(1X,A10))
          WRITE(IOUTP,504)
          DO I=1,NSETS
            IF(ISETTYP(I).EQ.IOP) THEN
              WRITE(IOUTP,542) SETNAM(I),STEMP(I)(67:121)
            END IF
          END DO
          WRITE(IOUTP,504)
        ELSEIF(IOP.EQ.2) THEN
C       PREDICTION SETS
          WRITE(IOUTP,512)
512       FORMAT(1X,'------------',5(1x,'----------'))
          WRITE(IOUTP,514) 'SET NAME    ',(SUMMARY(JJ,IOP),JJ=1,5)
514       FORMAT(1X,A12,5(1X,A10))
          WRITE(IOUTP,512)
          DO I=1,NSETS
            IF(ISETTYP(I).EQ.IOP) THEN
              WRITE(IOUTP,542) SETNAM(I),STEMP(I)(1:55)
            END IF
          END DO
          WRITE(IOUTP,512)
          WRITE(IOUTP,*)
          WRITE(IOUTP,512)
          WRITE(IOUTP,514) 'SET NAME    ',(SUMMARY(JJ,IOP),JJ=6,10)
          WRITE(IOUTP,512)
          DO I=1,NSETS
            IF(ISETTYP(I).EQ.IOP) THEN
              WRITE(IOUTP,542) SETNAM(I),STEMP(I)(56:110)
            END IF
          END DO
          WRITE(IOUTP,512)
          WRITE(IOUTP,*)
          WRITE(IOUTP,516)
516       FORMAT(1X,'------------',4(1x,'----------'))
          WRITE(IOUTP,518) 'SET NAME    ',(SUMMARY(JJ,IOP),JJ=11,14)
518       FORMAT(1X,A12,4(1X,A10))
          WRITE(IOUTP,516)
          DO I=1,NSETS
            IF(ISETTYP(I).EQ.IOP) THEN
              WRITE(IOUTP,542) SETNAM(I),STEMP(I)(111:154)
            END IF
          END DO
          WRITE(IOUTP,516)
        END IF
      END IF
542   FORMAT(1X,A12,1X,A)

C     WRITE SOME EXPLANATORY NOTES REGARDING THE PREDICTION STATISTICS
      IF (IOP.EQ.2) THEN

      WRITE(IOUTP,1100)
1100  FORMAT(//,1X,'*INTERPRETING RUN STATISTICS FOR PREDICTION SETS*')
      WRITE(IOUTP,1125)
1125  FORMAT(/,
     +'The MOD-PREDICT tabulation of summary statistics pertains to ',/,
     +'predictions, observations and prior information identified in',/,
     +'the OBS-SEN-PES process input files, and listed as members of',/,
     +'SETS in the "SETS" input file. Statistics are presented for ' ,/,
     +'each SET.  For PREDICTIONS, statistics are of three types:   ',/,
     +'                                                             ',/,
     +'   ABSOLUTE    - USLARGEST, USSMALLEST, USAVERAGE            ',/,
     +'                 LARGEST, SMALLEST, AVERAGE                  ',/,
     +'   DEVIATIONAL - USDIFF-MAX, USDIFF-MIN, USDIFF-AVG          ',/,
     +'                 DIFF-MAX, DIFF-MIN, DIFF-AVG                ',/,
     +'   RELATIVE    - NGTREF, NLTREF                              ',/,
     +'                                                             ',/,
     +'This summary table can be used to indicate the deviation of  ',/,
     +'simulated predictions from reference values. HOWEVER - if '   ,/,
     +'there is no supportable basis for specifying a reference '    ,/,
     +'value, DEVIATIONAL and RELATIVE statistics are meaningless. ' ,/,
     +'THUS use only ABSOLUTE statistics for PREDICTIONS.          ' ,/,
     +'(Refer to MOD-PREDICT documentation).                        ',/)

      ENDIF

1199  IF (IFAIL.NE.0) THEN
          WRITE(IOUTP,1200)
1200      FORMAT('STOP EXECUTION (SPRD1SETS1RSS)')
      ENDIF

      RETURN
      END

C=======================================================================
      SUBROUTINE SPRD1NAM1WR(IFAIL,ATYPE,CUNIT,AFNAM,FFNAM,IUNIT,OUTNAM,
     +       NIUNIT,RUNTYPE,IGLOLST,AGLOBNAM,ALISTNAM,IGLOBUN,
     +       ILISTUN,INBAS,BASNAM,IMOUTS,MFOUTFILE,OBSNAM,PREDNAM,
     +       OB_SENLINE,PR_SENLINE,PESNAM,SENFILEOPT,MAXITER,
     +       PES_SENLINE,MUNIT,MFNAM)
C=======================================================================
C     WRITE NAME FILE(S) NEEDED FOR RUNTYPES
C     VERSION 1, AUG 2003, MJT
C     - USES THE ENTRIES LISTED IN AFNAM AND FFNAM TO DETERMINE WHICH
C       PROCESSES AND PACKAGES ARE WRITTEN TO WHICH NAME FILES
C     - FOR THE PREDICTION-ONLY CASE, USES MFNAM FOR THE NAME OF ANY
C       PREDICTION-SPECIFIC GWF PACKAGES

      USE DRIVER
      IMPLICIT NONE

      INTEGER RUNTYPE,INAM,IGLOLST,IGLOBUN,ILISTUN,INBAS,IFAIL,NIUNIT,
     +        IMOUTS,MAXITER,NBLNK,IGETUNIT,I,ISS
      INTEGER IUNIT(NIUNIT),MUNIT(NIUNIT)
      CHARACTER EMPTYCHAR
      CHARACTER*100 AFNAM(NIUNIT),MFNAM(NIUNIT)
      CHARACTER*100 AGLOBNAM,ALISTNAM,BASNAM,FFNAM(3,NIUNIT),
     +              PES_SENLINE,OB_SENLINE,PR_SENLINE
C      RUNTEXT,
      CHARACTER*200 OUTNAM,OBSNAM,PESNAM,PREDNAM,SENFILEOPT,
     +              MFOUTFILE(NIUNIT)
      CHARACTER*4 ATYPE, CUNIT(NIUNIT)
      CHARACTER*3 PREF
c     ------------------------------------------------------------------

      EMPTYCHAR = ' '

      SENFILEOPT = PAR_PREF//AFNAM(25)(1:NBLNK(AFNAM(25)))
      PESNAM     = PAR_PREF//TRIM(ADJUSTL(OUTNAM))//'.NAM'
      OBSNAM     = OBS_PREF//TRIM(ADJUSTL(OUTNAM))//'.NAM'
      PREDNAM    = PRE_PREF//TRIM(ADJUSTL(OUTNAM))//'.NAM'

C      IF(RUNTYPE.EQ.1)RUNTEXT= 'RUN FOR OBSERVATIONS ONLY'
C      IF(RUNTYPE.EQ.2)RUNTEXT= 'RUN FOR SENSITIVITIES'
C      IF(RUNTYPE.EQ.3)THEN
C        IF(MAXITER.EQ.0)RUNTEXT= 'STATISTICS FOR CURRENT PARAMETER SET'
C        IF(MAXITER.GT.0)RUNTEXT= 'CALIBRATION PLUS "BEST" STATISTICS'
C      END IF

      INAM = IGETUNIT(1,95)
      IF (ATYPE.EQ.'OBS ') THEN
C       OBSERVATIONS ONLY
        WRITE(IOUTP,10) OBSNAM
10      FORMAT(3X,'NAME FILE FOR OBSERVATIONS ONLY - ',A)
        OPEN(INAM,FILE = OBSNAM)
        WRITE(INAM,13) 'MOD-PREDICT PRODUCED THIS '
13      FORMAT('#',1X,A,'NAME FILE FOR OBSERVATIONS-ONLY')
        PREF = OBS_PREF
        ISS  = 1
      ELSE IF (ATYPE.EQ.'PRED') THEN
C       PREDICTIONS ONLY
        WRITE(IOUTP,20) PREDNAM
20      FORMAT(3X,'NAME FILE FOR PREDICTIONS ONLY - ',A)
        OPEN(INAM,FILE = PREDNAM)
        WRITE(INAM,23) 'MOD-PREDICT PRODUCED THIS '
23      FORMAT('#',1X,A,'NAME FILE FOR PREDICTIONS-ONLY')
        ISS  = 2
        PREF = PRE_PREF
      ELSE IF (ATYPE.EQ.'PES ') THEN
C       CALIBRATION RUN
        WRITE(IOUTP,30) PESNAM
30      FORMAT(3X,'NAME FILE FOR CALIBRATION RUN - ',A)
        OPEN(INAM,FILE = PESNAM)
        WRITE(INAM,33) 'MOD-PREDICT PRODUCED THIS '
33      FORMAT('#',1X,A,'NAME FILE FOR CALIBRATION CONDITIONS')
        ISS  = 3
        PREF = PAR_PREF
      ENDIF

C   BAS, GLO AND LST

      IF (AGLOBNAM.NE.EMPTYCHAR) WRITE(INAM,112) 'GLOBAL',IGLOBUN,
     +                                                    PREF//AGLOBNAM
      IF (ALISTNAM.NE.EMPTYCHAR) WRITE(INAM,112) 'LIST',ILISTUN,
     +                                                    PREF//ALISTNAM
      IF (BASNAM.NE.EMPTYCHAR) WRITE(INAM,112) 'BAS6',INBAS,BASNAM

C     PACKAGE NAMES BASED ON RUNTYPE,ISS,ATYPE
C     NOTE - 'PES' IS DEALT WITH IN THE FOLLOWING LOOP.

      DO I = 1,NIUNIT
        IF (I.NE.26) THEN
          IF ((AFNAM(I).NE.EMPTYCHAR)) THEN
C          IS THERE AN OPTIMIZED SEN FILE LISTED?
            IF((I.EQ.25).AND.(RUNTYPE.EQ.3).AND.(ATYPE.NE.'PES ')) THEN
               IF (MAXITER.GT.0) THEN
                 WRITE(INAM,112) CUNIT(I),IUNIT(I),SENFILEOPT
               ELSE
                 WRITE(INAM,112) CUNIT(I),IUNIT(I),ADJUSTL(AFNAM(I))
               END IF
C           IS THERE A FILE CREATED BY MODPREDICT AND STORED IN FFNAM WHICH
C           MUST BE USED?
C            **OR**
C           WAS THERE A FILE LISTED IN THE MODPREDICT NAME FILE WHICH MIGHT
C           NEED TO BE USED?
            ELSE
              IF ((FFNAM(ISS,I)(1:7).NE.'NO_FILE').OR.(MUNIT(I).NE.0))
     +          THEN
C               A MODPREDICT-CONSTRUCTED FILE MUST BE USED
                IF((FFNAM(ISS,I).NE.EMPTYCHAR).AND.(MFNAM(I).EQ.' '))
     +            THEN
c                  WRITE(*,112)CUNIT(I),IUNIT(I),ADJUSTL(FFNAM(ISS,I))
                  WRITE(INAM,112)CUNIT(I),IUNIT(I),ADJUSTL(FFNAM(ISS,I))
C               A FILE LISTED IN MODPREDICT NAME FILE MUST BE USED (FOR PREDICTIONS)
                ELSE IF((ATYPE.EQ.'PRED').AND.(MFNAM(I).NE.' ')) THEN
                  WRITE(INAM,112)CUNIT(I),MUNIT(I),ADJUSTL(MFNAM(I))
                ELSE
                  WRITE(INAM,112) CUNIT(I),IUNIT(I),ADJUSTL(AFNAM(I))
                END IF
              END IF
            END IF
          END IF
        END IF
      END DO

C   PES FILE - WHITHER TO WRITE, AND WHAT TO WRITE

      IF ((RUNTYPE.EQ.3).AND.(MAXITER.GT.0)) THEN
         IF (ATYPE.EQ.'OBS ') THEN
C         NEW PES FILE WITH MAXITER = 0
          WRITE(INAM,15) 'PES',IUNIT(26),
     +                                PAR_PREF//TRIM(ADJUSTL(AFNAM(26)))
        ELSE IF (ATYPE.EQ.'PES ') THEN
C         ORIGINAL PES FILE
          WRITE(INAM,15) 'PES',IUNIT(26),TRIM(ADJUSTL(AFNAM(26)))
        ENDIF
      ENDIF
15    FORMAT(A,1X,I3,1X,A)

C   OUTPUT FILES (NOT GLO/LST) AS THEY APPEAR IN PROVIDED MF2K NAME FILE
C   AND INPUT "DATA" FILES AS THEY APPEAR IN MF2K NAME FILE

      DO I = 1,IMOUTS
        IF (MFOUTFILE(I).NE.EMPTYCHAR) THEN
          WRITE(INAM,'(A)') MFOUTFILE(I)
        ENDIF
      END DO

C   GRID SENSITIVITIES FOR THE CASE

      IF ((ATYPE.EQ.'OBS ').AND.(OB_SENLINE.NE.EMPTYCHAR)) THEN
          WRITE(INAM,'(A)') OB_SENLINE
      ENDIF
      IF ((ATYPE.EQ.'PRED').AND.(PR_SENLINE.NE.EMPTYCHAR)) THEN
          WRITE(INAM,'(A)') PR_SENLINE
      ENDIF
      IF ((ATYPE.EQ.'PES ').AND.(PES_SENLINE.NE.EMPTYCHAR)) THEN
           WRITE(INAM,'(A)') PES_SENLINE
      ENDIF

      CLOSE(INAM)
      RETURN

112   FORMAT(A,1X,I2,1X,A)
110   FORMAT(1X,'ERROR ENCOUNTERED WRITING NAME FILE: ',A)
      IFAIL=1
      WRITE(IOUTP,111)
111   FORMAT('STOP EXECUTION (SPRD1NAM1WR)')
      RETURN

      END

C=======================================================================
      SUBROUTINE SPRD1DIS1AL(IFAIL,INDIS,AFNAM,NIUNIT)
C=======================================================================
C     READ THE DISCRETIZATION FILE FOR VARIABLES USED IN ADV2 PACKAGE:
C     - NLAY,NROW,NCOL
C     - LAYCBD

      USE DRIVER
      IMPLICIT NONE

      INTEGER INDIS,LLOC,ISTART,ISTOP,K,NIUNIT,IERR,IFAIL,NBLNK
      REAL R
      CHARACTER*100 AFNAM(NIUNIT)
      LOGICAL LOP
C-----------------------------------------------------------------------

C     CHECK AND OPEN
      INQUIRE(UNIT=INDIS,OPENED=LOP)
      IF (LOP) THEN
          REWIND(INDIS)
        ELSE
          AFNAM(24)=ADJUSTL(AFNAM(24))
          OPEN(INDIS,FILE=AFNAM(24),STATUS='OLD',IOSTAT=IERR)
          IF(IERR.NE.0) THEN
            WRITE(IOUTP,2) AFNAM(24)(1:NBLNK(AFNAM(24)))
2           FORMAT('ERROR OPENING FILE ',A,'.')
            IFAIL = 1
            RETURN
          END IF
      END IF

C     READ THE HEADERS
      CALL URDCOM(INDIS,0,CLINE)
      LLOC=1
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NLAY,R,IOUTP,INDIS)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NROW,R,IOUTP,INDIS)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NCOL,R,IOUTP,INDIS)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,NPER,R,IOUTP,INDIS)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,ITMUNI,R,IOUTP,INDIS)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,LENUNI,R,IOUTP,INDIS)

C     LAYER DESIGNATIONS
      READ(INDIS,*) (LAYCBD(K),K=1,NLAY)

C     IF ALL READ OKAY, CLOSE AND RETURN
      CLOSE(INDIS)
      RETURN

      END

c=======================================================================
      SUBROUTINE SPRD1SETS1VM(IFAIL,STATISTIC,STATFLAG,VMULT,NSETS,
     +                     AFILE,IRPLOT,ISETPLT,ISYMBOL)
c=======================================================================
C     APPLY VMULT TO THE WEIGHT STATISTIC ACCORDING TO RULES BELOW
C   VERSION 1, AUG 2003, MJT

C     FOR OBSERVATIONS
C     STATFLAG: 0 - statistic * VMULT
C               1 - statistic * sqrt(VMULT)
C               2 - statistic * VMULT

C     FOR PRIOR INFORMATION
C     STATFLAG: 0 - statistic * VMULT
C               1 - statistic * sqrt(VMULT)
C               2 - statistic * VMULT
C              10 - statistic * VMULT
C              11 - statistic * sqrt(VMULT)
C              12 - statistic * VMULT
C
C     WHEN THE STATISTIC PASSED IS ACTUALLY AN ENTRY FROM A VARIANCE-
C       COVARIANCE MATRIX, THEN STATFLAG IS PASSED AS 1 - DIAGONALS ARE
C       SCALED BY A SINGLE VMULT, AND OFF-DIAGONALS ARE SCALED BY
C       SQRT(VMULT1)*SQRT(VMULT2)
C
C     IRPLOT - PLOT-SYMBOL FOR THE OBSERVATION/PREDICTION IN QUESTION
C     AFILE  - OBSPRED FILE NAME
C
C     ALL OTHER VARIABLES AS DEFINED IN MF2K/MODPREDICT DOCUMENTATION OR
C       OTHER 'SETS' SUBROUTINES.
C
      USE DRIVER
      IMPLICIT NONE

      INTEGER STATFLAG,NBLNK,IFAIL,NSETS,J,IRPLOT,MM, ISTAT
      INTEGER ISETPLT(NSETS,ISETCNT),ISYMBOL(NSETS)
      REAL STATISTIC, VVMULT, VMULT(NSETS)
      CHARACTER*100 AFILE
c     ------------------------------------------------------------------

      IFAIL = 0
      ISTAT = STATFLAG
      IF (ISTAT.EQ.10) ISTAT = 0
      IF (ISTAT.EQ.11) ISTAT = 1
      IF (ISTAT.EQ.12) ISTAT = 2

C     FIRST DO THE CHECK FOR WHICH VMULT() IT SHOULD BE
      DO J = 1,NSETS
        DO MM = 1,ISYMBOL(J)
          IF (IRPLOT.EQ.ISETPLT(J,MM)) THEN
              VVMULT = VMULT(J)
              GOTO 10
          ELSE
              VVMULT = 1.00
          ENDIF
        END DO
      END DO

C     NOW USE THE CORRECT VMULT() VALUE TO SCALE THE WEIGHT STATISTIC
10    IF(STATISTIC.LE.0.0)THEN
        WRITE(IOUTP,20) AFILE(1:NBLNK(AFILE)),STATISTIC
20      FORMAT(A,': ILLEGAL STATISTIC VALUE: ',G12.6)
        IFAIL = 1
        RETURN
      END IF
      IF((ISTAT.LT.0).OR.(ISTAT.GT.2))THEN
        WRITE(IOUTP,21) AFILE(1:NBLNK(AFILE)),ISTAT
21      FORMAT(A,': ILLEGAL STAT-FLAG ',I6,2X,'- ADJUSTED TO 0')
        STATFLAG=0
      END IF
      IF((ISTAT.EQ.2).OR.(ISTAT.EQ.0))THEN
        STATISTIC = STATISTIC*VVMULT
      ELSEIF(ISTAT.eq.1)then
        STATISTIC = STATISTIC*SQRT(VVMULT)
      END IF
      RETURN

      END

C=======================================================================
      SUBROUTINE SPRD1NAM1OPEN(IFAIL,INUNIT,IOUTG,IOUTL,IOUT,IUNIT,
     +        CUNIT,IREWND,NIUNIT,INBAS,AFNAM,AGLOBNAM,ALISTNAM,
     +            IGLOBUN,ILISTUN,IGLOLST,BASNAM,MFOUTFILE,IMOUTS)
C=======================================================================
C-----VERSION 24JAN2000 SGLO1BAS6OPEN
C   - MODIFIED AUG 2003 MJT (AS SPRD1NAM1OPEN)
C     CHECK FOR FILES LISTED IN MODFLOW2000 NAME FILE
C     - IDENTIFY RELATION OF GLO+LIST, BAS
C     - LOAD THE REMAINING GWF PROCESS FILES INTO AFNAM
C     - THIS ROUTINE RETAINS SOME OF THE CHECKING THAT MF2K PERFORMS

      USE DRIVER
      IMPLICIT NONE

      INTEGER NFILE,INUNIT,IGLOBUN,ILISTUN,IGLOLST,IMOUT,IMOUTS, INBAS,
     +        IOUT,IOUTL,IOUTG,I,IFIRST,KLIST,LLOC,N,ITYP2,ITYP1,IU,
     +        ISTOP,ISTART, INAM2,INAM1,IFLEN,NIUNIT,IFAIL
      INTEGER IUNIT(NIUNIT),IREWND(NIUNIT)
      REAL R
      CHARACTER*4 CUNIT(NIUNIT)
      CHARACTER*7 FILSTAT
      CHARACTER*20 FILACT, FMTARG, ACCARG, ACCESS,FORM,ACTION(2)
      CHARACTER*200 LINE, FNAME, MFOUTFILE(NIUNIT)
      CHARACTER*100 AFNAM(NIUNIT),AGLOBNAM,ALISTNAM,BASNAM

      DATA (ACTION(I),I=1,2)/'READ','READWRITE'/
      DATA ACCESS/'TRANSPARENT'/
      DATA FORM/'UNFORMATTED'/
      LOGICAL LOP
c     ------------------------------------------------------------------

      IMOUTS = 0
      INBAS=0
      IOUTG=0
      NFILE=0
      IOUT=0
      IGLOLST = 0
      IREWND=1
      IFIRST=1
      KLIST=0

      WRITE(IOUTP,1)
1     FORMAT(3X,'CHECKING ACTIVE PACKAGES IN MODFLOW NAME FILE')

C-------DETERMINE IF BOTH GLOBAL AND LIST FILES WILL BE PRODUCED --
C       - READ A LINE; IGNORE BLANK LINES AND PRINT COMMENT LINES.
10    READ(INUNIT,'(A)',END=1000) LINE
      IF(LINE.EQ.' ') GO TO 10
      IF(LINE(1:1).EQ.'#') THEN
        GO TO 10
      END IF
C
C3------DECODE THE FILE TYPE AND UNIT NUMBER.
      LLOC=1
      CALL URWORD(LINE,LLOC,ITYP1,ITYP2,1,N,R,IOUT,INUNIT)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,IU,R,IOUT,INUNIT)
C
C4------CHECK FOR A VALID FILE TYPE.
      FMTARG='FORMATTED'
      ACCARG='SEQUENTIAL'
      FILSTAT='UNKNOWN'
      FILACT=' '
C
C4A-----FIRST ENTRY MUST BE FILE-TYPE "LIST" OR "GLOBAL"
      IF(NFILE.EQ.0) THEN
         IF(LINE(ITYP1:ITYP2).EQ.'GLOBAL') THEN
            IOUTG=IU
            IF(IFIRST.EQ.1) KLIST=KLIST+1
         ELSE IF(LINE(ITYP1:ITYP2).EQ.'LIST') THEN
            IOUTL=IU
            IOUT=IU
            IF(IFIRST.EQ.1) KLIST=KLIST+1
         ELSE
            WRITE(*,*)
     1       ' FIRST ENTRY IN NAME FILE MUST BE "GLOBAL" OR "LIST".'
            STOP
         END IF
C
C4A-----2ND FILE CAN BE "LIST" FILE TYPE.
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'LIST') THEN
         IF(IFIRST.EQ.1) KLIST=KLIST+1
C
C4B-----CHECK FOR "BAS" FILE TYPE.
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'BAS6') THEN
         INBAS=IU
         FILSTAT='OLD    '
         FILACT=ACTION(1)
C
C4C-----CHECK FOR "UNFORMATTED" FILE TYPE.
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'DATA(BINARY)' .OR.
     1        LINE(ITYP1:ITYP2).EQ.'DATAGLO(BINARY)') THEN
         FMTARG=FORM
         ACCARG=ACCESS
C
C4D-----CHECK FOR "FORMATTED" FILE TYPE.
      ELSE IF(LINE(ITYP1:ITYP2).EQ.'DATA' .OR.
     1        LINE(ITYP1:ITYP2).EQ.'DATAGLO') THEN
         FMTARG='FORMATTED'
         ACCARG='SEQUENTIAL'
C
C4E-----CHECK FOR MAJOR OPTIONS.
      ELSE
         IF(IFIRST.EQ.0) THEN
            DO 20 I=1,NIUNIT
               IF(LINE(ITYP1:ITYP2).EQ.CUNIT(I)) THEN
C                 ONLY LOAD INTO IUNIT IF NOT ALREADY SOMETHING IN THERE
C                 THAT CAME FROM THE MODPREDICT NAME FILE
                  IF(IUNIT(I).EQ.0) IUNIT(I)=IU
                  FILSTAT='OLD    '
                  FILACT=ACTION(1)
                  GO TO 30
               END IF
20          CONTINUE
            WRITE(IOUTP,21) LINE(ITYP1:ITYP2)
21          FORMAT(1X,'ILLEGAL FILE TYPE IN NAME FILE: ',A)
            STOP
30          CONTINUE
         ENDIF
      END IF
      IF(IFIRST.EQ.1) THEN
         NFILE=NFILE+1
         IOUT=0
         IOUTG=0
         IF(NFILE.EQ.2) THEN
            IFIRST=0
            NFILE=0
            REWIND(INUNIT)
         ENDIF
         GOTO 10
      ENDIF
C
C5------DETERMINE FILE NAME AND WRITE THE FILE NAME IF THE FILE IS NOT
C5------THE LISTING FILE.  THEN OPEN THE FILE.
      CALL URWORD(LINE,LLOC,INAM1,INAM2,0,N,R,IOUTG,INUNIT)
      IFLEN=INAM2-INAM1+1
      FNAME(1:IFLEN)=LINE(INAM1:INAM2)
      IMOUT = 1
      DO I=1,NIUNIT
         IF(LINE(ITYP1:ITYP2).EQ.CUNIT(I)) THEN
C            ONLY LOAD INTO AFNAM IF NOT ALREADY SOMETHING IN THERE
C            THAT CAME FROM THE MODPREDICT NAME FILE
             IF (AFNAM(I).EQ.' ') AFNAM(I) = FNAME(1:IFLEN)
             IMOUT = 0
           ELSE IF (LINE(ITYP1:ITYP2).EQ.'GLOBAL') THEN
             AGLOBNAM = FNAME(1:IFLEN)
             IGLOBUN  = IU
             IMOUT = 0
             GOTO 99
           ELSE IF (LINE(ITYP1:ITYP2).EQ.'LIST') THEN
             ALISTNAM = FNAME(1:IFLEN)
             ILISTUN  = IU
             IMOUT = 0
             GOTO 99
           ELSE IF (LINE(ITYP1:ITYP2).EQ.'BAS6') THEN
C            ASSUMED THAT THE BAS IS SAME FOR CALIBRATION AND PREDICTION
             BASNAM = FNAME(1:IFLEN)
             IMOUT = 0
         END IF
      END DO
      IF (FILACT.EQ.' ') FILACT=ACTION(2)
      IF (IMOUT.GT.0) THEN
          IMOUTS=IMOUTS+1
          MFOUTFILE(IMOUTS) = TRIM(ADJUSTL(LINE))
      ENDIF
      IF(NFILE.NE.0) WRITE(IOUTP,50) FNAME(1:IFLEN),
     1     LINE(ITYP1:ITYP2),IU
50    FORMAT(3X,'CHECKING ',A,1X,'TYPE:',A,' UNIT: ',I4)

      OPEN(UNIT=IU,FILE=FNAME(1:IFLEN),FORM=FMTARG,
     1      ACCESS=ACCARG,STATUS=FILSTAT,ACTION=FILACT,ERR=2000)
      INQUIRE(UNIT=IU,OPENED=LOP)
      IF (LOP) CLOSE (UNIT=IU)

99    IF(NFILE.LE.1) THEN
         IF(NFILE.EQ.0) THEN
            WRITE(IOUTP,90) LINE(INAM1:INAM2),IU
90          FORMAT(3X,'GLOBAL FILE: ',A,1X,'UNIT ',I4)
         ELSE
            WRITE(IOUTP,90) LINE(INAM1:INAM2),IU
91          FORMAT(3X,'LIST FILE  : ',A,1X,'UNIT ',I4)
         ENDIF
      ENDIF
      NFILE=NFILE+1
      GO TO 10
C
C7------END OF NAME FILE.  RETURN PROVIDED THAT LISTING FILE AND BAS
C7------FILES HAVE BEEN OPENED.

1000  IF(NFILE.EQ.0) THEN
         WRITE(*,*) ' NAME FILE IS EMPTY.'
         STOP
      ELSE IF(INBAS.EQ.0) THEN
         WRITE(IOUTP,*) ' BAS PACKAGE FILE HAS NOT BEEN OPENED.'
         STOP
      END IF
      INQUIRE(UNIT=INUNIT,OPENED=LOP)
      IF (LOP) CLOSE (UNIT=INUNIT)
      INQUIRE(UNIT=INBAS,OPENED=LOP)
      IF (LOP) CLOSE (UNIT=INBAS)
      IF(IOUT.EQ.0) IOUT=IOUTG
      RETURN
C
2000  CONTINUE
C     FILE-OPENING ERROR
      WRITE(*,2010)FNAME(1:IFLEN),IU,FILSTAT,FMTARG,ACCARG,FILACT
      WRITE(IOUTP,2010)FNAME(1:IFLEN),IU,FILSTAT,FMTARG,ACCARG,FILACT
2010  FORMAT(/,1X,'*** ERROR OPENING FILE "',A,'" ON UNIT ',I5,/,
     &7X,'SPECIFIED FILE STATUS: ',A,/
     &7X,'SPECIFIED FILE FORMAT: ',A,/
     &7X,'SPECIFIED FILE ACCESS: ',A,/
     &7X,'SPECIFIED FILE ACTION: ',A,/
     &2X,'-- STOP EXECUTION (SPRD1NAM1OPEN)')
2002  FORMAT( ' - FILE ',A,' FOUND OK.')
      STOP
      END

C=======================================================================
      SUBROUTINE SPRD1NAM2OPEN(IFAIL,IMPN,IUNIT,CUNIT,IREWND,NIUNIT,
     +                       MFNAM,AFNAM,APRED,ASETS,OBPAC,NOBPAC,MUNIT,
     +                       IPRD)
C=======================================================================
C-----VERSION 24JAN2000 SGLO1BAS6OPEN
C     MODIFIED AUG 2003, MJT (AS SPRD1NAM2OPEN)
C
C     OPEN FILES LISTED IN MODPREDICT NAME FILE
C     - LOAD OBS-SEN-PES FILES AND OBSERVATION PACKAGES INTO AFNAM: THIS
C       IS USED TO DETERMINE THE RUNTYPE EXECUTED BY MODPREDICT
C     - LOAD ANY GWF PROCESS FILES INTO MFNAM: THIS IS USED TO WRITE
C       PREDICTION-SCENARIO GWF PACKAGES TO THE PREDICTION-ONLY RUN
C       NAME FILES
C     - THIS ROUTINE DOES NOT RETAIN THE CHECKING THAT MF2K PERFORMS

      USE DRIVER
      IMPLICIT NONE

      INTEGER NFILE,I,LLOC,N,ITYP2,ITYP1,IU,ISTOP,ISTART,INAM2,INAM1,
     +        IFLEN,NIUNIT,IFAIL,IPRD,ISETS,IMPN,IERR,NOBPAC
      INTEGER IUNIT(NIUNIT),IREWND(NIUNIT),OBPAC(NOBPAC),MUNIT(NIUNIT)
      REAL R
      CHARACTER*4 CUNIT(NIUNIT)
C      CHARACTER*7 FILSTAT
      CHARACTER*200 FNAME,APRED,ASETS
      CHARACTER*100 MFNAM(NIUNIT),AFNAM(NIUNIT)
      LOGICAL LOP
c     ------------------------------------------------------------------

      NFILE=0
      IPRD = 0
      ISETS = 0
      IREWND=1

      WRITE(IOUTP,1)
1     FORMAT(3X,'CHECKING ACTIVE PACKAGES IN MODPREDICT NAME FILE')

10    READ(IMPN,'(A)',END=1000) CLINE
      IF(CLINE.EQ.' ') GO TO 10
      IF(CLINE(1:1).EQ.'#') THEN
        GO TO 10
      END IF

C     OBTAIN FILE TYPE AND UNIT NUMBER
      LLOC=1
      CALL URWORD(CLINE,LLOC,ITYP1,ITYP2,1,N,R,IOUTP,IMPN)
      CALL URWORD(CLINE,LLOC,ISTART,ISTOP,2,IU,R,IOUTP,IMPN)
C     DETERMINE FILE NAME
      CALL URWORD(CLINE,LLOC,INAM1,INAM2,0,N,R,IOUTP,IMPN)
      IFLEN=INAM2-INAM1+1
      FNAME(1:IFLEN)=CLINE(INAM1:INAM2)

C     FLAG TO ENSURE BOTH PRD AND SETS FILES WERE LISTED IN THE FILE
      IF(CLINE(ITYP1:ITYP2).EQ.'PRD') THEN
          IPRD = IU
          IUNIT(52) = IU
          APRED = FNAME(1:IFLEN)
          GOTO 30
      END IF
      IF(CLINE(ITYP1:ITYP2).EQ.'SETS') THEN
          ISETS = IU
          IUNIT(51) = IU
          ASETS = FNAME(1:IFLEN)
          GOTO 30
      END IF
C     CHECK FOR OBSERVATION PACKAGES - THESE GO INTO AFNAM
      DO I=1,NOBPAC
        IF(CLINE(ITYP1:ITYP2).EQ.CUNIT(OBPAC(I))) THEN
          IUNIT(OBPAC(I)) = IU
          AFNAM(OBPAC(I)) = FNAME(1:IFLEN)
          GOTO 30
        END IF
      END DO
C     CHECK FOR OBS-SEN-PES - THESE GO INTO AFNAM
      IF(CLINE(ITYP1:ITYP2).EQ.CUNIT(27)) THEN                      !OBS
          IUNIT(27) = IU
          AFNAM(27) = FNAME(1:IFLEN)
          GOTO 30
      ELSE IF(CLINE(ITYP1:ITYP2).EQ.CUNIT(25)) THEN                 !SEN
          IUNIT(25) = IU
          AFNAM(25) = FNAME(1:IFLEN)
          GOTO 30
      ELSE IF(CLINE(ITYP1:ITYP2).EQ.CUNIT(26)) THEN                 !PES
          IUNIT(26) = IU
          AFNAM(26) = FNAME(1:IFLEN)
          GOTO 30
      END IF
C     REMAINDER MUST BE PREDICTION-SPECIFIC GWF PACKAGES- THESE GO
C     INTO MFNAM AND UNIT NUMBER STORED IN MUNIT
      DO I=1,NIUNIT
        IF(CLINE(ITYP1:ITYP2).EQ.CUNIT(I)) THEN
          MUNIT(I) = IU
          MFNAM(I) = FNAME(1:IFLEN)
          GO TO 30
        END IF
      END DO
      WRITE(IOUTP,21) CLINE(ITYP1:ITYP2)
21    FORMAT(1X,'ILLEGAL FILE TYPE IN NAME FILE: ',A)
      IFAIL = 1
      RETURN
30    CONTINUE

C     OPEN THE FILE.
      INQUIRE(UNIT=IU,OPENED=LOP)
      IF (LOP) CLOSE (UNIT=IU)
      IF(NFILE.NE.0) WRITE(IOUTP,50)FNAME(1:IFLEN),CLINE(ITYP1:ITYP2),IU
50    FORMAT(3X,'CHECKING ',A,1X,'TYPE:',A,' UNIT: ',I4)

99      OPEN(UNIT=IU,FILE=FNAME(1:IFLEN),STATUS='OLD',IOSTAT=IERR)
      IF (IERR.NE.0) THEN
          WRITE(*,55) FNAME(1:IFLEN)
55        FORMAT(/,1X,'ERROR OPENING FILE ',A)
          STOP
      END IF
      NFILE=NFILE+1
      GO TO 10
C
C7------END OF NAME FILE.  RETURN PROVIDED THAT LISTING FILE AND BAS
C7------FILES HAVE BEEN OPENED.

1000  IF(NFILE.EQ.0) THEN
         WRITE(*,*) ' NAME FILE IS EMPTY.'
         IFAIL=1
      ELSE IF(IPRD.EQ.0) THEN
         WRITE(IOUTP,*) ' PRD FILE HAS NOT BEEN OPENED.'
         IFAIL=1
      ELSE IF(ISETS.EQ.0) THEN
         WRITE(IOUTP,*) ' SETS FILE HAS NOT BEEN OPENED.'
         IFAIL=1
      END IF
      INQUIRE(UNIT=IMPN,OPENED=LOP)
      IF (LOP) CLOSE (UNIT=IMPN)
      RETURN
C
C2000  CONTINUE
C     FILE-OPENING ERROR
      WRITE(*,2010)FNAME(1:IFLEN),IU
      WRITE(IOUTP,2010)FNAME(1:IFLEN),IU
2010  FORMAT(/,1X,'*** ERROR OPENING FILE "',A,'" ON UNIT ',I5)
      IFAIL = 1
      WRITE(IOUTP,2020)
2020  FORMAT('STOP EXECUTION (SPRD1NAM2OPEN)')
      RETURN
C2002  FORMAT( ' - FILE ',A,' FOUND OK.')
C      STOP
      END

C=======================================================================
      SUBROUTINE SPRD1PES1WR(WTP,IPR,NIPR,IIOUT,IU,DETWTP,NPLIST,
     &                       MPR,EV,IERR,ISENS,NIPRNAM,IPRAR,IAPLOT,
     &                       INAMES,NAMES,ND,BPRI,LN,WTPS,W3,W4,ISS,
     +                       NIL,VMULT,NSETS,FN,ISETPLT,ISYMBOL,IFAIL,
     +                       NPDIM)
C=======================================================================

C     VERSION 20000201 ERB (as "SPES1BAS6WR" in PES Process files)
C     MODIFIED AUG 2003 MJT (as "SPRD1PES1WR")
C     ******************************************************************
C     READ AND PREPARE FULL WEIGHT MATRIX FOR PARAMETERS
C     ******************************************************************
C      SPECIFICATIONS
      USE DRIVER
      IMPLICIT NONE

      INTEGER I, IERR, IPR, IU, J, K, MPR, N,NSETS,LN,ND,IPRAR,
     &        NIPR, NPLIST, INAMES,ISS,NIL,IIOUT,NN,MM,IFAIL,IPRN,
     +        IWTP,ISETN,ISETPLT(NSETS,ISETCNT),ISYMBOL(NSETS),NPDIM,
     +        IAPLOT(ND+IPR+MPR),IPNG(NPDIM),ISENS(NPDIM)
C       IPLOT(ND+IPR+MPR),ITSET,ISETTYP(NSETS),IOMIT
      CHARACTER*12 NAMES(ND+IPR+MPR)
C      CHARACTER*16 ANAME
      CHARACTER*10 PARNAM(NPDIM),NIPRNAM(IPRAR),NIPRNAMU,PNAME
      CHARACTER*100 FN
      REAL BPRI, DETWTP, EV,VMULT(NSETS),WTP,WTPS,TMP
      DOUBLE PRECISION CONVLOG, TEN, W3(IPRAR,IPRAR),W4(IPRAR)
      DIMENSION NIPR(IPRAR), LN(NPDIM), BPRI(IPRAR), WTP(IPRAR,IPRAR),
     &          WTPS(IPRAR,IPRAR)
C      DATA ANAME/'                '/
C-----------------------------------------------------------------------
  500 FORMAT (//,6X,'WEIGHT MATRIX FOR CORRELATED PRIOR',/,6X,75('-'))
  505 FORMAT (//,6X,'SQUARE-ROOT OF WEIGHT MATRIX FOR CORRELATED PRIOR',
     &        /,6X,75('-'))
C
  510 FORMAT (1X,6G13.6)
  515 FORMAT (/,' PARAMETER NUMBER',I5,' PID=',A4,' HAS WEIGHTING ',
     &        'SPECIFIED IN DATA SET 10 AND WITH THE FULL WEIGHT',
     &        ' MATRIX.',/,' THE DATA SET 10 WT VALUE IS IGNORED.',/)
  520 FORMAT (/' MULTIPLE PRIOR NUMBER',I5,' IS INCLUDED IN THE FULL ',
     &        'WEIGHT MATRIX.  THE DATA SET 12 WT VALUE IS IGNORED.')
  525 FORMAT (/,' SQUARE-ROOT OF THE WEIGHT MATRIX FOR PARAMETERS ',
     &        'WITH CORRELATIONS')
  530 FORMAT (/,' WEIGHT MATRIX FOR PARAMETERS WITH CORRELATIONS',/)
  535 FORMAT (//,' NIPR NAME',3X,'PLOT-SYMBOL',/,1X,10('-'),2X,11('-'))
C
  540 FORMAT (//,' CORRELATED PRIOR INFORMATION STATISTICS',/,
     &        ' DIAGONAL TERMS ARE COEFFICIENTS OF VARIATION; ',
     &        'OFF-DIAGONALS ARE CORRELATION COEFFICIENTS',/)
  545 FORMAT (/,' VARIANCE-COVARIANCE MATRIX IS NOT POSITIVE-DEFINITE',
     &        /,' -- STOP EXECUTION (SPRD1PES1WR)',/)
  550 FORMAT (/,' CAN NOT USE AN UNESTIMATED PARAMETER',I5,
     &        ' -- STOP EXECUTION (SPRD1PES1WR)',/)
  555 FORMAT (/,' "',A10,'" IN ITEM 7 IS NOT DEFINED AS A ',
     &        'PARAMETER -- STOP EXECUTION (SPRD1PES1WR)',/)
  560 FORMAT (1X,A10,2X,I7)
  565 FORMAT (/,' CORRELATED PRIOR INFORMATION STATISTICS',/,' DIAGONAL'
     &        ,' TERMS ARE VARIANCES; OFF-DIAGONALS ARE COVARIANCES',/)
C
      TEN = 10.0
      NIL = 0
      ISETN = -99
      CONVLOG = LOG(TEN)
C-----READ WHICH PARAMETERS OR PARAMETER SUMS ARE INVOLVED IN THE
C-----FULL WEIGHT MATRIX, AND CHECK AGAINST OTHER PRIOR (PES ITEM 7)
      WRITE (IOUTP,535)
      DO 8 I = 1,IPR
C       READ PES ITEM 7
        INAMES = INAMES+1
        READ (IU,*) NIPRNAM(I), BPRI(I), IAPLOT(ND+MPR+I)               !IAPLOT
        IF (ISS.EQ.2) WRITE(IIOUT,*) NIPRNAM(I),BPRI(I),IAPLOT(ND+MPR+I)!IAPLOT
        NAMES(INAMES) = NIPRNAM(I)
        CALL UCASE(NIPRNAM(I),NIPRNAMU,1)
        DO 4 J = 1,NPLIST
          CALL UCASE(PARNAM(J),PNAME,1)
          IF (PNAME.EQ.NIPRNAMU) THEN
            NIPR(I) = J
            GOTO 6
          ENDIF
 4      CONTINUE
        WRITE (IOUTP,555) NIPRNAM(I)
        IERR = 1
 6      CONTINUE
        WRITE (IOUTP,560) NIPRNAM(I), IAPLOT(ND+MPR+I)
 8    CONTINUE

C     CHECK HERE THAT ALL THE CORRELATED PRIOR INFO TERMS ARE
C     MEMBERS OF THE SAME SET, AND IF NOT, RETURN ERROR AND STOP.
      DO I=1,IPR
          DO NN=1,NSETS
            DO MM=1,ISYMBOL(NN)
              IF (IAPLOT(ND+MPR+I).EQ.ISETPLT(NN,MM)) THEN              !IAPLOT
C               CORRELATED PRIOR IS IN THIS SET: STORE FOR CHECKING
                ISETN = NN
                GOTO 22
              ENDIF
            END DO
          END DO
      END DO
22    CONTINUE
      IF (ISETN.EQ.-99) THEN
C         ISETN WAS NEVER CHANGED - SO NONE OF THE PRIOR ARE IN SETS
          WRITE(IOUTP,*) ' CORRELATED PRIOR ARE NOT MEMBERS OF SETS'
      ELSE
        DO I=1,IPR
C         CHECK THEY ARE ALL IN THE SAME SET
          DO NN=1,NSETS
            DO MM=1,ISYMBOL(NN)
              IF (IAPLOT(ND+MPR+I).EQ.ISETPLT(NN,MM)) THEN              !IAPLOT
                IF (ISETN.NE.NN) THEN
                  WRITE(IOUTP,23)
23                FORMAT(/,1X,'CORRELATED PRIOR INFORMATION ARE ',
     +                        'NOT CONTAINED IN A SINGLE SET. THIS',
     +                   /,1X,'IS NOT ALLOWED - STOPPING ',
     +                        '(SPRD1PES1RP)')
                  IFAIL = 1
                  RETURN
                END IF
              ENDIF
            END DO
          END DO
        END DO
      END IF
C
      DO 10 I = 1, IPR
        N = NIPR(I)
        IF (ISENS(N).LE.0) THEN
          WRITE (IOUTP,550) N
          IFAIL = 1
          RETURN
        ENDIF
   10 CONTINUE
C------READ AND WRITE MATRIX USED TO DEFINE THE WEIGHTING
C     READ PES ITEM 8
      READ(IU,*) IWTP
      IF (ISS.EQ.2) WRITE(IIOUT,*) IWTP
      IF(IWTP .EQ. 0) WRITE (IOUTP,565)
      IF(IWTP .EQ. 1) WRITE (IOUTP,540)
      DO 20 K = 1, IPR
        READ (IU,*) (WTP(K,I),I=1,IPR)
C       IF CORRELATED PRIOR ARE IN SET, MULTIPLY THE MATRIX BY VMULT
        IF (ISETN.NE.-99) THEN
          DO I=1,IPR
C           PASS NIL SO SCALING IS BY VMULT
            CALL SPRD1SETS1VM(IFAIL,WTP(K,I),NIL,VMULT,NSETS,
     +                        FN,IAPLOT(ND+MPR+I),ISETPLT,ISYMBOL)      !IAPLOT
          END DO
        ENDIF
        IF (ISS.EQ.2) WRITE (IIOUT,510) (WTP(K,I),I=1,IPR)
C    CONVERT LOG10 TO LOG
        IF(IWTP .EQ. 0) THEN
          DO 15 I = 1,IPR
            IF (LN(NIPR(K)).GT.0) WTP(K,I) = WTP(K,I) * CONVLOG
            IF (LN(NIPR(I)).GT.0) WTP(K,I) = WTP(K,I) * CONVLOG
   15     CONTINUE
        ENDIF
C     CONVERT COEFFICIENTS OF VARIATION TO STANDARD DEVIATIONS
        IF(IWTP .EQ. 1) THEN
          IF (LN(NIPR(K)).LE.0 .AND. BPRI(K).NE.0.0)
     &               WTP(K,K) = WTP(K,K) * BPRI(K)
          IF (LN(NIPR(K)).GT.0 .AND. LOG(BPRI(K)).NE.0.0)
     &               WTP(K,K) = WTP(K,K) * LOG(BPRI(K))
        ENDIF
   20 CONTINUE
C     CONVERT CORRELATIONS TO COVARIANCES, AND STANDARD DEVIATIONS TO
C     VARIANCES
      IF(IWTP.EQ.1) THEN
        DO 30 K=1,IPR
          DO 25 I=1,IPR
            IF(K .NE. I) WTP(K,I)=WTP(K,I)*WTP(I,I)*WTP(K,K)
   25     CONTINUE
   30   CONTINUE
        DO 40 K=1,IPR
          WTP(K,K) = WTP(K,K)**2
   40   CONTINUE
      ENDIF
C     DECOMPOSE
      CALL SVD (IPR,WTP,WTPS,DETWTP,W3,W4,IPRAR)
C     MULTIPLY BY COMMON ERROR VARIANCE
      DETWTP = -LOG(EV)+DETWTP
      TMP = SQRT(EV)
      DO 70 I = 1, IPR
        DO 60 J = 1, IPR
          WTP(I,J) = EV*WTP(I,J)
          WTPS(I,J) = TMP*WTPS(I,J)
   60   CONTINUE
   70 CONTINUE
C     PRINT, USING FORMAT 6G11.4
      IPRN = 20
c      WRITE (IIOUTP,500)
c      CALL ULAPRW(WTP,ANAME,0,0,IPR,IPR,0,IPRN,IIOUT)
c      WRITE (IIOUTP,505)
c      CALL ULAPRW(WTPS,ANAME,0,0,IPR,IPR,0,IPRN,IIOUT)
      RETURN
      END

C=======================================================================
      SUBROUTINE SPRD1PES1PI(EV,EQNAM,IIOUT,IUPAR,LN,MPR,NPLIST,PRM,WP,
     &                      MPRAR,IAPLOT,NAMES,IPR,ND,IERR,NIPR,IPRAR,
     &                      IFAIL,PARNAM,ISS,AFILE,
     +                      VMULT,NSETS,ISETPLT,ISYMBOL,NPDIM)
c  NIL,
C=======================================================================
C     VERSION 19990504 ERB (as SPES1BAS6PI in PES Process files)
C     MODIFIED AUG 2003 MJT (as SPRD1PES1PI)
C     WRITE PRIOR INFO SCALED BY VMULT FOR PREDICTIVE ANALYSIS
C     ******************************************************************
C     READ PRIOR-INFORMATION EQUATIONS (PES ITEM 9)
C     ******************************************************************
C       SPECIFICATIONS:
C     ------------------------------------------------------------------

      USE DRIVER
      IMPLICIT NONE

      INTEGER I, ICOL, ISP, ISTART,ISTOP,KLOGS, L, LN, MPR, NPLIST,
     +        IFAIL,IERR,IIOUT,IUPAR,ND,IPR,IPRAR,MPRAR,LENG,KTERMS,
     +        N, KP, IP, ISP1,IPCK,J,IPNEXT1, KI, IP1ST,NSETS,ISS,NPDIM
C      ISETN,
      INTEGER IAPLOT(ND+IPR+MPR), NIPR(IPRAR), ISETPLT(NSETS,ISETCNT),
     +        ISYMBOL(NSETS)
C      ,IOMIT,ISETTYP(NSETS),
      CHARACTER LINE*200, EQNAM*10, EQUAL*1, RW*20, TIMES*1, PNAM*10,
     &          PLUS*1, MINUS*1
      CHARACTER*12 NAMES(ND+IPR+MPR)
      CHARACTER*10 PNTEMP, PNAM1,PARNAM
C      , VALTEMP
      CHARACTER*16 AITN
      CHARACTER*6 BITN
      CHARACTER*100 AFILE
      REAL COEF, EV, PRM, WP, R, SIGN, COEF1, STATP, CVLOG2LN, WPP, BB,
     +     TVAL, VMULT(NSETS), STATPUNSC
      DIMENSION EQNAM(MPRAR), LN(NPDIM), prm(nplist+1,MPRAR),
     +          WP(MPRAR),PARNAM(NPDIM)
      DOUBLE PRECISION VARMIN

      LOGICAL ISNUM
C     ------------------------------------------------------------------
 1000 FORMAT(A200)
 1010 FORMAT(/,
     &3X,'EQUATIONS OF PRIOR INFORMATION ON PARAMETERS',//,
     &4X,'EQUATION',5X,'PRIOR',6X,'----EQUATION TERMS-----',10X,
     &'      STAT*       STAT-   PLOT',/,
     &6X,'NAME',6X,'ESTIMATE',4X,'COEFFICIENT  PARAMETER',4X,
     &'  STAT       VMULT       FLAG   SYMBOL',/,3X,
     &10('-'),2(2X,11('-')),2X,10('-'),2X,11('-'),2X,10('-'),2X,
     +6('-'),2X,6('-'))
 1015 FORMAT(3X,A,1P,2(2X,G11.4),2X,A,2(2X,G11.4),3X,I2,4X,I4)
 1016 FORMAT(9X,'Additional term:',1X,1P,G11.4,2X,A)
C
      VARMIN = 1.0E-23
      EQUAL = '='
      PLUS = '+'
      MINUS = '-'
      TIMES = '*'
      CVLOG2LN = LOG(10.0)
      LENG = LEN(LINE)
C
C     PRINT TABLE HEADING
      WRITE (IOUTP,1010)
C
C-----READ MPR EQUATIONS
      DO 80 I = 1,MPR
        CLINE = ' '
        ICOL = 1
        ISTART = 1
        ISTOP = LENG
        KLOGS = 0
        KTERMS = 0
        READ(IUPAR,1000,END=90) LINE
C
C-------GET EQUATION NAME
        CALL URWORD(LINE,ICOL,ISTART,ISTOP,1,N,R,IIOUT,0)
        EQNAM(I) = LINE(ISTART:ISTOP)
        NAMES(ND+I) = EQNAM(I)
        CLINE = TRIM(ADJUSTL(CLINE))//' '//EQNAM(I)
C
C-------GET PRIOR ESTIMATE
        CALL URWORD(LINE,ICOL,ISTART,ISTOP,3,N,PRM(NPLIST+1,I),IIOUT,0)
        CALL UWRTSIG(IFAIL,prm(nplist+1,I),AITN,16,0,TVAL,0)
        CLINE = TRIM(ADJUSTL(CLINE))//' '//AITN
C
C-------GET EQUAL SIGN
        CALL URWORD(LINE,ICOL,ISTART,ISTOP,0,N,R,IIOUT,0)
        IF (LINE(ISTART:ISTOP).NE.EQUAL) THEN
          WRITE(IOUTP,1020)EQNAM(I)
 1020     FORMAT(' "=" SYMBOL NOT FOUND IN PRIOR-INFORMATION',
     &           ' EQUATION "',A10,'"',/,' -- STOP EXECUTION')
          IFAIL = 1
          RETURN
        ENDIF
        SIGN = 1.0
        CLINE = TRIM(ADJUSTL(CLINE))//' '//EQUAL
C
C-------GET COEFFICIENTS AND PARAMETER NAMES
 20     CONTINUE
        CALL URWORD(LINE,ICOL,ISTART,ISTOP,1,N,R,IOUTP,0)
        IF (LINE(ISTART:ISTOP).EQ.'STAT') THEN
          CLINE = TRIM(ADJUSTL(CLINE))//' '//'STAT'
          GOTO 60
        END IF
        IF (LINE(ISTART:ISTOP).EQ.PLUS) THEN
          CLINE = TRIM(ADJUSTL(CLINE))//' '//PLUS
          SIGN = 1.0
          GOTO 20
        ENDIF
        IF (LINE(ISTART:ISTOP).EQ.MINUS) THEN
          CLINE = TRIM(ADJUSTL(CLINE))//' '//MINUS
          SIGN = -1.0
          GOTO 20
        ENDIF
C
        PNAM = LINE(ISTART:ISTOP)
        CLINE = TRIM(ADJUSTL(CLINE))//' '//PNAM
C
C-------CHECK TO SEE IF STRING CAN BE INTERPRETED AS A NUMBER
        RW=' '
        L=20-ISTOP+ISTART
        RW(L:20)=LINE(ISTART:ISTOP)
        ISNUM=.FALSE.
        READ(RW,'(F20.0)',ERR=30) COEF
C
C-------IF NO READ ERROR, STRING IS A COEFFICIENT
        ISNUM=.TRUE.
 30     CONTINUE
C
        IF (ISNUM) THEN
C---------IF STRING IS A COEFFICIENT, GET "*" AND PARAMETER NAME
          CALL URWORD(LINE,ICOL,ISTART,ISTOP,0,N,R,IOUTP,0)
          IF (LINE(ISTART:ISTOP).NE.TIMES) THEN
            WRITE(IIOUT,1030) EQNAM(I)
 1030       FORMAT(' "*" SYMBOL NOT FOUND IN PRIOR-INFORMATION',
     &             ' EQUATION "',A10,'"',/,' -- STOP EXECUTION')
            IFAIL = 1
            RETURN
          ENDIF
          CLINE = TRIM(ADJUSTL(CLINE))//' '//TIMES
          CALL URWORD(LINE,ICOL,ISTART,ISTOP,1,N,R,IOUTP,0)
          PNAM = LINE(ISTART:ISTOP)
          CLINE = TRIM(ADJUSTL(CLINE))//' '//PNAM
        ELSE
C---------IF STRING IS NOT A NUMBER, SET COEF = 1
          COEF = 1.0
        ENDIF
C
C-------LOOK UP PARAMETER NUMBER
        DO 40 KP=1,NPLIST
          CALL UCASE(PARNAM(KP),PNTEMP,1)
          IF (PNAM.EQ.PNTEMP) THEN
            IP = KP
            GOTO 50
          ENDIF
 40     CONTINUE
C
C-------IF NO MATCH FOUND FOR PARAMETER NAME, PRINT ERROR MESSAGE
        WRITE(IOUTP,1040)PNAM,EQNAM(I)
 1040   FORMAT(' PARAMETER NAME "',A10,'" IN PRIOR-',
     &         'INFORMATION EQUATION "',A10,'"',/' NOT FOUND',
     &         ' -- STOP EXECUTION (SPRD1PES1PI)')
          IFAIL = 1
          RETURN
 50     CONTINUE
C
C       PRINT WARNING IF PARAMETER WAS INCLUDED IN FULL WEIGHT MATRIX
        IF (IPR.GT.0) THEN
          DO 52 KP = 1,IPR
            IF (NIPR(KP).EQ.IP) THEN
              WRITE(IOUTP,1042) PARNAM(IP)
              IF (IERR.EQ.0) IERR = -1
            ENDIF
   52     CONTINUE
        ENDIF
 1042   FORMAT(/,
     &' WARNING: THE SAME PARAMETER (',A,') HAS BEEN SPECIFIED',/,
     &' IN MORE THAN ONE TYPE OF PRIOR INFORMATION.  THIS USUALLY',/,
     &' IS A MISTAKE.')
C
C       IF PARAMETER IS USED IN MORE THAN ONE EQUATION, PRINT WARNING
        DO 55 KI = 1, I
          IF (PRM(IP,KI).NE.0.0) THEN
            WRITE(IOUTP,1045) PNAM
            IF (IERR.EQ.0) IERR = -1
          ENDIF
 55     CONTINUE
 1045   FORMAT(/,1X,48('*'),/,
     &  ' *  WARNING: PARAMETER "',   A10,'" IS USED IN  *',/
     &  ' *  MORE THAN ONE PRIOR-INFORMATION EQUATION    *',/
     &  ,1X,48('*'),/)
        PRM(IP,I) = SIGN*COEF
        KTERMS = KTERMS + 1
        IF (KTERMS.EQ.1) THEN
          COEF1 = SIGN*COEF
          PNAM1 = PNAM
        ENDIF
C
C-------COUNT PARAMETERS IN THIS EQUATION THAT ARE ESTIMATED USING
C       LOG-TRANSFORMATION
        IF (LN(IP).GT.0) KLOGS = KLOGS + 1
C
C-------LOOP BACK TO GET NEXT STRING
        SIGN = 1.0
        GOTO 20
C
 60     CONTINUE
C
C       ALL TERMS IN EQUATION i HAVE BEEN READ.  NOW READ STATISTIC.
C
C-------IF THERE IS A LOG-TRANSFORMED PARAMETER IN THE EQUATION, THERE
C       SHOULD BE ONLY ONE PARAMETER
        IF (KLOGS.GT.0 .AND. KTERMS.GT.1) THEN
          WRITE(IOUTP,1050)EQNAM(I)
 1050     FORMAT(' PRIOR-INFORMATION EQUATION "',A10,
     &           '" CONTAINS A LOG-TRANSFORMED PARAMETER',/,
     &           ' AND MORE THAN ONE PARAMETER',/,
     &           ' -- STOP EXECUTION (SPRD1PES1PI)')
          IFAIL = 1
          RETURN
        ENDIF
C
C-------GET STATP AND ISP (STAT-FLAG)
        CALL URWORD(LINE,ICOL,ISTART,ISTOP,3,N,STATP,IOUTP,0)
        CALL URWORD(LINE,ICOL,ISTART,ISTOP,2,ISP,R,IOUTP,0)
C-------GET PLOT SYMBOL
        CALL URWORD(LINE,ICOL,ISTART,ISTOP,2,IAPLOT(ND+I),R,IOUTP,0)

C    == SCALE THE STATISTIC WITH VMULT                                  !LOG TRANSFORMED PARAMETERS
        STATPUNSC = STATP
        CALL SPRD1SETS1VM(IFAIL,STATP,ISP,VMULT,NSETS,
     +                     AFILE,IAPLOT(ND+I),ISETPLT,ISYMBOL)
        WP(I) = STATP
        CALL UWRTSIG(IFAIL,STATP,AITN,16,0,TVAL,0)
        CLINE = TRIM(ADJUSTL(CLINE))//' '//AITN
        WRITE(BITN,'(I6)') ISP
        CLINE = TRIM(ADJUSTL(CLINE))//' '//BITN
        WRITE(BITN,'(I6)') IAPLOT(ND+I)
        CLINE = TRIM(ADJUSTL(CLINE))//' '//BITN
C
C       PRINT PRIOR-INFORMATION EQUATION TO IIOUT
        IF (ISS.EQ.2) WRITE(IIOUT,'(A)') CLINE

C       PRINT PRIOR-INFORMATION SUMMARY TO IOUTP
        WRITE(IOUTP,1015) EQNAM(I),prm(nplist+1,I),COEF1,PNAM1,
     +                    STATPUNSC,STATP,ISP,IAPLOT(ND+I)
C
C       CHECK FOR VALID VALUE OF ISP
        ISP1 = ISP
        IF (KLOGS.GT.0) THEN
          IF (ISP.GE.10) ISP1 = ISP - 10
          IF (ISP1.LT.0 .OR. ISP1.GT.2) THEN
            WRITE(IOUTP,1055) EQNAM(I),ISP
            IFAIL = 1
            RETURN
          ENDIF
        ELSE
          IF (ISP.LT.0 .OR. ISP.GT.2) THEN
            WRITE(IOUTP,1056) EQNAM(I),ISP
            IFAIL = 1
            RETURN
          ENDIF
        ENDIF
 1055   FORMAT(/,' *** ERROR: PRIOR-INFORMATION EQUATION "',A,
     &'" USES AN INVALID VALUE OF',/,
     &' STAT-FLAG (STAT-FLAG = ',I5,').  FOR AN',
     &' EQUATION CONTAINING A LOG-TRANSFORMED',/,
     &' PARAMETER, STAT-FLAG MUST BE 0, 1, 2, 10, 11, OR 12.',/,
     &' -- STOP EXECUTION (SPRD1PES1PI)')
 1056   FORMAT(/,' *** ERROR: PRIOR-INFORMATION EQUATION "',A,
     &'" USES AN INVALID VALUE OF',/,
     &' STAT-FLAG (STAT-FLAG = ',I5,').  FOR AN',
     &' EQUATION CONTAINING PARAMETERS',/,
     &' THAT ARE NOT LOG-TRANSFORMED,',
     &' STAT-FLAG MUST BE 0, 1, OR 2.',/,
     &' -- STOP EXECUTION (SPRD1PES1PI)')
C
        IF (KTERMS.GT.1) THEN
C         PRINT COEFFICIENT AND PARAMETER FOR ADDITIONAL EQUATION TERMS
          IP1ST = 1
          DO 65 J = 2,KTERMS
            DO 63 IPCK = IP1ST,NPLIST
              IF (PRM(IPCK,I).NE.0. .AND. PARNAM(IPCK).NE.PNAM1) THEN
                WRITE (IOUTP,1016) PRM(IPCK,I),PARNAM(IPCK)
                IPNEXT1 = IPCK + 1
                GOTO 64
              ENDIF
   63       CONTINUE
   64       CONTINUE
            IP1ST = IPNEXT1
   65     CONTINUE
        ENDIF
C
C----------CONVERT STATISTICS TO WEIGHTS; CALCULATE WP**.5 FOR PRINTING
        WPP = WP(I)
        BB = prm(nplist+1,I)
C
C       IF STATISTIC IS NOT VARIANCE, CONVERT TO VARIANCE (ALSO CONVERT
C       TO REGRESSION SPACE, IF REQUIRED)
        IF (KLOGS.GT.0) THEN
C         EQUATION IS FOR A LOG-TRANSFORMED PARAMETER
          BB = LOG(BB)
          IF (ISP.EQ.2) THEN
C           STAT IS C.V. IN NATIVE SPACE - CONVERT TO S.D. IN NATIVE SP.
            WPP = WPP*EXP(BB)
          ELSEIF (ISP.EQ.12) THEN
C           STAT IS C.V. IN LOG10 SPACE - CONVERT TO S.D. IN LOG10 SPACE
            WPP = WPP*BB/CVLOG2LN
          ENDIF
C         CONVERT S.D. TO VARIANCE
          IF (ISP1.GT.0) WPP = WPP**2.
C         ... CONVERT VARIANCE ...
          IF (ISP.GE.10) THEN
C           ... FROM LOG BASE 10 SPACE TO LOG BASE e SPACE
            WPP = WPP*CVLOG2LN**2
          ELSE
C           ... FROM NATIVE SPACE TO LOG BASE e SPACE
            WPP = LOG((WPP/(EXP(BB))**2) + 1.0)
          ENDIF
        ELSE
C         EQUATION IS FOR UNTRANSFORMED PARAMETER(S)
          IF (ISP.EQ.2) WPP = WPP*BB
          IF (ISP.GT.0) WPP = WPP**2.
        ENDIF
C
C       ENSURE THAT WPP IS NOT TOO SMALL
        IF (WPP.EQ.0.0) THEN
          WRITE(IOUTP,1057) EQNAM(I)
 1057     FORMAT(/,
     &' ERROR: THE VARIANCE FOR EQUATION "',A,'"  EVALUATES AS ZERO',/,
     &' -- STOP EXECUTION (SPRD1PES1PI)')
          IFAIL = 1
          RETURN
        ELSEIF (WPP.LT.VARMIN) THEN
          WRITE(IIOUT,1058) EQNAM(I),WPP,VARMIN
 1058     FORMAT(/,
     &' WARNING: THE VARIANCE CALCULATED FOR EQUATION "',A,'" IS ',
     &1PG11.4,/,
     &' SUCH SMALL VARIANCES CAN LEAD TO COMPUTATIONAL PROBLEMS.',/,
     &' TRY TO REDEFINE THE PARAMETER(S) SUCH THAT THE VARIANCE IS',/,
     &' AT LEAST ',G11.4)
        ENDIF
        WP(I) = (EV/WPP)**.5
C
 80   CONTINUE
C
      RETURN
C
C-----PRINT END-OF-FILE ERROR MESSAGE
 90   CONTINUE
      WRITE(IOUTP,1060)
 1060 FORMAT(' END-OF-FILE REACHED DURING ATTEMPT TO ',
     &        'READ PRIOR INFORMATION--STOP EXECUTION')
      IFAIL =1
      RETURN
C
      END

c=======================================================================
      SUBROUTINE SPRD1SEN1WT(IFAIL,ND,IPR,MPR,IHWT)
c=======================================================================
C     CALCULATES AND REPORTS THE WEIGHT MATRICES
C
C   VERSION 1, AUG 2003, MJT
C   - PORTIONS OF THIS CODE ARE EXTRACTED FROM ROUTINES PROVIDED WITH MF2K

      USE DRIVER
      IMPLICIT NONE

      INTEGER I,J,ND,IFAIL,MPR,IPR,IHWT,IROWS
      REAL DTLWTQ,EV,TMP
      DOUBLE PRECISION W1(ND,ND),W2(ND)
      REAL RWTQ(WMROW,WMCOL),RWTQS(WMROW,WMCOL)
C-----------------------------------------------------------------------

C   INITIALIZE

      W1 = 0.
      W2 = 0.
      EV = 1.0
      DTLWTQ = 0.0
      IROWS = WMCOL

C---REPORT THE ENTRIES FOR THE MATRICES AS READ AND SCALED FROM INPUTS

C     TERMS FOR HEAD OBS NOT WRITTEN
C     TERMS FOR HEAD-DEPENDENT FLOWS
C     -STORE IN SMALLER ARRAY
      DO I=1,WMROW
        DO J=1,WMCOL
          RWTQ(I,J) = XWTQ(I,J)
        END DO
      END DO
      IF (IWTMAT.GT.0) THEN
        WRITE(IOUTP,85)
85      FORMAT(/,3X,'COVARIANCES FOR HEAD-DEPENDENT FLOW OBS')
        DO I=1,WMROW
          WRITE(IOUTP,*) '   ',(RWTQ(I,J),J=1,WMCOL)
        END DO
      ENDIF

C---CALCULATE THE WEIGHT MATRICES
C   WEIGHT MATRIX FOR HEADS NOT ECHOED
C   WEIGHT MATRIX FOR HEAD-DEPENDENT FLOWS AND ADVECTIVE TRANSPORT
C     IS THE MATRIX DIAGONAL
      IF (IWTMAT.EQ.0) THEN
        DTLWTQ = 0.
        DO I = 1, WMROW
c          RWTQ(I,I) = EV/RWTQ(I,I)             !ALREADY DONE IN UWTCALC
          RWTQ(I,I) =  RWTQ(I,I)
          RWTQS(I,I) = SQRT(RWTQ(I,I))
          DTLWTQ = DTLWTQ + LOG(RWTQ(I,I))
        END DO
        GOTO 100
      ENDIF
C     IF THE MATRIX HAS ONLY ONE ENTRY (I.E. ONE OBSERVATION ONLY)
      IF (WMROW.EQ.1) THEN
        RWTQ(1,1) = EV/RWTQ(1,1)
        RWTQS(1,1) = SQRT(RWTQ(1,1))
        DTLWTQ = LOG(RWTQ(1,1))
        GOTO 100
      ENDIF
C     OTHERWISE - DECOMPOSE
      CALL SVD (IROWS,RWTQ,RWTQS,DTLWTQ,W1,W2,IROWS)
      DTLWTQ = EV*DTLWTQ
      TMP = SQRT(EV)
      DO I = 1,WMROW
        DO J = 1,WMCOL
          RWTQ(I,J) = EV*RWTQ(I,J)
C         XWTQS(I,J) = TMP*XWTQS(I,J)                                   !SEE CODE IN OBS1BAS6.F OF MODFLOW - ERROR?
        END DO
      END DO
100   CONTINUE

C---REPORT THE WEIGHT MATRICES TO MODPREDICT.OUT
C     HEADS WILL NOT BE WRITTEN
      IF (IHWT.GT.0) THEN
        WRITE(IOUTP,180)
180     FORMAT(/,3X,'PROCESSED WEIGHTS FOR HEAD OBS')
      ENDIF
C     HEAD-DEPENDENT FLOWS
      IF (WMROW.GT.0) THEN
        WRITE(IOUTP,200)
200     FORMAT(/,3X,'PROCESSED WEIGHT MATRIX FOR HEAD-DEP. AND ADV OBS')
        XWTQ = 0.
        DO I=1,WMROW
          DO J=1,WMCOL
              XWTQ(I,J) = RWTQ(I,J)
          END DO
C          WRITE(IOUTP,*) '   ',(XWTQ(I,J),J=1,WMCOL)
        END DO
      ENDIF

      RETURN
      END

c=======================================================================
      SUBROUTINE SPRD1SEN1COR(IFAIL,ND,IPR,MPR,IHWT,S_SU,NPE,OBSNAMED,
     +                     OBSNAME,IPLOTD,NPDIM,PARNAMTEMP,
     +                     OBSTYPE,NAMES,IAPLOT,IPLOTOP,XOPR,SUMSQ,
     +                     IOWTQ,H,HOBS,PRM,PAROPT,MPRAR,NPLIST,WP,IDRY,
     +                     LN,BSCAL)
c=======================================================================
C     CALCULATE THE COVARIANCE AND CORRELATION MATRIX FOR THE           CHECK PRM DIMENSIONING
C     PARAMETERS. THIS ROUTINE USES UNSCALED SENSITIVITIES WRITTEN
C     BY MF2K, AND THE WEIGHT MATRICES CALCULATED BY MODPREDICT.
C
C   VERSION 1, AUG 2003, MJT
C   - LARGE PORTIONS OF THIS CODE ARE EXTRACTED FROM "pes1bas6.f"
C       AND "pes1gau1.f" ROUTINES PROVIDED WITH MF2K, WHICH WERE WRITTEN
C       IN LARGE PART BY STEEN CHRISTENSON

      USE DRIVER
      IMPLICIT NONE

      INTEGER I,J,ND,IFAIL,MPR,IPR,IHWT,NPE,N,NPDIM,M,NF,K,
     +      IHCALC,NP,MP,IP,NP1,IP1,NM1,KP1,IDRY,IOWTQ,IPRC,IIPP,MPRAR,
     +      IPM,NPLIST
      INTEGER IPLOTD(ND+MPR+IPR),IAPLOT(ND+MPR+IPR),IPLOTOP(ND+MPR+IPR)
      INTEGER LN(NPDIM)
      CHARACTER*12 OBSNAMED(ND+MPR+IPR),NAMES(ND+MPR+IPR),
     +             OBSTYPE(ND+IPR+MPR),OBSNAME(ND+MPR+IPR),
     +             OBSNF(ND+IPR+MPR)
      CHARACTER*10 PARNAMTEMP(NPDIM)
      CHARACTER*1 XOPR(ND+IPR+MPR)
      REAL SUMSQ,H(ND+IPR+MPR),HOBS(ND+IPR+MPR),prm(nplist+1,MPRAR),
     +     PAROPT(NPDIM),TMPA,WP(MPRAR),BSCAL(NPDIM)
      DOUBLE PRECISION S_SU(NPDIM,ND),SCLE(NPE),COV(NPE,NPE),XDBVAR,
     +                 COR(NPE,NPE),DTMPA,VAR,DET,DPIV,DUM(NPE,NPE),
     +                 DTEMP,BUFF(NPE,NPE)
C-----------------------------------------------------------------------
C     INITIALIZE
      COV  = 0.
      COR = 0.
      SCLE = 1.
      DUM = 0.
      IPRC = 1                                                          !HARDWIRED MATRIX PRINTING FORMAT

C  CHECK ALL INFORMATION WAS READ CORRECTLY FROM UNDERSCORES
C    OBSERVATIONS FIRST: COMPARE NAMES AND OBSNAME
C                        LINE UP OBSTYPE WITH OBSNAME RATHER THAN NAMES
      NF=0
      DO N=1,ND
        DO M=1,ND-IDRY
          IF((NAMES(N).EQ.OBSNAME(M)).AND.(IAPLOT(N).EQ.IPLOTOP(M)))
     +      THEN
            GOTO 5
          END IF
        END DO
C       SOMETHING WAS MISSING - CHECK IF IT WAS AN OMIT
        IF (XOPR(N).NE.'X') THEN
          NF = NF+1
          OBSNF(NF)=NAMES(N)
          WRITE(IOUTP,*) NAMES(N),XOPR(N)
        ENDIF
5     END DO
      IF (NF.GT.0) THEN
        WRITE(IOUTP,10)
10      FORMAT(/,3X,'THE FOLLOWING OBS/PRIOR/PRED WERE NOT FOUND IN ',
     +         /,3X,'THE "OBS" UNDERSCORE FILES PRODUCED BY MF2K')
        DO N=1,NF
          WRITE(IOUTP,20) OBSNF(N)
20        FORMAT(3X,A12)
        END DO
        IFAIL = 1
        RETURN
      ELSE
        WRITE(IOUTP,30)
30      FORMAT(/,3X,'ALL OBS/PRIOR/PRED LISTED IN THE MF2K FILES WERE',
     +         /,3X,'FOUND IN "OBS" UNDERSCORE FILES PRODUCED BY MF2K')
      ENDIF

C    SENSITIVITIES NEXT: COMPARE NAMES AND OBSNAMED
C                        COMPARE PARNAM AND PARNAMTEMP
      NF=0
      DO N=1,ND
        DO M=1,ND-IDRY
          IF((NAMES(N).EQ.OBSNAMED(M)).AND.(IAPLOT(N).EQ.IPLOTD(M)))
     +      THEN
            GOTO 45
          END IF
        END DO
C       SOMETHING WAS MISSING - CHECK IF IT WAS AN OMIT
        IF (XOPR(N).NE.'X') THEN
          NF = NF+1
          OBSNF(NF)=NAMES(N)
        ENDIF
45    END DO
      IF (NF.GT.0) THEN
        WRITE(IOUTP,50)
50      FORMAT(/,3X,'THE FOLLOWING OBS/PRIOR/PRED WERE NOT FOUND IN ',
     +         /,3X,'THE "SEN" UNDERSCORE FILES PRODUCED BY MF2K')
        DO N=1,NF
          WRITE(IOUTP,60) OBSNF(N)
60        FORMAT(3X,A12)
        END DO
        IFAIL = 1
        RETURN
      ELSE
        WRITE(IOUTP,70)
70      FORMAT(/,3X,'ALL OBS/PRIOR/PRED LISTED IN THE MF2K FILES WERE',
     +         /,3X,'FOUND IN "SEN" UNDERSCORE FILES PRODUCED BY MF2K')
      ENDIF

C  MAKE THE ((XtX)-1) CALCULATIONS
C  - HEADS
      IHCALC=0
      IF (IHWT.GT.0) THEN
        DO N=1,ND
          IF ((OBSTYPE(N).EQ.'HEADS').AND.(XOPR(N).NE.'X')) THEN
            IHCALC=IHCALC+1
            DO NP=1,NPE
              DO MP=1,NPE
                DTEMP = S_SU(NP,N)*S_SU(MP,N)*DBLE(HWT(N))
                DUM(MP,NP) = DUM(MP,NP) + DTEMP
                COV(MP,NP) = COV(MP,NP) + DTEMP
              END DO
            END DO
          END IF
        END DO
c        WRITE(IOUTP,90)
c90      FORMAT(/,1X,'HEADS CONTRIBUTION TO COEFFICIENT MATRIX')
C        BUFF = DUM
C        CALL UPARPM(BUFF,NPE,IPRC,IOUTP,PARNAMTEMP,NPDIM)
      ENDIF

C  - FLOWS AND AVECTIVE TRANSPORT ARE COMPUTED TOGETHER
      IF (WMROW.GT.0) THEN
C       CALL MODIFIED VERSION OF STEEN CHRISTENSEN ROUTINE
        CALL SOBS1BAS6WF(NPE,IHWT,WMROW,XWTQ,S_SU,COV,HOBS,H,IWTMAT,
     +                   ND,NPDIM)
C       FILL IN LOWER HALF BY SYMMETRY
        DO I=2,NPE
          DO J=1,I-1
              COV(J,I)=COV(I,J)
          END DO
        END DO
        IF (IFAIL.NE.0) THEN
          WRITE(IOUTP,132)
132       FORMAT(/,1X,'ERROR PROCESSING HEAD-DEP. FLOW OBSERVATIONS')
          GOTO 999
        ENDIF
c        WRITE(IOUTP,150)
c150     FORMAT(/,1X,'FLOW AND ADV CONTRIBUTION TO COEFFICIENT MATRIX')
C        DUM = COV-DUM
C        BUFF = DUM
C        CALL UPARPM(BUFF,NPE,IPRC,IOUTP,PARNAMTEMP,NPDIM)
      END IF

C   PRIOR INFORMATION
C    ESTIMATES OF PARAMETER SUMS
      IF (MPR.GT.0) THEN
        DO IPM = 1, MPR
          TMPA = 0.
          DO IP = 1, NPLIST
            IF (PRM(IP,IPM).GT.0.) TMPA = TMPA + PRM(IP,IPM)*PAROPT(IP)
          END DO
          TMPA = PRM(NPLIST+1,IPM) - TMPA
          DO 290 IP = 1, NPE
            IIPP = IPPTR(IP)
            IF (PRM(IIPP,IPM).EQ.0.) GOTO 290
            DTMPA = DBLE(WP(IPM))*DBLE(PRM(IIPP,IPM))
            DO I = IP, NPE
              XDBVAR = DBLE(PRM(IPPTR(I),IPM))*DTMPA
              COV(I,IP) = (XDBVAR)**2. + COV(I,IP)
            END DO
  290     CONTINUE
        END DO
      ENDIF

C     ** CORRELATED PRIOR NOT IMPLEMENTED YET **
C      IF (IPR.GT.0) CALL SPES1GAU1PF(IPR,NIPR,WTP,C,G,NPE,NPLIST,PRM,B,
C     &                               BUFF,MPRAR,IPRAR,BPRI)

c    REPORT PROGRESS
      IF (IPR+MPR.GT.0) THEN
        WRITE(IOUTP,450)
450     FORMAT(/,1X,'PRIOR INFO CONTRIBUTION TO COEFFICIENT MATRIX')
        DUM = COV-DUM
        BUFF = DUM
        CALL UPARPM(BUFF,NPE,IPRC,IOUTP,PARNAMTEMP,NPDIM)
      ENDIF

C   SCALE THE COFFICIENT MATRIX
      NP1 = NPE-1
      NM1 = NP1
      IF (NPE.GT.1) THEN
        DO IP = 1, NPE
          SCLE(IP) = 1.0
          IF (COV(IP,IP).GT.1.E-30) SCLE(IP) = DSQRT(COV(IP,IP))
        END DO
        DO IP = 1, NP1
          DTMPA = SCLE(IP)
          IP1 = IP + 1
          DO I = IP1, NPE
            COV(I,IP) = COV(I,IP)/(SCLE(I)*DTMPA)
            COV(IP,I) = COV(I,IP)
          END DO
          COV(IP,IP) = 1.0
        END DO
        COV(NPE,NPE) = 1.0
      ENDIF

C   DECOMPOSE THE COEFFICIENT MATRIX
C      IND = 0
      DET = 1.
      DO K = 1, NM1
        DPIV = COV(K,K)
        DET = DET*DPIV
        IF (DPIV.GT.1.E-13) THEN
          DPIV = 1.0/DPIV
          KP1 = K + 1
          DO J = KP1, NPE
            DTMPA = COV(J,K)*DPIV
            DO I = J, NPE
              COV(I,J) = COV(I,J) - DTMPA*COV(I,K)
            END DO
          END DO
          COV(K,K) = DPIV
        ELSE
C          IND = 1
        ENDIF
      END DO
      DET = DET*COV(NPE,NPE)

C   COMPLETE THE INVERSION
      IF (NPE.LT.2) THEN
        COV(1,1) = 1.0/COV(1,1)
      ELSE
        CALL SPES1GAU1IN(NPE,COV)
      ENDIF

C   CALCULATE AND REPORT THE 'ERROR VARIANCE'
      IDRY = 0
      VAR = SUMSQ/REAL(ND-IDRY+MPR+IPR-NPE-NOMIT)

C   UNSCALE THE INVERTED MATRIX AND CALCULATE V-C MATRIX
      DO IP = 1, NPE
        DTMPA = SCLE(IP)
        DO I = IP, NPE
          COV(I,IP) = VAR*COV(I,IP)/(SCLE(I)*DTMPA)
          COV(IP,I) = COV(I,IP)
        END DO
        SCLE(IP) = DSQRT(COV(IP,IP))
      END DO

C   CALCULATE AND REPORT COMBINED CORRELATION MATRIX
      IF (NPE.GT.1) THEN
        DO IP = 1, NPE
          DTMPA = SCLE(IP)
          DO I = IP, NPE
            COR(I,IP) = COV(I,IP)/(SCLE(I)*DTMPA)
            COR(IP,I) = COR(I,IP)
          END DO
        END DO
      END IF
      WRITE(IOUTP,800)
800   FORMAT(/,1X,'COMBINED CORRELATION MATRIX')
      BUFF = COR
      IPRC = 1
      CALL UPARPM(BUFF,NPE,IPRC,IOUTP,PARNAMTEMP,NPDIM)

C     ALL OKAY - RETURN
      RETURN

999   IFAIL = 1
      WRITE(IOUTP,1000)
1000  FORMAT(//,1X,'ERROR CALCULATING COMBINED CORRELATION MATRIX ',
     +             '(SPRD1SEN1COR)')

      RETURN
      END

C=======================================================================
      SUBROUTINE SPRD1SEN1CSS1(IFAIL,IOWTQ,IAPLOT,IPR,MPR,LN,ND,
     +                     NPE,NPDIM,NAMES,S_SU,BSCAL,OBSTYPE,XOPR,IHWT,
     +                     PARNAMTEMP,PAROPT,IDRY,PCSS,NSETS,
     +                     PRM,MPRAR,NPLIST,WP)
C
C     VERSION 20000313 ERB (SOBS1BAS6ST)
C     MODIFIED BY MJT 10/25/03 - GROUP BY SETS, DEAL WITH PRIOR
C     ******************************************************************
C     PRINT OBSERVATION-SENSITIVITY TABLES
C     ******************************************************************
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      USE DRIVER
      IMPLICIT NONE

      INTEGER IOWTQ, IPR, MPR, ND, NPE, IFAIL, NPDIM, N, IIP, IHWT,IIPP,
     +        NQ1, K, IDRY, NSETS,MPRAR,NPLIST,IPM
C      ,IP,I,NP,
      CHARACTER*12 NAMES(ND+IPR+MPR),OBSTYPE(ND+IPR+MPR)
      CHARACTER*1 XOPR(ND+IPR+MPR)
      CHARACTER*10 PARNAMTEMP(NPDIM)
      INTEGER IAPLOT(ND+IPR+MPR),LN(NPDIM)
      DOUBLE PRECISION S_SU(NPDIM,ND),BUF1(NPDIM),BUF2(NPDIM,ND),
     +                 BB,TMP,PCSS(NPDIM,NSETS)
      REAL PRM(NPLIST+1,MPRAR),WP(MPRAR),DTMPA,
     +     BSCAL(NPDIM),PAROPT(NPDIM)
C      TMPA,DELTA
C     ------------------------------------------------------------------

C      DELTA = 1.01

C  REPORT THE COMPILED UNSCALED SENSITIVITY DATA?

C     PRINT UNSCALED SENSITIVITIES
C      WRITE(IOUTP,10)
C  10  FORMAT(/,1X,'UNSCALED SENSITIVITIES COMPILED FROM MF2K RUNS')
C      WRITE (IOUTP,*) (PARNAMTEMP(N),N=1,NPE)
C      DO N = 1, ND
C        WRITE (IOUTP,*) NAMES(N),(S_SU(IIP,N),IIP=1,NPE)
C      END DO
      BUF1 = 0.                                             !IS AN ARRAY
      BUF2 = 0.                                             !IS AN ARRAY

C  -- HEADS

      IF (IHWT.GT.0) THEN
        DO N=1,ND
          IF ((OBSTYPE(N).EQ.'HEADS').AND.((XOPR(N).EQ.'O').OR.
     +                                    (XOPR(N).EQ.'C'))) THEN
            DO IIP=1,NPE
              IIPP = IPPTR(IIP)
              BB = ABS(PAROPT(IIPP))
              IF (LN(IIPP).LE.0) THEN
C               PARAMETER IS NOT LOG-TRANSFORMED
                IF (BB.LT.DBLE(BSCAL(IIPP))) BB = DBLE(BSCAL(IIPP))
              ELSE
C               PARAMETER IS LOG-TRANSFORMED
                BB = 1.0
              ENDIF
              BUF2(IIP,N) = BB*S_SU(IIP,N)*(DBLE(HWT(N)**.5))
              BUF1(IIP) = BUF1(IIP) + (BUF2(IIP,N)*BUF2(IIP,N))
            END DO
          END IF
        END DO
      END IF

C  -- FLOWS AND ADV

      IF (WMROW.GT.0) THEN
        DO 120 N = 1,WMROW
          NQ1 = N
C         CHECK IS NOT "PREDICTION" GOING DOWN ROWS
          IF ((OBSTYPE(N+IHWT).NE.'HEADS').AND.
     +       ((XOPR(N+IHWT).EQ.'O').OR.(XOPR(N+IHWT).EQ.'C'))) THEN
C           PROCEED WITH THIS ROW OF THE HEAD-DEPENDENT AND ADV OBS
            DO 110 IIP = 1,NPE
              IIPP = IPPTR(IIP)
              IF (XWTQ(NQ1,NQ1).LT.0.) THEN              !DIAGONAL TERMS
                BUF2(IIP,N+IHWT) = 0.
                GOTO 110
              ENDIF
              BB = DBLE(ABS(PAROPT(IIPP)))
              IF (LN(IIPP).LE.0) THEN
C               PARAMETER IS NOT LOG-TRANSFORMED
                IF (BB.LT.DBLE(BSCAL(IIPP))) BB = DBLE(BSCAL(IIPP))
              ELSE
C               PARAMETER IS LOG-TRANSFORMED
                BB = 1.0
              ENDIF
              IF (IOWTQ.GT.0) THEN                   !OFF-DIAGONAL TERMS
                TMP = 0.
                DO 100 K = 1, WMROW
C                 CHECK IS NOT "PREDICTION" GOING ALONG COLUMNS
                  IF ((OBSTYPE(K+IHWT).NE.'HEADS').AND.
     +             ((XOPR(K+IHWT).EQ.'O').OR.(XOPR(K+IHWT).EQ.'C')))THEN
C                   IF A MEMBER OF A SET - WHICH SET
                    IF (XWTQ(K,K).GT.0.) TMP = TMP + SQRT(XWTQ(NQ1,K))
     &                                               *S_SU(IIP,IHWT+K)
                  END IF
  100           CONTINUE
                BUF2(IIP,N) = BB*TMP
              ELSE
                BUF2(IIP,N+IHWT)=BB*S_SU(IIP,N+IHWT)*SQRT(XWTQ(NQ1,NQ1))
              ENDIF
C             CONTRIBUTION TO COMPOSITE SCALED SENSITIVITY
              BUF1(IIP) = BUF1(IIP)+(BUF2(IIP,N+IHWT)*BUF2(IIP,N+IHWT))
  110       CONTINUE
          END IF
  120   CONTINUE
      ENDIF

C     PRINT DIMENSIONLESS SCALED SENSITIVITIES (SCALED BY B*(WT**.5))
C      WRITE(IOUTP,130)
C  130 FORMAT(/,1X,'DIMENSIONLESS SCALED SENSITIVITIES ',
C     +            '(SCALED BY B*(WT**.5))')
C      WRITE (IOUTP,*) (PARNAMTEMP(N),N=1,NPE)
C      DO N = 1, ND
C        WRITE (IOUTP,*) NAMES(N),(BUF2(IIP,N),IIP=1,NPE)
C      END DO

      IF (MPR.GT.0) THEN
        DO IIP = 1,NPE
          BB = DBLE(ABS(PAROPT(IIP)))
          IF (LN(IIP).LE.0) THEN
C           PARAMETER IS NOT LOG-TRANSFORMED
            IF (BB.LT.DBLE(BSCAL(IIP))) BB = DBLE(BSCAL(IIP))
          ELSE
C           PARAMETER IS LOG-TRANSFORMED
            BB = 1.0
          ENDIF
C         CHECK FOR EACH EQUATION FOR OCCURENCE OF THIS PARAMETER
          DTMPA = 0.
          DO 300 IPM = 1, MPR
            IIPP = IPPTR(IIP)
            IF (PRM(IIPP,IPM).EQ.0.) GOTO 300
            DTMPA = DTMPA + (SQRT(DBLE(WP(IPM)))*DBLE(PRM(IIPP,IPM))*BB)
  300     CONTINUE
C         CONTRIBUTION TO COMPOSITE SCALED SENSITIVITY
          BUF1(IIP) = BUF1(IIP) + DTMPA**2.
        END DO
      ENDIF

C  -- COMPLETE AND PRINT THE CSS INCLUDING PRIOR IF PRESENT

      DO IIP = 1,NPE
        BUF1(IIP) = (BUF1(IIP)/(ND+MPR-NPRED-NOMIT-IDRY))**.5
      END DO
      IF (MPR.LE.0) THEN
          WRITE (IOUTP,500)
        ELSE
          WRITE (IOUTP,501)
      END IF
      DO IIP = 1, NPE
        WRITE (IOUTP,*) PARNAMTEMP(IPPTR(IIP)),BUF1(IIP)
      END DO

  500 FORMAT(/,1X,'COMPOSITE SCALED SENSITIVITIES FOR ALL MEMBERS OF',
     +       /,1X,'CALIBRATION SETS',/)
  501 FORMAT(/,1X,'COMPOSITE SCALED SENSITIVITIES FOR ALL MEMBERS OF',
     +       /,1X,'CALIBRATION SETS - INCLUDING PRIOR INFORMATION',/)

      RETURN
      END

C=======================================================================
      SUBROUTINE SOBS1BAS6WF(NPE,IHWT,WMROW,XWTQ,S_SU,C,HOBS,H,IOWTQ,
     &                       ND,NPDIM)
C-----VERSION 1000 02FEB1996
C     ******************************************************************
C     ADD SENSITIVITY CONTRIBUTIONS FROM NON-HEAD DATA WITH FULL WEIGHT
C     MATRIX TO C AND G
C     (DEVELOPED BY STEEN CHRISTENSEN, AARHUS UNIVERSITY)
C     MODIFIED AUG 2003, MJT
C     ******************************************************************
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      REAL DTMPA, H, HOBS, W
      INTEGER I, IOWTQ, IP, J, K, L, L1, N, N1, NPE,IHWT, WMROW
      DOUBLE PRECISION C(NPE,NPE), TMP, S_SU(NPDIM,ND)
      DIMENSION XWTQ(ND,ND), HOBS(ND), H(ND)
C     ------------------------------------------------------------------
C
      IF (IOWTQ.GT.0) THEN
        DO 50 J = 1, NPE
          DO 40 K = 1, WMROW
            TMP = 0.0
            IF (XWTQ(K,K).LT.0.0) THEN
              DO 10 L = 1, WMROW
                TMP = TMP + 1.E-20*(S_SU(J,IHWT+L))
   10         CONTINUE
            ELSE
              DO 20 L = 1, WMROW
                IF (XWTQ(L,L).LT.0.0) THEN
                  TMP = TMP + 1.E-20*(S_SU(J,IHWT+L))
                ELSE
                  TMP = TMP + DBLE(XWTQ(K,L))*(S_SU(J,IHWT+L))
                ENDIF
   20         CONTINUE
            ENDIF
            DO 30 I = J, NPE
              C(I,J) = C(I,J) + (S_SU(I,IHWT+K))*TMP
   30       CONTINUE
   40     CONTINUE
   50   CONTINUE
        DO 90 I = 1, NPE
          DO 80 K = 1, WMROW
            TMP = 0.0
            IF (XWTQ(K,K).LT.0.0) THEN
              DO 60 L = 1, WMROW
                L1 = IHWT + L
                TMP = TMP + 1.E-20*DBLE(HOBS(L1)-H(L1))
   60         CONTINUE
            ELSE
              DO 70 L = 1, WMROW
                L1 = IHWT + L
                IF (XWTQ(L,L).LT.0.0) THEN
                  TMP = TMP + 1.E-20*DBLE(HOBS(L1)-H(L1))
                ELSE
                  TMP = TMP + DBLE(XWTQ(K,L))*DBLE(HOBS(L1)-H(L1))
                ENDIF
   70         CONTINUE
            ENDIF
   80     CONTINUE
   90   CONTINUE
      ELSE
C     IF WEIGHT MATRIX IS DIAGONAL
        DO 120 N = 1, WMROW
          N1 = N + IHWT
c          TMPA = HOBS(N1) - H(N1)
          W = XWTQ(N,N)
          IF (W.LT.0) W = 1.E-20
          DO 110 IP = 1, NPE
            DTMPA = DBLE(W)*(S_SU(IP,N1))
            DO 100 I = IP, NPE
              C(I,IP) = (S_SU(I,N1))*DTMPA + C(I,IP)
  100       CONTINUE
  110     CONTINUE
  120   CONTINUE
      ENDIF
C      IF (IFO.EQ.0) THEN                                               !IFO?
C        DO 130 K = 1, WMROW
C          IF (XWTQ(K,K).LT.0.0) XWTQ(K,K) = -XWTQ(K,K)
C  130   CONTINUE
C      ENDIF
      RETURN
      END

C=======================================================================
      SUBROUTINE SPES1GAU1IN(NPE,C)
C-----VERSION 1000 01FEB1992 (LIFTED DIRECTLY FROM MF2K FOR MODPREDICT)
C     ******************************************************************
C         COMPLETE CALCULATION OF THE INVERSE OF SCALED
C         COEFFICIENT MATRIX C STARTING FROM DECOMPOSED MATRIX
C         FROM SPES1GAU1SL, FOR NPE>1
C     ******************************************************************
C         SPECIFICATIONS:
C     ------------------------------------------------------------------
      INTEGER I, IM1, J, K, KP1, NPE, NP1
      DOUBLE PRECISION C(NPE,NPE), DSUM
C     ------------------------------------------------------------------
      NP1 = NPE - 1
      C(NPE,NPE) = 1.0/C(NPE,NPE)
      DO 50 K = 1, NP1
        KP1 = K + 1
        DO 20 I = KP1, NPE
          DSUM = 0.0
          IM1 = I - 1
          DO 10 J = K, IM1
            DSUM = DSUM + C(I,J)*C(J,K)
   10     CONTINUE
          C(K,I) = -DSUM
          C(I,K) = -DSUM*C(I,I)
   20   CONTINUE
        DO 40 I = 1, K
          DSUM = C(K,I)
          DO 30 J = KP1, NPE
            DSUM = DSUM + C(J,K)*C(I,J)
   30     CONTINUE
          C(K,I) = DSUM
          C(I,K) = C(K,I)
   40   CONTINUE
   50 CONTINUE
      RETURN
      END

C=======================================================================
      SUBROUTINE SPRD1SEN1SORT(IFAIL,S_SU,ND,NPE,NAMES,NOMIT,OBSTYPE,
     +               IPLOTOP,IPR,MPR,IAPLOT,NPDIM,IDRY,
     +               H,HOBS,RES,UWH,UWHOBS,UWRES,KTDIM,IOUTP,OBSNAME)
C=======================================================================
C     SORT THE HOBS,RES,S_SU TO MATCH THE ORDER AS READ FROM "OBS" FILES
C     VERSION 1, AUG 2003, MJT

      IMPLICIT NONE
      INTEGER IFAIL,ND,NPE,NOMIT,MPR,IPR,NPDIM,N,J,IDRY,M,KTDIM,MM,IA,NN
      INTEGER IPLOTOP(ND+IPR+MPR),IAPLOT(ND+IPR+MPR),IMATCH,IOUTP
C     +        IMARR(ND+IPR+MPR)
      DOUBLE PRECISION S_SU(NPDIM,ND),TS_SU(NPDIM,ND)
      REAL H(ND+IPR+MPR),HOBS(ND+IPR+MPR),RES(ND+IPR+MPR),
     +     UWH(ND+IPR+MPR),UWHOBS(ND+IPR+MPR),UWRES(ND+IPR+MPR)
      REAL TH(ND+IPR+MPR),THOBS(ND+IPR+MPR),TRES(ND+IPR+MPR),
     +     TUWH(ND+IPR+MPR),TUWHOBS(ND+IPR+MPR),TUWRES(ND+IPR+MPR)
      CHARACTER*12 NAMES(ND+IPR+MPR),OBSTYPE(ND+IPR+MPR),
     +             OBSNAME(ND+IPR+MPR)
C     ------------------------------------------------------------------

      WRITE(IOUTP,1)
1     FORMAT(/,1X,'MATCHING DATA READ FROM UNDERSCORE FILES WITH ',
     +            'NAMES/PLOT-SYMBOLS AS ',
     +       /,1X,'READ FROM "OBS" FILES.')

C     INTIALIZE

      TS_SU = 0.
      TH = 0.
      THOBS = 0.
      TRES  = 0.
      TUWH = 0.
      TUWHOBS = 0.
      TUWRES = 0.

C     FILL IN OBSYTYPE = 'PRI' FOR PRIOR                                - COULD DO THIS IN "PES" ROUTINES
      DO N=ND+1,ND+IPR+MPR
        OBSTYPE(N) = 'PRI'
      END DO

C  -- CHECK TABLE
C      DO N=1,ND+IPR+MPR
C        WRITE(*,*) NAMES(N),IAPLOT(N),OBSTYPE(N),OBSNAMED(N),IPLOTD(N),
C     +             (S_SU(M,N),M=1,3)
C      END DO

      IMATCH = 0
C      IMARR  = 0
      NN = 0
      DO N=1,ND+IPR+MPR-NOMIT-IDRY
        NN = NN+1
        IF (NN.EQ.(1+ND+IPR+MPR-NOMIT-IDRY)) THEN
          GOTO 100
        ENDIF
        MM = 0
        DO M=1,ND+IPR+MPR
          MM = MM + 1
          IF (MM.EQ.(1+ND+IPR+MPR)) THEN
            GOTO 80
          ENDIF
          IF ((OBSNAME(NN).EQ.NAMES(MM)).AND.
     +       (IPLOTOP(NN).EQ.IAPLOT(MM))) THEN
            IMATCH     = IMATCH + 1
            TH(MM)     = H(NN)
            THOBS(MM)  = HOBS(NN)
            TRES(MM)   = RES(NN)
            TUWH(MM)   = UWH(NN)
            TUWHOBS(MM)= UWHOBS(NN)
            TUWRES(MM) = UWRES(NN)
            IF (NN.LE.ND+IDRY) THEN                !NO SENSITIVITES FOR PRIOR
              DO J=1,NPE
                TS_SU(J,MM)=S_SU(J,NN)
              END DO
            ENDIF
c           DEAL WITH ADV
            IF (OBSTYPE(MM).EQ.'ADV') THEN
              DO IA=1,KTDIM-1
                MM = MM + 1
                NN = NN + 1
                IF ((OBSNAME(NN).EQ.NAMES(MM)).AND.
     +             (IPLOTOP(NN).EQ.IAPLOT(MM))) THEN
                  IMATCH     = IMATCH + 1
                  TH(MM)     = H(NN)
                  THOBS(MM)  = HOBS(NN)
                  TRES(MM)   = RES(NN)
                  TUWH(MM)   = UWH(NN)
                  TUWHOBS(MM)= UWHOBS(NN)
                  TUWRES(MM) = UWRES(NN)
                  IF (NN.LE.ND) THEN
                    DO J=1,NPE
                      TS_SU(J,MM)=S_SU(J,NN)
                    END DO
                  END IF
                ELSE
C                 ONE OF THE KTDIM ENTRIES DOES NOT MATCH
                  WRITE(IOUTP,50)
50                FORMAT(/,1X,'ERROR MATCHING ADV OBSERVATIONS READ ',
     +                      'FROM UNDERSCORES WITH THOSE READ FROM ',
     +                      'ORIGINAL "OBS" FILES')
                  GOTO 999
                END IF
              END DO
            END IF
          END IF
        END DO
80      CONTINUE
      END DO
100   CONTINUE
C     CHECK WE GOT THE RIGHT NUMBER OF MATCHES
      IF (IMATCH.NE.(ND+IPR+MPR-NOMIT-IDRY)) THEN
          WRITE(IOUTP,190) IMATCH, ND+IPR+MPR-NOMIT-IDRY, NOMIT
190       FORMAT(/,1X,3(I5))
          WRITE(IOUTP,200)
200       FORMAT(/,1X,'ERROR MATCHING SENSITIVITIES WITH OBSERVATIONS ',
     +                'AS READ FROM "OBS" FILES')
          GOTO 999
      ENDIF

C     RESTORE THE ARRAYS FROM THE TEMP ARRAYS
      S_SU  = 0.
      S_SU  = TS_SU
      H     = 0.
      H     = TH
      HOBS  = 0.
      HOBS  = THOBS
      RES   = 0.
      RES   = TRES
      UWH   = 0.
      UWH   = TUWH
      UWHOBS= 0.
      UWHOBS= TUWHOBS
      UWRES = 0.
      UWRES = TUWRES

C  -- CHECK TABLE
C      DO N=1,ND
C        WRITE(*,*) NAMES(N),IAPLOT(N),OBSTYPE(N),OBSNAMED(N),IPLOTD(N),
C     +             (S_SU(M,N),M=1,3)
C      END DO
      RETURN

999   IFAIL = 1
      WRITE(IOUTP,1000)
1000  FORMAT(//,1X,'ERROR SORTING SENSTIVITIES - STOPPING (SENSORT)')
      RETURN

      END

C=======================================================================
      SUBROUTINE SPRD1PRED1WR(IFAIL,ND,NPDIM,NPE,SPP,SPR,SPS,
     +                        XOPR,PREDBASE,IPR,MPR,PARNAMTEMP,IAPLOT,
     +                        OBSNAME,IOUTP,PRESUF)
C=======================================================================
C     WRITE THE NEW PREDICTION UNDERSCORE FILES SPS,SPR,SPP

      IMPLICIT NONE
      INTEGER IFAIL,ND,NPDIM,IPR,MPR,NPE,IGETUNIT,ISPS,ISPR,ISPP,IERR,
     +        IAPLOT(ND+IPR+MPR),IOUTP,N,I
      CHARACTER*200 PREDBASE,FNAM
      CHARACTER*500 ASPP,ASPR,ASPS
      CHARACTER*10 PARNAMTEMP(NPDIM)
      CHARACTER*20 HEADER,FMTC
      CHARACTER*23 FMTR
      CHARACTER*3 AITN
      CHARACTER*12 OBSNAME(ND+MPR+IPR),ASEN
      CHARACTER*1 XOPR(ND+IPR+MPR)
      CHARACTER*5 PRESUF(3)
      REAL SPP(NPDIM,ND),SPS(NPDIM,ND),SPR(NPDIM,ND),TVAL

      IFAIL = 0
      WRITE(AITN,'(I3)') NPE
      AITN = ADJUSTL(AITN)
      FMTC = '(A20,'//TRIM(AITN)//'(2X,A10,1X))'
      FMTR = '(A12,I5,1X,A500)'
      HEADER = 'PREDICTION  SYMBOL  '

      ISPP = IGETUNIT(1,95)
      FNAM = TRIM(ADJUSTL(PREDBASE))//PRESUF(1)
      OPEN(ISPP,FILE=FNAM,IOSTAT=IERR)

      FNAM = TRIM(ADJUSTL(PREDBASE))//PRESUF(2)
      ISPR = IGETUNIT(1,95)
      OPEN(ISPR,FILE=FNAM,IOSTAT=IERR)

      FNAM = TRIM(ADJUSTL(PREDBASE))//PRESUF(3)
      ISPS = IGETUNIT(1,95)
      OPEN(ISPS,FILE=FNAM,IOSTAT=IERR)

      IF(IERR.NE.0) THEN
        WRITE(IOUTP,2)
2       FORMAT('ERROR OPENING NEW PREDICTION UNDERSCORE FILES')
        GOTO 99
      END IF
      WRITE (ISPP,FMTC,ERR=99) HEADER,(PARNAMTEMP(N),N=1,NPE)
      WRITE (ISPR,FMTC,ERR=99) HEADER,(PARNAMTEMP(N),N=1,NPE)
      WRITE (ISPS,FMTC,ERR=99) HEADER,(PARNAMTEMP(N),N=1,NPE)
      DO N=1,ND
        IF (XOPR(N).EQ.'P') THEN
          ASPP=' '
          ASPR=' '
          ASPS=' '
C         WRITE TO CHARACTER STRING FOR MAX PRECISION
          DO I=1,NPE
            IF((SPP(I,N).GT.-1.0E20).AND.(SPP(I,N).LT.1.0E20)) THEN
              CALL UWRTSIG(IFAIL,SPP(I,N),ASEN,11,0,TVAL,0)
              ASPP=TRIM(ADJUSTL(ASPP))//' '//ASEN
            ELSE
              ASPP=TRIM(ADJUSTL(ASPP))//' '//'    UNDEF   '
            END IF
          END DO
          WRITE(ISPP,FMTR,ERR=99)OBSNAME(N),IAPLOT(N),ASPP
          DO I=1,NPE
            IF((SPR(I,N).GT.-1.0E20).AND.(SPR(I,N).LT.1.0E20)) THEN
              CALL UWRTSIG(IFAIL,SPR(I,N),ASEN,11,0,TVAL,0)
              ASPR=TRIM(ADJUSTL(ASPR))//' '//ASEN
            ELSE
              ASPR=TRIM(ADJUSTL(ASPR))//' '//'    UNDEF   '
            END IF
          END DO
          WRITE(ISPR,FMTR,ERR=99)OBSNAME(N),IAPLOT(N),ASPR
          DO I=1,NPE
            IF((SPS(I,N).GT.-1.0E20).AND.(SPS(I,N).LT.1.0E20)) THEN
              CALL UWRTSIG(IFAIL,SPS(I,N),ASEN,11,0,TVAL,0)
              ASPS=TRIM(ADJUSTL(ASPS))//' '//ASEN
            ELSE
              ASPS=TRIM(ADJUSTL(ASPS))//' '//'    UNDEF   '
            END IF
          END DO
          WRITE(ISPS,FMTR,ERR=99)OBSNAME(N),IAPLOT(N),ASPS
        ENDIF
      END DO
      CLOSE(ISPP)
      CLOSE(ISPR)
      CLOSE(ISPS)
      RETURN

C   ERROR HANDLING

99    WRITE(IOUTP,100)
100   FORMAT(/,1X,'ERROR WRITING NEW PREDICTION UNDERSCORE FILES - ',
     +       '(SPRD1PRED1WR)')
      IFAIL = 1

      RETURN
      END
